/* Categories.c generated by valac 0.56.3, the Vala compiler
 * generated from Categories.vala, do not modify */

/* Categories.vala
 *
 * Copyright (C) 2009-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "font-manager.h"
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <sqlite3.h>

#define DEFAULT_LANGUAGE_FILTER_COMMENT _ ("Filter based on supported orthographies")
#define FONT_MANAGER_SELECT_FROM_FONTS "SELECT DISTINCT family, description FROM Fonts"
#define FONT_MANAGER_SELECT_FROM_METADATA_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Metada" \
"ta USING (filepath, findex) WHERE"
#define FONT_MANAGER_SELECT_FROM_PANOSE_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Panose" \
" USING (filepath, findex) WHERE"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_CATEGORY_INDEX_ALL,
	FONT_MANAGER_CATEGORY_INDEX_SYSTEM,
	FONT_MANAGER_CATEGORY_INDEX_USER,
	FONT_MANAGER_CATEGORY_INDEX_PANOSE,
	FONT_MANAGER_CATEGORY_INDEX_WIDTH,
	FONT_MANAGER_CATEGORY_INDEX_WEIGHT,
	FONT_MANAGER_CATEGORY_INDEX_SLANT,
	FONT_MANAGER_CATEGORY_INDEX_SPACING,
	FONT_MANAGER_CATEGORY_INDEX_LICENSE,
	FONT_MANAGER_CATEGORY_INDEX_VENDOR,
	FONT_MANAGER_CATEGORY_INDEX_FILETYPE,
	FONT_MANAGER_CATEGORY_INDEX_UNSORTED,
	FONT_MANAGER_CATEGORY_INDEX_DISABLED,
	FONT_MANAGER_CATEGORY_INDEX_LANGUAGE,
	FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES
} FontManagerCategoryIndex;

#define FONT_MANAGER_TYPE_CATEGORY_INDEX (font_manager_category_index_get_type ())
typedef enum  {
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS
} FontManagerCategoryModelColumn;

#define FONT_MANAGER_TYPE_CATEGORY_MODEL_COLUMN (font_manager_category_model_column_get_type ())

#define FONT_MANAGER_TYPE_CATEGORY_MODEL (font_manager_category_model_get_type ())
#define FONT_MANAGER_CATEGORY_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel))
#define FONT_MANAGER_CATEGORY_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModelClass))
#define FONT_MANAGER_IS_CATEGORY_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL))
#define FONT_MANAGER_IS_CATEGORY_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_MODEL))
#define FONT_MANAGER_CATEGORY_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModelClass))

typedef struct _FontManagerCategoryModel FontManagerCategoryModel;
typedef struct _FontManagerCategoryModelClass FontManagerCategoryModelClass;
typedef struct _FontManagerCategoryModelPrivate FontManagerCategoryModelPrivate;

#define FONT_MANAGER_TYPE_CACHEABLE (font_manager_cacheable_get_type ())
#define FONT_MANAGER_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheable))
#define FONT_MANAGER_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))
#define FONT_MANAGER_IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))

typedef struct _FontManagerCacheable FontManagerCacheable;
typedef struct _FontManagerCacheableClass FontManagerCacheableClass;

#define FONT_MANAGER_TYPE_FILTER (font_manager_filter_get_type ())
#define FONT_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilter))
#define FONT_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))
#define FONT_MANAGER_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))

typedef struct _FontManagerFilter FontManagerFilter;
typedef struct _FontManagerFilterClass FontManagerFilterClass;

#define FONT_MANAGER_TYPE_CATEGORY (font_manager_category_get_type ())
#define FONT_MANAGER_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory))
#define FONT_MANAGER_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))
#define FONT_MANAGER_IS_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))

typedef struct _FontManagerCategory FontManagerCategory;
typedef struct _FontManagerCategoryClass FontManagerCategoryClass;
enum  {
	FONT_MANAGER_CATEGORY_MODEL_0_PROPERTY,
	FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY,
	FONT_MANAGER_CATEGORY_MODEL_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define FONT_MANAGER_TYPE_LANGUAGE_FILTER (font_manager_language_filter_get_type ())
#define FONT_MANAGER_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter))
#define FONT_MANAGER_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))
#define FONT_MANAGER_IS_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_LANGUAGE_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))

typedef struct _FontManagerLanguageFilter FontManagerLanguageFilter;
typedef struct _FontManagerLanguageFilterClass FontManagerLanguageFilterClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_TYPE_BASE_ORTHOGRAPHY_DATA (font_manager_base_orthography_data_get_type ())
typedef struct _FontManagerBaseOrthographyData FontManagerBaseOrthographyData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

#define FONT_MANAGER_TYPE_DISABLED (font_manager_disabled_get_type ())
#define FONT_MANAGER_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled))
#define FONT_MANAGER_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))
#define FONT_MANAGER_IS_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_IS_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_DISABLED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))

typedef struct _FontManagerDisabled FontManagerDisabled;
typedef struct _FontManagerDisabledClass FontManagerDisabledClass;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;

#define FONT_MANAGER_TYPE_APPLICATION (font_manager_application_get_type ())
#define FONT_MANAGER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplication))
#define FONT_MANAGER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))
#define FONT_MANAGER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))

typedef struct _FontManagerApplication FontManagerApplication;
typedef struct _FontManagerApplicationClass FontManagerApplicationClass;
enum  {
	FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL,
	FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL,
	FONT_MANAGER_CATEGORY_MODEL_NUM_SIGNALS
};
static guint font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_BASE_TREE_VIEW (font_manager_base_tree_view_get_type ())
#define FONT_MANAGER_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeView))
#define FONT_MANAGER_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))
#define FONT_MANAGER_IS_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_IS_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_BASE_TREE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))

typedef struct _FontManagerBaseTreeView FontManagerBaseTreeView;
typedef struct _FontManagerBaseTreeViewClass FontManagerBaseTreeViewClass;
typedef struct _FontManagerBaseTreeViewPrivate FontManagerBaseTreeViewPrivate;

#define FONT_MANAGER_TYPE_CATEGORY_TREE (font_manager_category_tree_get_type ())
#define FONT_MANAGER_CATEGORY_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree))
#define FONT_MANAGER_CATEGORY_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTreeClass))
#define FONT_MANAGER_IS_CATEGORY_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE))
#define FONT_MANAGER_IS_CATEGORY_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_TREE))
#define FONT_MANAGER_CATEGORY_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTreeClass))

typedef struct _FontManagerCategoryTree FontManagerCategoryTree;
typedef struct _FontManagerCategoryTreeClass FontManagerCategoryTreeClass;
typedef struct _FontManagerCategoryTreePrivate FontManagerCategoryTreePrivate;

#define FONT_MANAGER_TYPE_CELL_RENDERER_PILL (font_manager_cell_renderer_pill_get_type ())
#define FONT_MANAGER_CELL_RENDERER_PILL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPill))
#define FONT_MANAGER_CELL_RENDERER_PILL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPillClass))
#define FONT_MANAGER_IS_CELL_RENDERER_PILL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL))
#define FONT_MANAGER_IS_CELL_RENDERER_PILL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_PILL))
#define FONT_MANAGER_CELL_RENDERER_PILL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPillClass))

typedef struct _FontManagerCellRendererPill FontManagerCellRendererPill;
typedef struct _FontManagerCellRendererPillClass FontManagerCellRendererPillClass;

#define FONT_MANAGER_TYPE_CELL_RENDERER_COUNT (font_manager_cell_renderer_count_get_type ())
#define FONT_MANAGER_CELL_RENDERER_COUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCount))
#define FONT_MANAGER_CELL_RENDERER_COUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCountClass))
#define FONT_MANAGER_IS_CELL_RENDERER_COUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT))
#define FONT_MANAGER_IS_CELL_RENDERER_COUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT))
#define FONT_MANAGER_CELL_RENDERER_COUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCountClass))

typedef struct _FontManagerCellRendererCount FontManagerCellRendererCount;
typedef struct _FontManagerCellRendererCountClass FontManagerCellRendererCountClass;
enum  {
	FONT_MANAGER_CATEGORY_TREE_0_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DATABASE_PROXY (font_manager_database_proxy_get_type ())
#define FONT_MANAGER_DATABASE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxy))
#define FONT_MANAGER_DATABASE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxyClass))
#define FONT_MANAGER_IS_DATABASE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY))
#define FONT_MANAGER_IS_DATABASE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DATABASE_PROXY))
#define FONT_MANAGER_DATABASE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxyClass))

typedef struct _FontManagerDatabaseProxy FontManagerDatabaseProxy;
typedef struct _FontManagerDatabaseProxyClass FontManagerDatabaseProxyClass;
typedef struct _Block7Data Block7Data;
enum  {
	FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_NUM_SIGNALS
};
static guint font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_FILTER_DATA (font_manager_filter_data_get_type ())
typedef struct _FontManagerFilterData FontManagerFilterData;

#define FONT_MANAGER_TYPE_USER_FONTS (font_manager_user_fonts_get_type ())
#define FONT_MANAGER_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFonts))
#define FONT_MANAGER_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))
#define FONT_MANAGER_IS_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_IS_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_USER_FONTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))

typedef struct _FontManagerUserFonts FontManagerUserFonts;
typedef struct _FontManagerUserFontsClass FontManagerUserFontsClass;

#define FONT_MANAGER_TYPE_UNSORTED (font_manager_unsorted_get_type ())
#define FONT_MANAGER_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsorted))
#define FONT_MANAGER_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))
#define FONT_MANAGER_IS_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_IS_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_UNSORTED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))

typedef struct _FontManagerUnsorted FontManagerUnsorted;
typedef struct _FontManagerUnsortedClass FontManagerUnsortedClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerCategoryModel {
	GObject parent_instance;
	FontManagerCategoryModelPrivate * priv;
};

struct _FontManagerCategoryModelClass {
	GObjectClass parent_class;
};

struct _FontManagerCategoryModelPrivate {
	GPtrArray* _categories;
	gint stamp;
	gchar* language_filter_tooltip;
};

struct _FontManagerBaseOrthographyData {
	gchar* name;
	gchar* native;
};

struct _Block5Data {
	int _ref_count_;
	FontManagerCategoryModel* self;
	FontManagerReject* reject;
	FontManagerDisabled* disabled;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	FontManagerCategory* cat;
};

struct _FontManagerBaseTreeView {
	GtkTreeView parent_instance;
	FontManagerBaseTreeViewPrivate * priv;
};

struct _FontManagerBaseTreeViewClass {
	GtkTreeViewClass parent_class;
	gboolean (*show_context_menu) (FontManagerBaseTreeView* self, GdkEventButton* event);
};

struct _FontManagerCategoryTree {
	FontManagerBaseTreeView parent_instance;
	FontManagerCategoryTreePrivate * priv;
};

struct _FontManagerCategoryTreeClass {
	FontManagerBaseTreeViewClass parent_class;
};

struct _FontManagerCategoryTreePrivate {
	gboolean _update_in_progress;
	gchar* _selected_iter;
	FontManagerCategory* _selected_filter;
	FontManagerLanguageFilter* _language_filter;
	guint* change_timeout;
	gboolean refresh_required;
	GtkCellRendererText* renderer;
	FontManagerCellRendererCount* count_renderer;
	GtkCellRendererPixbuf* pixbuf_renderer;
	FontManagerCategoryModel* _model_;
};

struct _Block7Data {
	int _ref_count_;
	FontManagerCategoryTree* self;
	FontManagerDatabaseProxy* db;
};

struct _FontManagerFilterData {
	gint index;
	gchar* name;
	gchar* comment;
	gchar* column;
};

static gint FontManagerCategoryModel_private_offset;
static gpointer font_manager_category_model_parent_class = NULL;
static GtkTreeModelIface * font_manager_category_model_gtk_tree_model_parent_iface = NULL;
static gint FontManagerCategoryTree_private_offset;
static gpointer font_manager_category_tree_parent_class = NULL;

VALA_EXTERN GType font_manager_category_index_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_category_model_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_category_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryModel, g_object_unref)
VALA_EXTERN GType font_manager_cacheable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCacheable, g_object_unref)
VALA_EXTERN GType font_manager_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFilter, g_object_unref)
VALA_EXTERN GType font_manager_category_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategory, g_object_unref)
static gboolean font_manager_category_model_invalid_iter (FontManagerCategoryModel* self,
                                                   GtkTreeIter* iter);
static void font_manager_category_model_valid_iter (FontManagerCategoryModel* self,
                                             GtkTreeIter* result);
static void font_manager_category_model_update_language_filter_tooltip (FontManagerCategoryModel* self);
VALA_EXTERN GType font_manager_language_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerLanguageFilter, g_object_unref)
VALA_EXTERN GPtrArray* font_manager_category_model_get_categories (FontManagerCategoryModel* self);
VALA_EXTERN gint font_manager_filter_get_size (FontManagerFilter* self);
VALA_EXTERN FontManagerStringSet* font_manager_language_filter_get_selected (FontManagerLanguageFilter* self);
VALA_EXTERN GType font_manager_base_orthography_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerBaseOrthographyData* font_manager_base_orthography_data_dup (const FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_free (FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_copy (const FontManagerBaseOrthographyData* self,
                                              FontManagerBaseOrthographyData* dest);
VALA_EXTERN void font_manager_base_orthography_data_destroy (FontManagerBaseOrthographyData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerBaseOrthographyData, font_manager_base_orthography_data_destroy)
static GtkTreeModelFlags font_manager_category_model_real_get_flags (GtkTreeModel* base);
static gint font_manager_category_model_real_get_n_columns (GtkTreeModel* base);
static GType font_manager_category_model_real_get_column_type (GtkTreeModel* base,
                                                        gint index);
static gboolean font_manager_category_model_real_get_iter (GtkTreeModel* base,
                                                    GtkTreeIter* iter,
                                                    GtkTreePath* path);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static GtkTreePath* font_manager_category_model_real_get_path (GtkTreeModel* base,
                                                        GtkTreeIter* iter);
static void font_manager_category_model_real_get_value (GtkTreeModel* base,
                                                 GtkTreeIter* iter,
                                                 gint column,
                                                 GValue* val);
VALA_EXTERN GPtrArray* font_manager_category_get_children (FontManagerCategory* self);
VALA_EXTERN gchar* font_manager_filter_get_name (FontManagerFilter* self);
VALA_EXTERN gchar* font_manager_filter_get_icon (FontManagerFilter* self);
VALA_EXTERN gint font_manager_filter_get_index (FontManagerFilter* self);
VALA_EXTERN gchar* font_manager_filter_get_comment (FontManagerFilter* self);
static gboolean font_manager_category_model_real_iter_next (GtkTreeModel* base,
                                                     GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_previous (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_children (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent);
static gboolean font_manager_category_model_real_iter_has_child (GtkTreeModel* base,
                                                          GtkTreeIter* iter);
static gint font_manager_category_model_real_iter_n_children (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_nth_child (GtkTreeModel* base,
                                                          GtkTreeIter* iter,
                                                          GtkTreeIter* parent,
                                                          gint n);
static gboolean font_manager_category_model_real_iter_parent (GtkTreeModel* base,
                                                       GtkTreeIter* iter,
                                                       GtkTreeIter* child);
static void font_manager_category_model_emit_row_changed_signal (FontManagerCategoryModel* self,
                                                          gint index);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN void font_manager_category_model_update (FontManagerCategoryModel* self);
VALA_EXTERN GType font_manager_disabled_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerDisabled, g_object_unref)
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_category_model_set_categories (FontManagerCategoryModel* self,
                                                 GPtrArray* value);
VALA_EXTERN GPtrArray* font_manager_get_default_categories (FontManagerDatabase* db);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_category_update (FontManagerCategory* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void font_manager_category_update_finish (FontManagerCategory* self,
                                          GAsyncResult* _res_);
static void _____lambda40_ (Block6Data* _data6_,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda40__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void __lambda41_ (FontManagerCategoryModel* self);
static void ___lambda41__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                                   gpointer self);
VALA_EXTERN GType font_manager_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerApplication, g_object_unref)
VALA_EXTERN guint font_manager_application_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN FontManagerApplication* font_manager_get_default_application (void);
VALA_EXTERN FontManagerReject* font_manager_application_get_reject (FontManagerApplication* self);
VALA_EXTERN void font_manager_disabled_update (FontManagerDisabled* self,
                                   FontManagerStringSet* reject,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void font_manager_disabled_update_finish (FontManagerDisabled* self,
                                          GAsyncResult* _res_);
static void __lambda42_ (Block5Data* _data5_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda42__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda43_ (Block5Data* _data5_);
static void __lambda44_ (Block5Data* _data5_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda44__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda43__font_manager_selections_changed (FontManagerSelections* _sender,
                                                   gpointer self);
VALA_EXTERN FontManagerCategoryModel* font_manager_category_model_new (void);
VALA_EXTERN FontManagerCategoryModel* font_manager_category_model_construct (GType object_type);
static GObject * font_manager_category_model_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void font_manager_category_model_finalize (GObject * obj);
static GType font_manager_category_model_get_type_once (void);
static void _vala_font_manager_category_model_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_font_manager_category_model_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
VALA_EXTERN GType font_manager_base_tree_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerBaseTreeView, g_object_unref)
VALA_EXTERN GType font_manager_category_tree_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryTree, g_object_unref)
VALA_EXTERN GType font_manager_cell_renderer_pill_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCellRendererPill, g_object_unref)
VALA_EXTERN GType font_manager_cell_renderer_count_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCellRendererCount, g_object_unref)
static void font_manager_category_tree_connect_signals (FontManagerCategoryTree* self);
VALA_EXTERN GType font_manager_database_proxy_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerDatabaseProxy, g_object_unref)
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void font_manager_category_tree_on_selection_changed (FontManagerCategoryTree* self,
                                                      GtkTreeSelection* selection);
static void _font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                                  gpointer self);
static void __lambda49_ (FontManagerCategoryTree* self);
static void __lambda50_ (FontManagerCategoryTree* self);
VALA_EXTERN void font_manager_category_tree_set_update_in_progress (FontManagerCategoryTree* self,
                                                        gboolean value);
static void ___lambda50__font_manager_category_model_update_begin (FontManagerCategoryModel* _sender,
                                                            gpointer self);
static void __lambda51_ (FontManagerCategoryTree* self);
static void ___lambda51__font_manager_category_model_update_complete (FontManagerCategoryModel* _sender,
                                                               gpointer self);
static void __lambda52_ (FontManagerCategoryTree* self,
                  GtkTreePath* path,
                  GtkTreeIter* iter);
VALA_EXTERN const gchar* font_manager_category_tree_get_selected_iter (FontManagerCategoryTree* self);
static gboolean ____lambda53_ (FontManagerCategoryTree* self);
static gboolean _____lambda53__gsource_func (gpointer self);
static guint* _uint_dup (guint* self);
static void ___lambda52__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                              GtkTreePath* path,
                                              GtkTreeIter* iter,
                                              gpointer self);
static void ___lambda49__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN FontManagerDatabaseProxy* font_manager_application_get_db (FontManagerApplication* self);
static void __lambda57_ (FontManagerCategoryTree* self);
static void ___lambda57__font_manager_database_proxy_update_started (FontManagerDatabaseProxy* _sender,
                                                              gpointer self);
static void __lambda58_ (Block7Data* _data7_);
VALA_EXTERN gboolean font_manager_database_proxy_ready (FontManagerDatabaseProxy* self,
                                            FontManagerDatabaseType type);
VALA_EXTERN void font_manager_category_tree_update (FontManagerCategoryTree* self);
static void ___lambda58__font_manager_database_proxy_status_changed (FontManagerDatabaseProxy* _sender,
                                                              gpointer self);
static void __lambda59_ (FontManagerCategoryTree* self);
static void ___lambda59__font_manager_database_proxy_update_complete (FontManagerDatabaseProxy* _sender,
                                                               gpointer self);
VALA_EXTERN void font_manager_category_tree_select_first_row (FontManagerCategoryTree* self);
VALA_EXTERN FontManagerCategory* font_manager_category_tree_get_selected_filter (FontManagerCategoryTree* self);
static void font_manager_category_tree_count_cell_data_func (FontManagerCategoryTree* self,
                                                      GtkTreeViewColumn* layout,
                                                      GtkCellRenderer* cell,
                                                      GtkTreeModel* model,
                                                      GtkTreeIter* treeiter);
static void font_manager_category_tree_pixbuf_cell_data_func (FontManagerCategoryTree* self,
                                                       GtkTreeViewColumn* layout,
                                                       GtkCellRenderer* cell,
                                                       GtkTreeModel* model,
                                                       GtkTreeIter* treeiter);
VALA_EXTERN void font_manager_category_tree_set_selected_filter (FontManagerCategoryTree* self,
                                                     FontManagerCategory* value);
VALA_EXTERN void font_manager_category_tree_set_selected_iter (FontManagerCategoryTree* self,
                                                   const gchar* value);
static gboolean __lambda45_ (FontManagerCategoryTree* self);
VALA_EXTERN FontManagerLanguageFilter* font_manager_category_tree_get_language_filter (FontManagerCategoryTree* self);
VALA_EXTERN void font_manager_category_tree_set_language_filter (FontManagerCategoryTree* self,
                                                     FontManagerLanguageFilter* value);
static void ___lambda46_ (FontManagerCategoryTree* self);
static void ____lambda46__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                                    gpointer self);
static gboolean ___lambda45__gsource_func (gpointer self);
VALA_EXTERN gboolean font_manager_filter_get_requires_update (FontManagerFilter* self);
static gboolean ___lambda47_ (FontManagerCategoryTree* self);
static gboolean ____lambda47__gsource_func (gpointer self);
static void ____lambda48_ (FontManagerCategoryTree* self,
                    GObject* obj,
                    GAsyncResult* res);
VALA_EXTERN void font_manager_filter_set_requires_update (FontManagerFilter* self,
                                              gboolean value);
static void _____lambda48__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN FontManagerCategoryTree* font_manager_category_tree_new (void);
VALA_EXTERN FontManagerCategoryTree* font_manager_category_tree_construct (GType object_type);
VALA_EXTERN FontManagerBaseTreeView* font_manager_base_tree_view_new (void);
VALA_EXTERN FontManagerBaseTreeView* font_manager_base_tree_view_construct (GType object_type);
VALA_EXTERN gboolean font_manager_category_tree_get_update_in_progress (FontManagerCategoryTree* self);
static GObject * font_manager_category_tree_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
VALA_EXTERN FontManagerCellRendererCount* font_manager_cell_renderer_count_new (void);
VALA_EXTERN FontManagerCellRendererCount* font_manager_cell_renderer_count_construct (GType object_type);
static void _font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                                GtkCellRenderer* cell,
                                                                                GtkTreeModel* tree_model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self);
static void _font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                               GtkCellRenderer* cell,
                                                                               GtkTreeModel* tree_model,
                                                                               GtkTreeIter* iter,
                                                                               gpointer self);
static gboolean _font_manager_category_tree___lambda60_ (FontManagerCategoryTree* self,
                                                  GtkTreeView* t,
                                                  GtkTreeIter* i,
                                                  GtkTreePath* p);
static gboolean __font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row (GtkTreeView* _sender,
                                                                                 GtkTreeIter* iter,
                                                                                 GtkTreePath* path,
                                                                                 gpointer self);
static void font_manager_category_tree_finalize (GObject * obj);
static GType font_manager_category_tree_get_type_once (void);
static void _vala_font_manager_category_tree_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_font_manager_category_tree_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
VALA_EXTERN GType font_manager_filter_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerFilterData* font_manager_filter_data_dup (const FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_free (FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_copy (const FontManagerFilterData* self,
                                    FontManagerFilterData* dest);
VALA_EXTERN void font_manager_filter_data_destroy (FontManagerFilterData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerFilterData, font_manager_filter_data_destroy)
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN FontManagerCategory* font_manager_category_new (const gchar* name,
                                                const gchar* comment,
                                                const gchar* icon,
                                                const gchar* sql,
                                                gint index);
VALA_EXTERN FontManagerCategory* font_manager_category_construct (GType object_type,
                                                      const gchar* name,
                                                      const gchar* comment,
                                                      const gchar* icon,
                                                      const gchar* sql,
                                                      gint index);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_new (void);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_construct (GType object_type);
VALA_EXTERN GType font_manager_user_fonts_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUserFonts, g_object_unref)
VALA_EXTERN FontManagerCategory* font_manager_construct_panose_filter (void);
VALA_EXTERN FontManagerCategory* font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                                              FontManagerFilterData* data);
VALA_EXTERN FontManagerCategory* font_manager_construct_info_filter (FontManagerDatabase* db,
                                                         FontManagerFilterData* data);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_new (void);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_construct (GType object_type);
VALA_EXTERN GType font_manager_unsorted_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUnsorted, g_object_unref)
VALA_EXTERN FontManagerDisabled* font_manager_disabled_new (void);
VALA_EXTERN FontManagerDisabled* font_manager_disabled_construct (GType object_type);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_new (void);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_construct (GType object_type);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const FontManagerBaseOrthographyData FONT_MANAGER_Orthographies[132];
const FontManagerFilterData FONT_MANAGER_attributes[4] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_WIDTH, N_ ("Width"), N_ ("Grouped by font width"), "width"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_WEIGHT, N_ ("Weight"), N_ ("Grouped by font weight"), "weight"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SLANT, N_ ("Slant"), N_ ("Grouped by font angle"), "slant"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SPACING, N_ ("Spacing"), N_ ("Grouped by font spacing"), "spacing"}};
const FontManagerFilterData FONT_MANAGER_metadata[3] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_LICENSE, N_ ("License"), N_ ("Grouped by license type"), "license-type"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_VENDOR, N_ ("Vendor"), N_ ("Grouped by vendor"), "vendor"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE, N_ ("Filetype"), N_ ("Grouped by filetype"), "filetype"}};

 G_GNUC_NO_INLINE static GType
font_manager_category_index_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_CATEGORY_INDEX_ALL, "FONT_MANAGER_CATEGORY_INDEX_ALL", "all"}, {FONT_MANAGER_CATEGORY_INDEX_SYSTEM, "FONT_MANAGER_CATEGORY_INDEX_SYSTEM", "system"}, {FONT_MANAGER_CATEGORY_INDEX_USER, "FONT_MANAGER_CATEGORY_INDEX_USER", "user"}, {FONT_MANAGER_CATEGORY_INDEX_PANOSE, "FONT_MANAGER_CATEGORY_INDEX_PANOSE", "panose"}, {FONT_MANAGER_CATEGORY_INDEX_WIDTH, "FONT_MANAGER_CATEGORY_INDEX_WIDTH", "width"}, {FONT_MANAGER_CATEGORY_INDEX_WEIGHT, "FONT_MANAGER_CATEGORY_INDEX_WEIGHT", "weight"}, {FONT_MANAGER_CATEGORY_INDEX_SLANT, "FONT_MANAGER_CATEGORY_INDEX_SLANT", "slant"}, {FONT_MANAGER_CATEGORY_INDEX_SPACING, "FONT_MANAGER_CATEGORY_INDEX_SPACING", "spacing"}, {FONT_MANAGER_CATEGORY_INDEX_LICENSE, "FONT_MANAGER_CATEGORY_INDEX_LICENSE", "license"}, {FONT_MANAGER_CATEGORY_INDEX_VENDOR, "FONT_MANAGER_CATEGORY_INDEX_VENDOR", "vendor"}, {FONT_MANAGER_CATEGORY_INDEX_FILETYPE, "FONT_MANAGER_CATEGORY_INDEX_FILETYPE", "filetype"}, {FONT_MANAGER_CATEGORY_INDEX_UNSORTED, "FONT_MANAGER_CATEGORY_INDEX_UNSORTED", "unsorted"}, {FONT_MANAGER_CATEGORY_INDEX_DISABLED, "FONT_MANAGER_CATEGORY_INDEX_DISABLED", "disabled"}, {FONT_MANAGER_CATEGORY_INDEX_LANGUAGE, "FONT_MANAGER_CATEGORY_INDEX_LANGUAGE", "language"}, {FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES, "FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES", "n-categories"}, {0, NULL, NULL}};
	GType font_manager_category_index_type_id;
	font_manager_category_index_type_id = g_enum_register_static ("FontManagerCategoryIndex", values);
	return font_manager_category_index_type_id;
}

GType
font_manager_category_index_get_type (void)
{
	static volatile gsize font_manager_category_index_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_index_type_id__once)) {
		GType font_manager_category_index_type_id;
		font_manager_category_index_type_id = font_manager_category_index_get_type_once ();
		g_once_init_leave (&font_manager_category_index_type_id__once, font_manager_category_index_type_id);
	}
	return font_manager_category_index_type_id__once;
}

 G_GNUC_NO_INLINE static GType
font_manager_category_model_column_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT", "object"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON", "icon"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME", "name"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT", "comment"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType font_manager_category_model_column_type_id;
	font_manager_category_model_column_type_id = g_enum_register_static ("FontManagerCategoryModelColumn", values);
	return font_manager_category_model_column_type_id;
}

GType
font_manager_category_model_column_get_type (void)
{
	static volatile gsize font_manager_category_model_column_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_model_column_type_id__once)) {
		GType font_manager_category_model_column_type_id;
		font_manager_category_model_column_type_id = font_manager_category_model_column_get_type_once ();
		g_once_init_leave (&font_manager_category_model_column_type_id__once, font_manager_category_model_column_type_id);
	}
	return font_manager_category_model_column_type_id__once;
}

static inline gpointer
font_manager_category_model_get_instance_private (FontManagerCategoryModel* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryModel_private_offset);
}

static gboolean
font_manager_category_model_invalid_iter (FontManagerCategoryModel* self,
                                          GtkTreeIter* iter)
{
	gboolean result;
#line 63 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 64 "../src/font-manager/Categories.vala"
	(*iter).stamp = 0;
#line 65 "../src/font-manager/Categories.vala"
	result = FALSE;
#line 65 "../src/font-manager/Categories.vala"
	return result;
#line 729 "Categories.c"
}

static void
font_manager_category_model_valid_iter (FontManagerCategoryModel* self,
                                        GtkTreeIter* result)
{
	gint none = 0;
	GtkTreeIter iter = {0};
	void* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
#line 68 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/font-manager/Categories.vala"
	none = -1;
#line 70 "../src/font-manager/Categories.vala"
	_tmp0_ = GINT_TO_POINTER (none);
#line 70 "../src/font-manager/Categories.vala"
	memset (&_tmp1_, 0, sizeof (GtkTreeIter));
#line 70 "../src/font-manager/Categories.vala"
	_tmp1_.stamp = self->priv->stamp;
#line 70 "../src/font-manager/Categories.vala"
	_tmp1_.user_data2 = _tmp0_;
#line 70 "../src/font-manager/Categories.vala"
	iter = _tmp1_;
#line 71 "../src/font-manager/Categories.vala"
	*result = iter;
#line 71 "../src/font-manager/Categories.vala"
	return;
#line 758 "Categories.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/font-manager/Categories.vala"
	return self ? g_object_ref (self) : NULL;
#line 766 "Categories.c"
}

static void
font_manager_category_model_update_language_filter_tooltip (FontManagerCategoryModel* self)
{
	FontManagerLanguageFilter* filter = NULL;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FontManagerLanguageFilter* _tmp2_;
	FontManagerLanguageFilter* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GString* builder = NULL;
	GString* _tmp7_;
	FontManagerLanguageFilter* _tmp8_;
	FontManagerStringSet* _tmp9_;
	FontManagerStringSet* _tmp10_;
	GString* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
#line 74 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_categories;
#line 75 "../src/font-manager/Categories.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
#line 75 "../src/font-manager/Categories.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp1_, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter));
#line 75 "../src/font-manager/Categories.vala"
	filter = _tmp2_;
#line 76 "../src/font-manager/Categories.vala"
	_tmp3_ = filter;
#line 76 "../src/font-manager/Categories.vala"
	_tmp4_ = font_manager_filter_get_size ((FontManagerFilter*) _tmp3_);
#line 76 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 76 "../src/font-manager/Categories.vala"
	if (_tmp5_ == 0) {
#line 805 "Categories.c"
		gchar* _tmp6_;
#line 77 "../src/font-manager/Categories.vala"
		_tmp6_ = g_strdup (DEFAULT_LANGUAGE_FILTER_COMMENT);
#line 77 "../src/font-manager/Categories.vala"
		_g_free0 (self->priv->language_filter_tooltip);
#line 77 "../src/font-manager/Categories.vala"
		self->priv->language_filter_tooltip = _tmp6_;
#line 78 "../src/font-manager/Categories.vala"
		_g_object_unref0 (filter);
#line 78 "../src/font-manager/Categories.vala"
		return;
#line 817 "Categories.c"
	}
#line 80 "../src/font-manager/Categories.vala"
	_tmp7_ = g_string_new ("");
#line 80 "../src/font-manager/Categories.vala"
	builder = _tmp7_;
#line 81 "../src/font-manager/Categories.vala"
	_tmp8_ = filter;
#line 81 "../src/font-manager/Categories.vala"
	_tmp9_ = font_manager_language_filter_get_selected (_tmp8_);
#line 81 "../src/font-manager/Categories.vala"
	_tmp10_ = _tmp9_;
#line 81 "../src/font-manager/Categories.vala"
	font_manager_string_set_sort (_tmp10_, (GCompareFunc) font_manager_natural_sort);
#line 831 "Categories.c"
	{
		FontManagerStringSet* _lang_list = NULL;
		FontManagerLanguageFilter* _tmp11_;
		FontManagerStringSet* _tmp12_;
		FontManagerStringSet* _tmp13_;
		guint _lang_size = 0U;
		FontManagerStringSet* _tmp14_;
		guint _tmp15_;
		guint _tmp16_;
		gint _lang_index = 0;
#line 82 "../src/font-manager/Categories.vala"
		_tmp11_ = filter;
#line 82 "../src/font-manager/Categories.vala"
		_tmp12_ = font_manager_language_filter_get_selected (_tmp11_);
#line 82 "../src/font-manager/Categories.vala"
		_tmp13_ = _tmp12_;
#line 82 "../src/font-manager/Categories.vala"
		_lang_list = _tmp13_;
#line 82 "../src/font-manager/Categories.vala"
		_tmp14_ = _lang_list;
#line 82 "../src/font-manager/Categories.vala"
		g_object_get (_tmp14_, "size", &_tmp15_, NULL);
#line 82 "../src/font-manager/Categories.vala"
		_tmp16_ = _tmp15_;
#line 82 "../src/font-manager/Categories.vala"
		_lang_size = _tmp16_;
#line 82 "../src/font-manager/Categories.vala"
		_lang_index = -1;
#line 82 "../src/font-manager/Categories.vala"
		while (TRUE) {
#line 862 "Categories.c"
			gint _tmp17_;
			guint _tmp18_;
			gchar* lang = NULL;
			FontManagerStringSet* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* language = NULL;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			GString* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 82 "../src/font-manager/Categories.vala"
			_lang_index = _lang_index + 1;
#line 82 "../src/font-manager/Categories.vala"
			_tmp17_ = _lang_index;
#line 82 "../src/font-manager/Categories.vala"
			_tmp18_ = _lang_size;
#line 82 "../src/font-manager/Categories.vala"
			if (!(((guint) _tmp17_) < _tmp18_)) {
#line 82 "../src/font-manager/Categories.vala"
				break;
#line 886 "Categories.c"
			}
#line 82 "../src/font-manager/Categories.vala"
			_tmp19_ = _lang_list;
#line 82 "../src/font-manager/Categories.vala"
			_tmp20_ = font_manager_string_set_get (_tmp19_, (guint) _lang_index);
#line 82 "../src/font-manager/Categories.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 82 "../src/font-manager/Categories.vala"
			lang = _tmp21_;
#line 83 "../src/font-manager/Categories.vala"
			_tmp22_ = lang;
#line 83 "../src/font-manager/Categories.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 83 "../src/font-manager/Categories.vala"
			language = _tmp23_;
#line 902 "Categories.c"
			{
				FontManagerBaseOrthographyData* orth_collection = NULL;
				gint orth_collection_length1 = 0;
				gint _orth_collection_size_ = 0;
				gint orth_it = 0;
#line 84 "../src/font-manager/Categories.vala"
				orth_collection = FONT_MANAGER_Orthographies;
#line 84 "../src/font-manager/Categories.vala"
				orth_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_Orthographies);
#line 84 "../src/font-manager/Categories.vala"
				for (orth_it = 0; orth_it < orth_collection_length1; orth_it = orth_it + 1) {
#line 914 "Categories.c"
					FontManagerBaseOrthographyData orth = {0};
#line 84 "../src/font-manager/Categories.vala"
					orth = orth_collection[orth_it];
#line 918 "Categories.c"
					{
						FontManagerBaseOrthographyData _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
#line 85 "../src/font-manager/Categories.vala"
						_tmp24_ = orth;
#line 85 "../src/font-manager/Categories.vala"
						_tmp25_ = _tmp24_.name;
#line 85 "../src/font-manager/Categories.vala"
						_tmp26_ = lang;
#line 85 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp25_, _tmp26_) == 0) {
#line 931 "Categories.c"
							FontManagerBaseOrthographyData _tmp27_;
							const gchar* _tmp28_;
							gchar* _tmp29_;
#line 86 "../src/font-manager/Categories.vala"
							_tmp27_ = orth;
#line 86 "../src/font-manager/Categories.vala"
							_tmp28_ = _tmp27_.native;
#line 86 "../src/font-manager/Categories.vala"
							_tmp29_ = g_strdup (_tmp28_);
#line 86 "../src/font-manager/Categories.vala"
							_g_free0 (language);
#line 86 "../src/font-manager/Categories.vala"
							language = _tmp29_;
#line 87 "../src/font-manager/Categories.vala"
							break;
#line 947 "Categories.c"
						}
					}
				}
			}
#line 90 "../src/font-manager/Categories.vala"
			_tmp30_ = builder;
#line 90 "../src/font-manager/Categories.vala"
			_tmp31_ = language;
#line 90 "../src/font-manager/Categories.vala"
			_tmp32_ = g_strdup_printf ("   %s   ", _tmp31_);
#line 90 "../src/font-manager/Categories.vala"
			_tmp33_ = _tmp32_;
#line 90 "../src/font-manager/Categories.vala"
			g_string_append (_tmp30_, _tmp33_);
#line 90 "../src/font-manager/Categories.vala"
			_g_free0 (_tmp33_);
#line 82 "../src/font-manager/Categories.vala"
			_g_free0 (language);
#line 82 "../src/font-manager/Categories.vala"
			_g_free0 (lang);
#line 968 "Categories.c"
		}
	}
#line 92 "../src/font-manager/Categories.vala"
	_tmp34_ = builder;
#line 92 "../src/font-manager/Categories.vala"
	_tmp35_ = _tmp34_->str;
#line 92 "../src/font-manager/Categories.vala"
	_tmp36_ = g_markup_escape_text (_tmp35_, (gssize) -1);
#line 92 "../src/font-manager/Categories.vala"
	_g_free0 (self->priv->language_filter_tooltip);
#line 92 "../src/font-manager/Categories.vala"
	self->priv->language_filter_tooltip = _tmp36_;
#line 93 "../src/font-manager/Categories.vala"
	_g_string_free0 (builder);
#line 93 "../src/font-manager/Categories.vala"
	_g_object_unref0 (filter);
#line 93 "../src/font-manager/Categories.vala"
	return;
#line 987 "Categories.c"
}

static GtkTreeModelFlags
font_manager_category_model_real_get_flags (GtkTreeModel* base)
{
	FontManagerCategoryModel * self;
	GtkTreeModelFlags result;
#line 96 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 97 "../src/font-manager/Categories.vala"
	result = GTK_TREE_MODEL_ITERS_PERSIST;
#line 97 "../src/font-manager/Categories.vala"
	return result;
#line 1001 "Categories.c"
}

static gint
font_manager_category_model_real_get_n_columns (GtkTreeModel* base)
{
	FontManagerCategoryModel * self;
	gint result;
#line 100 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 101 "../src/font-manager/Categories.vala"
	result = (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS;
#line 101 "../src/font-manager/Categories.vala"
	return result;
#line 1015 "Categories.c"
}

static GType
font_manager_category_model_real_get_column_type (GtkTreeModel* base,
                                                  gint index)
{
	FontManagerCategoryModel * self;
	GType result;
#line 104 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 105 "../src/font-manager/Categories.vala"
	if (index == ((gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT)) {
#line 106 "../src/font-manager/Categories.vala"
		result = G_TYPE_OBJECT;
#line 106 "../src/font-manager/Categories.vala"
		return result;
#line 1032 "Categories.c"
	}
#line 107 "../src/font-manager/Categories.vala"
	result = G_TYPE_STRING;
#line 107 "../src/font-manager/Categories.vala"
	return result;
#line 1038 "Categories.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 115 "../src/font-manager/Categories.vala"
	if (length > 0) {
#line 115 "../src/font-manager/Categories.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1049 "Categories.c"
	}
#line 115 "../src/font-manager/Categories.vala"
	return NULL;
#line 1053 "Categories.c"
}

static gboolean
font_manager_category_model_real_get_iter (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           GtkTreePath* path)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	GPtrArray* _tmp1_;
	gint depth = 0;
	gint* indices = NULL;
	gint _tmp3_ = 0;
	gint* _tmp4_;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint indices_length1;
	gint _indices_size_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	void* _tmp8_;
	gboolean result;
#line 110 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 110 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 111 "../src/font-manager/Categories.vala"
	font_manager_category_model_valid_iter (self, &_tmp0_);
#line 111 "../src/font-manager/Categories.vala"
	_vala_iter = _tmp0_;
#line 112 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_categories;
#line 112 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 1090 "Categories.c"
		GtkTreeIter _tmp2_;
#line 113 "../src/font-manager/Categories.vala"
		_tmp2_ = _vala_iter;
#line 113 "../src/font-manager/Categories.vala"
		result = font_manager_category_model_invalid_iter (self, &_tmp2_);
#line 113 "../src/font-manager/Categories.vala"
		if (iter) {
#line 113 "../src/font-manager/Categories.vala"
			*iter = _vala_iter;
#line 1100 "Categories.c"
		}
#line 113 "../src/font-manager/Categories.vala"
		return result;
#line 1104 "Categories.c"
	}
#line 114 "../src/font-manager/Categories.vala"
	depth = gtk_tree_path_get_depth (path);
#line 115 "../src/font-manager/Categories.vala"
	_tmp4_ = gtk_tree_path_get_indices_with_depth (path, &_tmp3_);
#line 115 "../src/font-manager/Categories.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup1 (_tmp4_, _tmp3_) : _tmp4_;
#line 115 "../src/font-manager/Categories.vala"
	_tmp5__length1 = _tmp3_;
#line 115 "../src/font-manager/Categories.vala"
	indices = _tmp5_;
#line 115 "../src/font-manager/Categories.vala"
	indices_length1 = _tmp5__length1;
#line 115 "../src/font-manager/Categories.vala"
	_indices_size_ = indices_length1;
#line 116 "../src/font-manager/Categories.vala"
	_tmp6_ = indices;
#line 116 "../src/font-manager/Categories.vala"
	_tmp6__length1 = indices_length1;
#line 116 "../src/font-manager/Categories.vala"
	_tmp7_ = _tmp6_[0];
#line 116 "../src/font-manager/Categories.vala"
	_tmp8_ = GINT_TO_POINTER (_tmp7_);
#line 116 "../src/font-manager/Categories.vala"
	_vala_iter.user_data = _tmp8_;
#line 117 "../src/font-manager/Categories.vala"
	if (depth > 1) {
#line 1132 "Categories.c"
		gint n_child = 0;
		gint* _tmp9_;
		gint _tmp9__length1;
		gint _tmp10_;
		gint n_children = 0;
		GtkTreeIter _tmp11_;
		gboolean _tmp12_ = FALSE;
		void* _tmp14_;
#line 118 "../src/font-manager/Categories.vala"
		_tmp9_ = indices;
#line 118 "../src/font-manager/Categories.vala"
		_tmp9__length1 = indices_length1;
#line 118 "../src/font-manager/Categories.vala"
		_tmp10_ = _tmp9_[1];
#line 118 "../src/font-manager/Categories.vala"
		n_child = _tmp10_;
#line 119 "../src/font-manager/Categories.vala"
		_tmp11_ = _vala_iter;
#line 119 "../src/font-manager/Categories.vala"
		n_children = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, &_tmp11_);
#line 120 "../src/font-manager/Categories.vala"
		if (n_child < 0) {
#line 120 "../src/font-manager/Categories.vala"
			_tmp12_ = TRUE;
#line 1157 "Categories.c"
		} else {
#line 120 "../src/font-manager/Categories.vala"
			_tmp12_ = n_child >= n_children;
#line 1161 "Categories.c"
		}
#line 120 "../src/font-manager/Categories.vala"
		if (_tmp12_) {
#line 1165 "Categories.c"
			GtkTreeIter _tmp13_;
#line 121 "../src/font-manager/Categories.vala"
			_tmp13_ = _vala_iter;
#line 121 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp13_);
#line 121 "../src/font-manager/Categories.vala"
			indices = (g_free (indices), NULL);
#line 121 "../src/font-manager/Categories.vala"
			if (iter) {
#line 121 "../src/font-manager/Categories.vala"
				*iter = _vala_iter;
#line 1177 "Categories.c"
			}
#line 121 "../src/font-manager/Categories.vala"
			return result;
#line 1181 "Categories.c"
		}
#line 122 "../src/font-manager/Categories.vala"
		_tmp14_ = GINT_TO_POINTER (n_child);
#line 122 "../src/font-manager/Categories.vala"
		_vala_iter.user_data2 = _tmp14_;
#line 1187 "Categories.c"
	}
#line 124 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 124 "../src/font-manager/Categories.vala"
	indices = (g_free (indices), NULL);
#line 124 "../src/font-manager/Categories.vala"
	if (iter) {
#line 124 "../src/font-manager/Categories.vala"
		*iter = _vala_iter;
#line 1197 "Categories.c"
	}
#line 124 "../src/font-manager/Categories.vala"
	return result;
#line 1201 "Categories.c"
}

static GtkTreePath*
font_manager_category_model_real_get_path (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreeIter _tmp5_;
	void* _tmp6_;
	GtkTreePath* result;
#line 127 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 127 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 127 "../src/font-manager/Categories.vala"
	_tmp0_ = *iter;
#line 127 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", NULL);
#line 129 "../src/font-manager/Categories.vala"
	_tmp1_ = gtk_tree_path_new ();
#line 129 "../src/font-manager/Categories.vala"
	path = _tmp1_;
#line 130 "../src/font-manager/Categories.vala"
	_tmp2_ = path;
#line 130 "../src/font-manager/Categories.vala"
	_tmp3_ = *iter;
#line 130 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.user_data;
#line 130 "../src/font-manager/Categories.vala"
	gtk_tree_path_append_index (_tmp2_, (gint) _tmp4_);
#line 131 "../src/font-manager/Categories.vala"
	_tmp5_ = *iter;
#line 131 "../src/font-manager/Categories.vala"
	_tmp6_ = _tmp5_.user_data2;
#line 131 "../src/font-manager/Categories.vala"
	if (((gint) _tmp6_) != -1) {
#line 1244 "Categories.c"
		GtkTreePath* _tmp7_;
		GtkTreeIter _tmp8_;
		void* _tmp9_;
#line 132 "../src/font-manager/Categories.vala"
		_tmp7_ = path;
#line 132 "../src/font-manager/Categories.vala"
		_tmp8_ = *iter;
#line 132 "../src/font-manager/Categories.vala"
		_tmp9_ = _tmp8_.user_data2;
#line 132 "../src/font-manager/Categories.vala"
		gtk_tree_path_append_index (_tmp7_, (gint) _tmp9_);
#line 1256 "Categories.c"
	}
#line 133 "../src/font-manager/Categories.vala"
	result = path;
#line 133 "../src/font-manager/Categories.vala"
	return result;
#line 1262 "Categories.c"
}

static void
font_manager_category_model_real_get_value (GtkTreeModel* base,
                                            GtkTreeIter* iter,
                                            gint column,
                                            GValue* val)
{
	FontManagerCategoryModel * self;
	GValue _vala_val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	FontManagerCategory* parent = NULL;
	GPtrArray* _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gconstpointer _tmp5_;
	FontManagerCategory* _tmp6_;
	FontManagerCategory* child = NULL;
	GtkTreeIter _tmp7_;
	void* _tmp8_;
	FontManagerCategory* _tmp16_ = NULL;
	FontManagerCategory* _tmp17_;
	FontManagerCategory* target = NULL;
	FontManagerCategory* _tmp20_;
#line 136 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 136 "../src/font-manager/Categories.vala"
	g_return_if_fail (iter != NULL);
#line 136 "../src/font-manager/Categories.vala"
	_tmp0_ = *iter;
#line 136 "../src/font-manager/Categories.vala"
	_vala_return_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp");
#line 136 "../src/font-manager/Categories.vala"
	_vala_return_if_fail ((column >= 0) && (column < ((gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS)), "column >= 0 && column < CategoryModelColumn.N_COLUMNS");
#line 139 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp1_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column));
#line 139 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 139 "../src/font-manager/Categories.vala"
	_vala_val = _tmp1_;
#line 140 "../src/font-manager/Categories.vala"
	_tmp2_ = self->priv->_categories;
#line 140 "../src/font-manager/Categories.vala"
	_tmp3_ = *iter;
#line 140 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.user_data;
#line 140 "../src/font-manager/Categories.vala"
	_tmp5_ = g_ptr_array_index (_tmp2_, (guint) ((gint) _tmp4_));
#line 140 "../src/font-manager/Categories.vala"
	_tmp6_ = _g_object_ref0 ((FontManagerCategory*) _tmp5_);
#line 140 "../src/font-manager/Categories.vala"
	parent = _tmp6_;
#line 141 "../src/font-manager/Categories.vala"
	child = NULL;
#line 142 "../src/font-manager/Categories.vala"
	_tmp7_ = *iter;
#line 142 "../src/font-manager/Categories.vala"
	_tmp8_ = _tmp7_.user_data2;
#line 142 "../src/font-manager/Categories.vala"
	if (((gint) _tmp8_) != -1) {
#line 1324 "Categories.c"
		FontManagerCategory* _tmp9_;
		GPtrArray* _tmp10_;
		GPtrArray* _tmp11_;
		GtkTreeIter _tmp12_;
		void* _tmp13_;
		gconstpointer _tmp14_;
		FontManagerCategory* _tmp15_;
#line 143 "../src/font-manager/Categories.vala"
		_tmp9_ = parent;
#line 143 "../src/font-manager/Categories.vala"
		_tmp10_ = font_manager_category_get_children (_tmp9_);
#line 143 "../src/font-manager/Categories.vala"
		_tmp11_ = _tmp10_;
#line 143 "../src/font-manager/Categories.vala"
		_tmp12_ = *iter;
#line 143 "../src/font-manager/Categories.vala"
		_tmp13_ = _tmp12_.user_data2;
#line 143 "../src/font-manager/Categories.vala"
		_tmp14_ = g_ptr_array_index (_tmp11_, (guint) ((gint) _tmp13_));
#line 143 "../src/font-manager/Categories.vala"
		_tmp15_ = _g_object_ref0 ((FontManagerCategory*) _tmp14_);
#line 143 "../src/font-manager/Categories.vala"
		_g_object_unref0 (child);
#line 143 "../src/font-manager/Categories.vala"
		child = _tmp15_;
#line 1350 "Categories.c"
	}
#line 144 "../src/font-manager/Categories.vala"
	_tmp17_ = child;
#line 144 "../src/font-manager/Categories.vala"
	if (_tmp17_ != NULL) {
#line 1356 "Categories.c"
		FontManagerCategory* _tmp18_;
#line 144 "../src/font-manager/Categories.vala"
		_tmp18_ = child;
#line 144 "../src/font-manager/Categories.vala"
		_tmp16_ = _tmp18_;
#line 1362 "Categories.c"
	} else {
		FontManagerCategory* _tmp19_;
#line 144 "../src/font-manager/Categories.vala"
		_tmp19_ = parent;
#line 144 "../src/font-manager/Categories.vala"
		_tmp16_ = _tmp19_;
#line 1369 "Categories.c"
	}
#line 144 "../src/font-manager/Categories.vala"
	_tmp20_ = _g_object_ref0 (_tmp16_);
#line 144 "../src/font-manager/Categories.vala"
	target = _tmp20_;
#line 145 "../src/font-manager/Categories.vala"
	switch (column) {
#line 145 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME:
#line 1379 "Categories.c"
		{
			FontManagerCategory* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 147 "../src/font-manager/Categories.vala"
			_tmp21_ = target;
#line 147 "../src/font-manager/Categories.vala"
			_tmp22_ = font_manager_filter_get_name ((FontManagerFilter*) _tmp21_);
#line 147 "../src/font-manager/Categories.vala"
			_tmp23_ = _tmp22_;
#line 147 "../src/font-manager/Categories.vala"
			_tmp24_ = _tmp23_;
#line 147 "../src/font-manager/Categories.vala"
			g_value_set_string (&_vala_val, _tmp24_);
#line 147 "../src/font-manager/Categories.vala"
			_g_free0 (_tmp24_);
#line 148 "../src/font-manager/Categories.vala"
			break;
#line 1399 "Categories.c"
		}
#line 145 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON:
#line 1403 "Categories.c"
		{
			FontManagerCategory* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 150 "../src/font-manager/Categories.vala"
			_tmp25_ = target;
#line 150 "../src/font-manager/Categories.vala"
			_tmp26_ = font_manager_filter_get_icon ((FontManagerFilter*) _tmp25_);
#line 150 "../src/font-manager/Categories.vala"
			_tmp27_ = _tmp26_;
#line 150 "../src/font-manager/Categories.vala"
			_tmp28_ = _tmp27_;
#line 150 "../src/font-manager/Categories.vala"
			g_value_set_string (&_vala_val, _tmp28_);
#line 150 "../src/font-manager/Categories.vala"
			_g_free0 (_tmp28_);
#line 151 "../src/font-manager/Categories.vala"
			break;
#line 1423 "Categories.c"
		}
#line 145 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT:
#line 1427 "Categories.c"
		{
			FontManagerCategory* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 154 "../src/font-manager/Categories.vala"
			_tmp29_ = target;
#line 154 "../src/font-manager/Categories.vala"
			_tmp30_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp29_);
#line 154 "../src/font-manager/Categories.vala"
			_tmp31_ = _tmp30_;
#line 154 "../src/font-manager/Categories.vala"
			if (_tmp31_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE)) {
#line 1440 "Categories.c"
				const gchar* _tmp32_;
#line 155 "../src/font-manager/Categories.vala"
				_tmp32_ = self->priv->language_filter_tooltip;
#line 155 "../src/font-manager/Categories.vala"
				g_value_set_string (&_vala_val, _tmp32_);
#line 1446 "Categories.c"
			} else {
				FontManagerCategory* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
#line 157 "../src/font-manager/Categories.vala"
				_tmp33_ = target;
#line 157 "../src/font-manager/Categories.vala"
				_tmp34_ = font_manager_filter_get_comment ((FontManagerFilter*) _tmp33_);
#line 157 "../src/font-manager/Categories.vala"
				_tmp35_ = _tmp34_;
#line 157 "../src/font-manager/Categories.vala"
				_tmp36_ = _tmp35_;
#line 157 "../src/font-manager/Categories.vala"
				_tmp37_ = g_markup_escape_text (_tmp36_, (gssize) -1);
#line 157 "../src/font-manager/Categories.vala"
				_tmp38_ = _tmp37_;
#line 157 "../src/font-manager/Categories.vala"
				g_value_set_string (&_vala_val, _tmp38_);
#line 157 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp38_);
#line 157 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp36_);
#line 1472 "Categories.c"
			}
#line 158 "../src/font-manager/Categories.vala"
			break;
#line 1476 "Categories.c"
		}
#line 145 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT:
#line 1480 "Categories.c"
		{
			FontManagerCategory* _tmp39_;
#line 160 "../src/font-manager/Categories.vala"
			_tmp39_ = target;
#line 160 "../src/font-manager/Categories.vala"
			g_value_set_object (&_vala_val, (GObject*) _tmp39_);
#line 161 "../src/font-manager/Categories.vala"
			break;
#line 1489 "Categories.c"
		}
		default:
		{
#line 163 "../src/font-manager/Categories.vala"
			g_assert_not_reached ();
#line 1495 "Categories.c"
		}
	}
#line 165 "../src/font-manager/Categories.vala"
	_g_object_unref0 (target);
#line 165 "../src/font-manager/Categories.vala"
	_g_object_unref0 (child);
#line 165 "../src/font-manager/Categories.vala"
	_g_object_unref0 (parent);
#line 165 "../src/font-manager/Categories.vala"
	if (val) {
#line 165 "../src/font-manager/Categories.vala"
		*val = _vala_val;
#line 1508 "Categories.c"
	} else {
#line 165 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 1512 "Categories.c"
	}
#line 165 "../src/font-manager/Categories.vala"
	return;
#line 1516 "Categories.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5795 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5796 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5796 "glib-2.0.vapi"
	return result;
#line 1529 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_next (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	gint parent = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gint child = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gboolean result;
#line 168 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 168 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 168 "../src/font-manager/Categories.vala"
	_tmp0_ = *iter;
#line 168 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
#line 170 "../src/font-manager/Categories.vala"
	_tmp1_ = *iter;
#line 170 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_.user_data;
#line 170 "../src/font-manager/Categories.vala"
	parent = (gint) _tmp2_;
#line 171 "../src/font-manager/Categories.vala"
	_tmp3_ = *iter;
#line 171 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.user_data2;
#line 171 "../src/font-manager/Categories.vala"
	child = (gint) _tmp4_;
#line 172 "../src/font-manager/Categories.vala"
	if (child != -1) {
#line 1567 "Categories.c"
		gint next_child = 0;
		GPtrArray* _tmp5_;
		gconstpointer _tmp6_;
		GPtrArray* _tmp7_;
		GPtrArray* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		void* _tmp12_;
#line 173 "../src/font-manager/Categories.vala"
		next_child = child + 1;
#line 174 "../src/font-manager/Categories.vala"
		_tmp5_ = self->priv->_categories;
#line 174 "../src/font-manager/Categories.vala"
		_tmp6_ = g_ptr_array_index (_tmp5_, (guint) parent);
#line 174 "../src/font-manager/Categories.vala"
		_tmp7_ = font_manager_category_get_children ((FontManagerCategory*) _tmp6_);
#line 174 "../src/font-manager/Categories.vala"
		_tmp8_ = _tmp7_;
#line 174 "../src/font-manager/Categories.vala"
		_tmp9_ = vala_g_ptr_array_get_length (_tmp8_);
#line 174 "../src/font-manager/Categories.vala"
		_tmp10_ = _tmp9_;
#line 174 "../src/font-manager/Categories.vala"
		if (next_child >= _tmp10_) {
#line 1592 "Categories.c"
			GtkTreeIter _tmp11_;
#line 175 "../src/font-manager/Categories.vala"
			_tmp11_ = *iter;
#line 175 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp11_);
#line 175 "../src/font-manager/Categories.vala"
			return result;
#line 1600 "Categories.c"
		}
#line 176 "../src/font-manager/Categories.vala"
		_tmp12_ = GINT_TO_POINTER (next_child);
#line 176 "../src/font-manager/Categories.vala"
		(*iter).user_data2 = _tmp12_;
#line 1606 "Categories.c"
	} else {
		gint next_parent = 0;
		GPtrArray* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		void* _tmp17_;
#line 178 "../src/font-manager/Categories.vala"
		next_parent = parent + 1;
#line 179 "../src/font-manager/Categories.vala"
		_tmp13_ = self->priv->_categories;
#line 179 "../src/font-manager/Categories.vala"
		_tmp14_ = vala_g_ptr_array_get_length (_tmp13_);
#line 179 "../src/font-manager/Categories.vala"
		_tmp15_ = _tmp14_;
#line 179 "../src/font-manager/Categories.vala"
		if (next_parent >= _tmp15_) {
#line 1623 "Categories.c"
			GtkTreeIter _tmp16_;
#line 180 "../src/font-manager/Categories.vala"
			_tmp16_ = *iter;
#line 180 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp16_);
#line 180 "../src/font-manager/Categories.vala"
			return result;
#line 1631 "Categories.c"
		}
#line 181 "../src/font-manager/Categories.vala"
		_tmp17_ = GINT_TO_POINTER (next_parent);
#line 181 "../src/font-manager/Categories.vala"
		(*iter).user_data = _tmp17_;
#line 1637 "Categories.c"
	}
#line 183 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 183 "../src/font-manager/Categories.vala"
	return result;
#line 1643 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_previous (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	gint parent = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gint child = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gboolean result;
#line 186 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 186 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 186 "../src/font-manager/Categories.vala"
	_tmp0_ = *iter;
#line 186 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
#line 188 "../src/font-manager/Categories.vala"
	_tmp1_ = *iter;
#line 188 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_.user_data;
#line 188 "../src/font-manager/Categories.vala"
	parent = (gint) _tmp2_;
#line 189 "../src/font-manager/Categories.vala"
	_tmp3_ = *iter;
#line 189 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.user_data2;
#line 189 "../src/font-manager/Categories.vala"
	child = (gint) _tmp4_;
#line 190 "../src/font-manager/Categories.vala"
	if (child != -1) {
#line 1681 "Categories.c"
		gint next_child = 0;
		void* _tmp6_;
#line 191 "../src/font-manager/Categories.vala"
		next_child = child - 1;
#line 192 "../src/font-manager/Categories.vala"
		if (next_child <= 0) {
#line 1688 "Categories.c"
			GtkTreeIter _tmp5_;
#line 193 "../src/font-manager/Categories.vala"
			_tmp5_ = *iter;
#line 193 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp5_);
#line 193 "../src/font-manager/Categories.vala"
			return result;
#line 1696 "Categories.c"
		}
#line 194 "../src/font-manager/Categories.vala"
		_tmp6_ = GINT_TO_POINTER (next_child);
#line 194 "../src/font-manager/Categories.vala"
		(*iter).user_data2 = _tmp6_;
#line 1702 "Categories.c"
	} else {
		gint next_parent = 0;
		void* _tmp8_;
#line 196 "../src/font-manager/Categories.vala"
		next_parent = parent - 1;
#line 197 "../src/font-manager/Categories.vala"
		if (next_parent <= 0) {
#line 1710 "Categories.c"
			GtkTreeIter _tmp7_;
#line 198 "../src/font-manager/Categories.vala"
			_tmp7_ = *iter;
#line 198 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp7_);
#line 198 "../src/font-manager/Categories.vala"
			return result;
#line 1718 "Categories.c"
		}
#line 199 "../src/font-manager/Categories.vala"
		_tmp8_ = GINT_TO_POINTER (next_parent);
#line 199 "../src/font-manager/Categories.vala"
		(*iter).user_data = _tmp8_;
#line 1724 "Categories.c"
	}
#line 201 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 201 "../src/font-manager/Categories.vala"
	return result;
#line 1730 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_children (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	GPtrArray* _tmp2_;
	gint first_index = 0;
	gboolean result;
#line 204 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 204 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail ((*parent).stamp == self->priv->stamp, "parent.stamp == stamp", FALSE);
#line 206 "../src/font-manager/Categories.vala"
	font_manager_category_model_valid_iter (self, &_tmp0_);
#line 206 "../src/font-manager/Categories.vala"
	_vala_iter = _tmp0_;
#line 207 "../src/font-manager/Categories.vala"
	_tmp2_ = self->priv->_categories;
#line 207 "../src/font-manager/Categories.vala"
	if (_tmp2_ == NULL) {
#line 207 "../src/font-manager/Categories.vala"
		_tmp1_ = TRUE;
#line 1759 "Categories.c"
	} else {
		void* _tmp3_;
#line 207 "../src/font-manager/Categories.vala"
		_tmp3_ = (*parent).user_data2;
#line 207 "../src/font-manager/Categories.vala"
		_tmp1_ = ((gint) _tmp3_) != -1;
#line 1766 "Categories.c"
	}
#line 207 "../src/font-manager/Categories.vala"
	if (_tmp1_) {
#line 1770 "Categories.c"
		GtkTreeIter _tmp4_;
#line 208 "../src/font-manager/Categories.vala"
		_tmp4_ = _vala_iter;
#line 208 "../src/font-manager/Categories.vala"
		result = font_manager_category_model_invalid_iter (self, &_tmp4_);
#line 208 "../src/font-manager/Categories.vala"
		if (iter) {
#line 208 "../src/font-manager/Categories.vala"
			*iter = _vala_iter;
#line 1780 "Categories.c"
		}
#line 208 "../src/font-manager/Categories.vala"
		return result;
#line 1784 "Categories.c"
	}
#line 209 "../src/font-manager/Categories.vala"
	first_index = 0;
#line 210 "../src/font-manager/Categories.vala"
	if (parent == NULL) {
#line 1790 "Categories.c"
		void* _tmp5_;
#line 211 "../src/font-manager/Categories.vala"
		_tmp5_ = GINT_TO_POINTER (first_index);
#line 211 "../src/font-manager/Categories.vala"
		_vala_iter.user_data = _tmp5_;
#line 1796 "Categories.c"
	} else {
		void* _tmp6_;
		void* _tmp7_;
#line 213 "../src/font-manager/Categories.vala"
		_tmp6_ = (*parent).user_data;
#line 213 "../src/font-manager/Categories.vala"
		_vala_iter.user_data = _tmp6_;
#line 214 "../src/font-manager/Categories.vala"
		_tmp7_ = GINT_TO_POINTER (first_index);
#line 214 "../src/font-manager/Categories.vala"
		_vala_iter.user_data2 = _tmp7_;
#line 1808 "Categories.c"
	}
#line 216 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 216 "../src/font-manager/Categories.vala"
	if (iter) {
#line 216 "../src/font-manager/Categories.vala"
		*iter = _vala_iter;
#line 1816 "Categories.c"
	}
#line 216 "../src/font-manager/Categories.vala"
	return result;
#line 1820 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_has_child (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	GPtrArray* _tmp1_;
	GtkTreeIter _tmp2_;
	gboolean result;
#line 219 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 219 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 219 "../src/font-manager/Categories.vala"
	_tmp0_ = *iter;
#line 219 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
#line 221 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_categories;
#line 221 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 222 "../src/font-manager/Categories.vala"
		result = FALSE;
#line 222 "../src/font-manager/Categories.vala"
		return result;
#line 1848 "Categories.c"
	}
#line 223 "../src/font-manager/Categories.vala"
	_tmp2_ = *iter;
#line 223 "../src/font-manager/Categories.vala"
	result = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, &_tmp2_) > 0;
#line 223 "../src/font-manager/Categories.vala"
	return result;
#line 1856 "Categories.c"
}

static gint
font_manager_category_model_real_iter_n_children (GtkTreeModel* base,
                                                  GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GPtrArray* _tmp0_;
	void* _tmp4_;
	FontManagerCategory* parent = NULL;
	GPtrArray* _tmp5_;
	void* _tmp6_;
	gconstpointer _tmp7_;
	FontManagerCategory* _tmp8_;
	FontManagerCategory* _tmp9_;
	GPtrArray* _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint result;
#line 226 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 226 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail ((iter == NULL) || ((*iter).stamp == self->priv->stamp), "iter == null || iter.stamp == stamp", 0);
#line 228 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_categories;
#line 228 "../src/font-manager/Categories.vala"
	if (_tmp0_ == NULL) {
#line 229 "../src/font-manager/Categories.vala"
		result = 0;
#line 229 "../src/font-manager/Categories.vala"
		return result;
#line 1889 "Categories.c"
	}
#line 230 "../src/font-manager/Categories.vala"
	if (iter == NULL) {
#line 1893 "Categories.c"
		GPtrArray* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 231 "../src/font-manager/Categories.vala"
		_tmp1_ = self->priv->_categories;
#line 231 "../src/font-manager/Categories.vala"
		_tmp2_ = vala_g_ptr_array_get_length (_tmp1_);
#line 231 "../src/font-manager/Categories.vala"
		_tmp3_ = _tmp2_;
#line 231 "../src/font-manager/Categories.vala"
		result = _tmp3_;
#line 231 "../src/font-manager/Categories.vala"
		return result;
#line 1907 "Categories.c"
	}
#line 232 "../src/font-manager/Categories.vala"
	_tmp4_ = (*iter).user_data2;
#line 232 "../src/font-manager/Categories.vala"
	if (((gint) _tmp4_) != -1) {
#line 233 "../src/font-manager/Categories.vala"
		result = 0;
#line 233 "../src/font-manager/Categories.vala"
		return result;
#line 1917 "Categories.c"
	}
#line 234 "../src/font-manager/Categories.vala"
	_tmp5_ = self->priv->_categories;
#line 234 "../src/font-manager/Categories.vala"
	_tmp6_ = (*iter).user_data;
#line 234 "../src/font-manager/Categories.vala"
	_tmp7_ = g_ptr_array_index (_tmp5_, (guint) ((gint) _tmp6_));
#line 234 "../src/font-manager/Categories.vala"
	_tmp8_ = _g_object_ref0 ((FontManagerCategory*) _tmp7_);
#line 234 "../src/font-manager/Categories.vala"
	parent = _tmp8_;
#line 235 "../src/font-manager/Categories.vala"
	_tmp9_ = parent;
#line 235 "../src/font-manager/Categories.vala"
	_tmp10_ = font_manager_category_get_children (_tmp9_);
#line 235 "../src/font-manager/Categories.vala"
	_tmp11_ = _tmp10_;
#line 235 "../src/font-manager/Categories.vala"
	_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 235 "../src/font-manager/Categories.vala"
	_tmp13_ = _tmp12_;
#line 235 "../src/font-manager/Categories.vala"
	result = _tmp13_;
#line 235 "../src/font-manager/Categories.vala"
	_g_object_unref0 (parent);
#line 235 "../src/font-manager/Categories.vala"
	return result;
#line 1945 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_nth_child (GtkTreeModel* base,
                                                 GtkTreeIter* iter,
                                                 GtkTreeIter* parent,
                                                 gint n)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	GPtrArray* _tmp1_;
	gint n_children = 0;
	gboolean result;
#line 238 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 238 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail ((parent == NULL) || ((*parent).stamp == self->priv->stamp), "parent == null || parent.stamp == stamp", FALSE);
#line 240 "../src/font-manager/Categories.vala"
	font_manager_category_model_valid_iter (self, &_tmp0_);
#line 240 "../src/font-manager/Categories.vala"
	_vala_iter = _tmp0_;
#line 241 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_categories;
#line 241 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 1972 "Categories.c"
		GtkTreeIter _tmp2_;
#line 242 "../src/font-manager/Categories.vala"
		_tmp2_ = _vala_iter;
#line 242 "../src/font-manager/Categories.vala"
		result = font_manager_category_model_invalid_iter (self, &_tmp2_);
#line 242 "../src/font-manager/Categories.vala"
		if (iter) {
#line 242 "../src/font-manager/Categories.vala"
			*iter = _vala_iter;
#line 1982 "Categories.c"
		}
#line 242 "../src/font-manager/Categories.vala"
		return result;
#line 1986 "Categories.c"
	}
#line 243 "../src/font-manager/Categories.vala"
	if (parent == NULL) {
#line 1990 "Categories.c"
		GPtrArray* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		void* _tmp7_;
#line 244 "../src/font-manager/Categories.vala"
		_tmp3_ = self->priv->_categories;
#line 244 "../src/font-manager/Categories.vala"
		_tmp4_ = vala_g_ptr_array_get_length (_tmp3_);
#line 244 "../src/font-manager/Categories.vala"
		_tmp5_ = _tmp4_;
#line 244 "../src/font-manager/Categories.vala"
		if (n >= _tmp5_) {
#line 2003 "Categories.c"
			GtkTreeIter _tmp6_;
#line 245 "../src/font-manager/Categories.vala"
			_tmp6_ = _vala_iter;
#line 245 "../src/font-manager/Categories.vala"
			result = font_manager_category_model_invalid_iter (self, &_tmp6_);
#line 245 "../src/font-manager/Categories.vala"
			if (iter) {
#line 245 "../src/font-manager/Categories.vala"
				*iter = _vala_iter;
#line 2013 "Categories.c"
			}
#line 245 "../src/font-manager/Categories.vala"
			return result;
#line 2017 "Categories.c"
		}
#line 246 "../src/font-manager/Categories.vala"
		_tmp7_ = GINT_TO_POINTER (n);
#line 246 "../src/font-manager/Categories.vala"
		_vala_iter.user_data = _tmp7_;
#line 247 "../src/font-manager/Categories.vala"
		result = TRUE;
#line 247 "../src/font-manager/Categories.vala"
		if (iter) {
#line 247 "../src/font-manager/Categories.vala"
			*iter = _vala_iter;
#line 2029 "Categories.c"
		}
#line 247 "../src/font-manager/Categories.vala"
		return result;
#line 2033 "Categories.c"
	}
#line 249 "../src/font-manager/Categories.vala"
	n_children = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, parent);
#line 250 "../src/font-manager/Categories.vala"
	if (n > (n_children - 1)) {
#line 2039 "Categories.c"
		GtkTreeIter _tmp8_;
#line 251 "../src/font-manager/Categories.vala"
		_tmp8_ = _vala_iter;
#line 251 "../src/font-manager/Categories.vala"
		result = font_manager_category_model_invalid_iter (self, &_tmp8_);
#line 251 "../src/font-manager/Categories.vala"
		if (iter) {
#line 251 "../src/font-manager/Categories.vala"
			*iter = _vala_iter;
#line 2049 "Categories.c"
		}
#line 251 "../src/font-manager/Categories.vala"
		return result;
#line 2053 "Categories.c"
	} else {
		void* _tmp9_;
		void* _tmp10_;
#line 253 "../src/font-manager/Categories.vala"
		_tmp9_ = (*parent).user_data;
#line 253 "../src/font-manager/Categories.vala"
		_vala_iter.user_data = _tmp9_;
#line 254 "../src/font-manager/Categories.vala"
		_tmp10_ = GINT_TO_POINTER (n);
#line 254 "../src/font-manager/Categories.vala"
		_vala_iter.user_data2 = _tmp10_;
#line 2065 "Categories.c"
	}
#line 256 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 256 "../src/font-manager/Categories.vala"
	if (iter) {
#line 256 "../src/font-manager/Categories.vala"
		*iter = _vala_iter;
#line 2073 "Categories.c"
	}
#line 256 "../src/font-manager/Categories.vala"
	return result;
#line 2077 "Categories.c"
}

static gboolean
font_manager_category_model_real_iter_parent (GtkTreeModel* base,
                                              GtkTreeIter* iter,
                                              GtkTreeIter* child)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter _tmp4_;
	void* _tmp5_;
	gboolean result;
#line 259 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) base;
#line 259 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 259 "../src/font-manager/Categories.vala"
	_tmp0_ = *child;
#line 259 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "child.stamp == stamp", FALSE);
#line 259 "../src/font-manager/Categories.vala"
	_tmp1_ = *child;
#line 259 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_.user_data2;
#line 259 "../src/font-manager/Categories.vala"
	_vala_return_val_if_fail (((gint) _tmp2_) != -1, "((int) child.user_data2) != -1", FALSE);
#line 262 "../src/font-manager/Categories.vala"
	font_manager_category_model_valid_iter (self, &_tmp3_);
#line 262 "../src/font-manager/Categories.vala"
	_vala_iter = _tmp3_;
#line 263 "../src/font-manager/Categories.vala"
	_tmp4_ = *child;
#line 263 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_.user_data;
#line 263 "../src/font-manager/Categories.vala"
	_vala_iter.user_data = _tmp5_;
#line 264 "../src/font-manager/Categories.vala"
	result = TRUE;
#line 264 "../src/font-manager/Categories.vala"
	if (iter) {
#line 264 "../src/font-manager/Categories.vala"
		*iter = _vala_iter;
#line 2124 "Categories.c"
	}
#line 264 "../src/font-manager/Categories.vala"
	return result;
#line 2128 "Categories.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 273 "../src/font-manager/Categories.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2136 "Categories.c"
}

static void
font_manager_category_model_emit_row_changed_signal (FontManagerCategoryModel* self,
                                                     gint index)
{
	GtkTreeIter iter = {0};
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkTreeIter _tmp2_;
#line 267 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/font-manager/Categories.vala"
	_tmp0_ = gtk_tree_path_new ();
#line 269 "../src/font-manager/Categories.vala"
	path = _tmp0_;
#line 270 "../src/font-manager/Categories.vala"
	gtk_tree_path_append_index (path, index);
#line 271 "../src/font-manager/Categories.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp1_, path);
#line 271 "../src/font-manager/Categories.vala"
	iter = _tmp1_;
#line 272 "../src/font-manager/Categories.vala"
	_tmp2_ = iter;
#line 272 "../src/font-manager/Categories.vala"
	gtk_tree_model_row_changed ((GtkTreeModel*) self, path, &_tmp2_);
#line 273 "../src/font-manager/Categories.vala"
	__vala_GtkTreePath_free0 (path);
#line 273 "../src/font-manager/Categories.vala"
	return;
#line 2168 "Categories.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 276 "../src/font-manager/Categories.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 276 "../src/font-manager/Categories.vala"
	return _data5_;
#line 2178 "Categories.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 276 "../src/font-manager/Categories.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2188 "Categories.c"
		FontManagerCategoryModel* self;
#line 276 "../src/font-manager/Categories.vala"
		self = _data5_->self;
#line 276 "../src/font-manager/Categories.vala"
		_g_object_unref0 (_data5_->disabled);
#line 276 "../src/font-manager/Categories.vala"
		_g_object_unref0 (_data5_->reject);
#line 276 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self);
#line 276 "../src/font-manager/Categories.vala"
		g_slice_free (Block5Data, _data5_);
#line 2200 "Categories.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 286 "../src/font-manager/Categories.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 286 "../src/font-manager/Categories.vala"
	return _data6_;
#line 2211 "Categories.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 286 "../src/font-manager/Categories.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2221 "Categories.c"
		FontManagerCategoryModel* self;
#line 286 "../src/font-manager/Categories.vala"
		self = _data6_->_data5_->self;
#line 286 "../src/font-manager/Categories.vala"
		_g_object_unref0 (_data6_->cat);
#line 286 "../src/font-manager/Categories.vala"
		block5_data_unref (_data6_->_data5_);
#line 286 "../src/font-manager/Categories.vala"
		_data6_->_data5_ = NULL;
#line 286 "../src/font-manager/Categories.vala"
		g_slice_free (Block6Data, _data6_);
#line 2233 "Categories.c"
	}
}

static void
_____lambda40_ (Block6Data* _data6_,
                GObject* obj,
                GAsyncResult* res)
{
	Block5Data* _data5_;
	FontManagerCategoryModel* self;
	FontManagerCategory* _tmp0_;
#line 288 "../src/font-manager/Categories.vala"
	_data5_ = _data6_->_data5_;
#line 288 "../src/font-manager/Categories.vala"
	self = _data5_->self;
#line 288 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 288 "../src/font-manager/Categories.vala"
	_tmp0_ = _data6_->cat;
#line 288 "../src/font-manager/Categories.vala"
	font_manager_category_update_finish (_tmp0_, res);
#line 2255 "Categories.c"
}

static void
______lambda40__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 288 "../src/font-manager/Categories.vala"
	_____lambda40_ (self, source_object, res);
#line 288 "../src/font-manager/Categories.vala"
	block6_data_unref (self);
#line 2267 "Categories.c"
}

static void
__lambda41_ (FontManagerCategoryModel* self)
{
#line 293 "../src/font-manager/Categories.vala"
	font_manager_category_model_update_language_filter_tooltip (self);
#line 294 "../src/font-manager/Categories.vala"
	font_manager_category_model_emit_row_changed_signal (self, (gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
#line 2277 "Categories.c"
}

static void
___lambda41__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                              gpointer self)
{
#line 292 "../src/font-manager/Categories.vala"
	__lambda41_ ((FontManagerCategoryModel*) self);
#line 2286 "Categories.c"
}

static void
__lambda42_ (Block5Data* _data5_,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerCategoryModel* self;
#line 299 "../src/font-manager/Categories.vala"
	self = _data5_->self;
#line 299 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 299 "../src/font-manager/Categories.vala"
	font_manager_disabled_update_finish (_data5_->disabled, res);
#line 2301 "Categories.c"
}

static void
___lambda42__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 299 "../src/font-manager/Categories.vala"
	__lambda42_ (self, source_object, res);
#line 299 "../src/font-manager/Categories.vala"
	block5_data_unref (self);
#line 2313 "Categories.c"
}

static void
__lambda44_ (Block5Data* _data5_,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerCategoryModel* self;
#line 303 "../src/font-manager/Categories.vala"
	self = _data5_->self;
#line 303 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 304 "../src/font-manager/Categories.vala"
	font_manager_disabled_update_finish (_data5_->disabled, res);
#line 305 "../src/font-manager/Categories.vala"
	font_manager_category_model_emit_row_changed_signal (self, (gint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
#line 2330 "Categories.c"
}

static void
___lambda44__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 303 "../src/font-manager/Categories.vala"
	__lambda44_ (self, source_object, res);
#line 303 "../src/font-manager/Categories.vala"
	block5_data_unref (self);
#line 2342 "Categories.c"
}

static void
__lambda43_ (Block5Data* _data5_)
{
	FontManagerCategoryModel* self;
	GPtrArray* _tmp0_;
#line 300 "../src/font-manager/Categories.vala"
	self = _data5_->self;
#line 301 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_categories;
#line 301 "../src/font-manager/Categories.vala"
	if (_tmp0_ == NULL) {
#line 302 "../src/font-manager/Categories.vala"
		return;
#line 2358 "Categories.c"
	}
#line 303 "../src/font-manager/Categories.vala"
	font_manager_disabled_update (_data5_->disabled, (FontManagerStringSet*) _data5_->reject, ___lambda44__gasync_ready_callback, block5_data_ref (_data5_));
#line 2362 "Categories.c"
}

static void
___lambda43__font_manager_selections_changed (FontManagerSelections* _sender,
                                              gpointer self)
{
#line 300 "../src/font-manager/Categories.vala"
	__lambda43_ (self);
#line 2371 "Categories.c"
}

void
font_manager_category_model_update (FontManagerCategoryModel* self)
{
	Block5Data* _data5_;
	FontManagerLanguageFilter* lang_filter = NULL;
	GPtrArray* _tmp11_;
	gconstpointer _tmp12_;
	FontManagerLanguageFilter* _tmp13_;
	FontManagerApplication* _tmp14_;
	FontManagerApplication* _tmp15_;
	FontManagerReject* _tmp16_;
	FontManagerReject* _tmp17_;
	FontManagerReject* _tmp18_;
	FontManagerReject* _tmp19_;
	GPtrArray* _tmp20_;
	gconstpointer _tmp21_;
	FontManagerDisabled* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 276 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/font-manager/Categories.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 276 "../src/font-manager/Categories.vala"
	_data5_->_ref_count_ = 1;
#line 276 "../src/font-manager/Categories.vala"
	_data5_->self = g_object_ref (self);
#line 277 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL], 0);
#line 278 "../src/font-manager/Categories.vala"
	font_manager_category_model_set_categories (self, NULL);
#line 2404 "Categories.c"
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp0_;
		GPtrArray* _tmp1_;
		GPtrArray* _tmp2_;
#line 280 "../src/font-manager/Categories.vala"
		_tmp0_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_BASE, &_inner_error0_);
#line 280 "../src/font-manager/Categories.vala"
		db = _tmp0_;
#line 280 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "../src/font-manager/Categories.vala"
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 2418 "Categories.c"
				goto __catch0_font_manager_database_error;
			}
#line 280 "../src/font-manager/Categories.vala"
			block5_data_unref (_data5_);
#line 280 "../src/font-manager/Categories.vala"
			_data5_ = NULL;
#line 280 "../src/font-manager/Categories.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 280 "../src/font-manager/Categories.vala"
			g_clear_error (&_inner_error0_);
#line 280 "../src/font-manager/Categories.vala"
			return;
#line 2431 "Categories.c"
		}
#line 281 "../src/font-manager/Categories.vala"
		_tmp1_ = font_manager_get_default_categories (db);
#line 281 "../src/font-manager/Categories.vala"
		_tmp2_ = _tmp1_;
#line 281 "../src/font-manager/Categories.vala"
		font_manager_category_model_set_categories (self, _tmp2_);
#line 281 "../src/font-manager/Categories.vala"
		_g_ptr_array_unref0 (_tmp2_);
#line 279 "../src/font-manager/Categories.vala"
		_g_object_unref0 (db);
#line 2443 "Categories.c"
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 279 "../src/font-manager/Categories.vala"
		e = _inner_error0_;
#line 279 "../src/font-manager/Categories.vala"
		_inner_error0_ = NULL;
#line 283 "../src/font-manager/Categories.vala"
		_tmp3_ = e;
#line 283 "../src/font-manager/Categories.vala"
		_tmp4_ = _tmp3_->message;
#line 283 "../src/font-manager/Categories.vala"
		g_critical ("Categories.vala:283: %s", _tmp4_);
#line 279 "../src/font-manager/Categories.vala"
		_g_error_free0 (e);
#line 2463 "Categories.c"
	}
	__finally0:
#line 279 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 279 "../src/font-manager/Categories.vala"
		block5_data_unref (_data5_);
#line 279 "../src/font-manager/Categories.vala"
		_data5_ = NULL;
#line 279 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 279 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 279 "../src/font-manager/Categories.vala"
		return;
#line 2478 "Categories.c"
	}
	{
		gint i = 0;
#line 286 "../src/font-manager/Categories.vala"
		i = (gint) FONT_MANAGER_CATEGORY_INDEX_ALL;
#line 2484 "Categories.c"
		{
			gboolean _tmp5_ = FALSE;
#line 286 "../src/font-manager/Categories.vala"
			_tmp5_ = TRUE;
#line 286 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 2491 "Categories.c"
				Block6Data* _data6_;
				GPtrArray* _tmp7_;
				gconstpointer _tmp8_;
				FontManagerCategory* _tmp9_;
				FontManagerCategory* _tmp10_;
#line 286 "../src/font-manager/Categories.vala"
				_data6_ = g_slice_new0 (Block6Data);
#line 286 "../src/font-manager/Categories.vala"
				_data6_->_ref_count_ = 1;
#line 286 "../src/font-manager/Categories.vala"
				_data6_->_data5_ = block5_data_ref (_data5_);
#line 286 "../src/font-manager/Categories.vala"
				if (!_tmp5_) {
#line 2505 "Categories.c"
					gint _tmp6_;
#line 286 "../src/font-manager/Categories.vala"
					_tmp6_ = i;
#line 286 "../src/font-manager/Categories.vala"
					i = _tmp6_ + 1;
#line 2511 "Categories.c"
				}
#line 286 "../src/font-manager/Categories.vala"
				_tmp5_ = FALSE;
#line 286 "../src/font-manager/Categories.vala"
				if (!(i < ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE))) {
#line 286 "../src/font-manager/Categories.vala"
					block6_data_unref (_data6_);
#line 286 "../src/font-manager/Categories.vala"
					_data6_ = NULL;
#line 286 "../src/font-manager/Categories.vala"
					break;
#line 2523 "Categories.c"
				}
#line 287 "../src/font-manager/Categories.vala"
				_tmp7_ = self->priv->_categories;
#line 287 "../src/font-manager/Categories.vala"
				_tmp8_ = g_ptr_array_index (_tmp7_, (guint) i);
#line 287 "../src/font-manager/Categories.vala"
				_tmp9_ = _g_object_ref0 ((FontManagerCategory*) _tmp8_);
#line 287 "../src/font-manager/Categories.vala"
				_data6_->cat = _tmp9_;
#line 288 "../src/font-manager/Categories.vala"
				_tmp10_ = _data6_->cat;
#line 288 "../src/font-manager/Categories.vala"
				font_manager_category_update (_tmp10_, ______lambda40__gasync_ready_callback, block6_data_ref (_data6_));
#line 286 "../src/font-manager/Categories.vala"
				block6_data_unref (_data6_);
#line 286 "../src/font-manager/Categories.vala"
				_data6_ = NULL;
#line 2541 "Categories.c"
			}
		}
	}
#line 290 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL], 0);
#line 291 "../src/font-manager/Categories.vala"
	_tmp11_ = self->priv->_categories;
#line 291 "../src/font-manager/Categories.vala"
	_tmp12_ = g_ptr_array_index (_tmp11_, (guint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
#line 291 "../src/font-manager/Categories.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp12_, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter));
#line 291 "../src/font-manager/Categories.vala"
	lang_filter = _tmp13_;
#line 292 "../src/font-manager/Categories.vala"
	g_signal_connect_object (lang_filter, "selections-changed", (GCallback) ___lambda41__font_manager_language_filter_selections_changed, self, 0);
#line 296 "../src/font-manager/Categories.vala"
	_tmp14_ = font_manager_get_default_application ();
#line 296 "../src/font-manager/Categories.vala"
	_tmp15_ = _tmp14_;
#line 296 "../src/font-manager/Categories.vala"
	_tmp16_ = font_manager_application_get_reject (_tmp15_);
#line 296 "../src/font-manager/Categories.vala"
	_tmp17_ = _tmp16_;
#line 296 "../src/font-manager/Categories.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 296 "../src/font-manager/Categories.vala"
	_tmp19_ = _tmp18_;
#line 296 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_tmp15_);
#line 296 "../src/font-manager/Categories.vala"
	_data5_->reject = _tmp19_;
#line 297 "../src/font-manager/Categories.vala"
	_vala_assert (_data5_->reject != NULL, "reject != null");
#line 298 "../src/font-manager/Categories.vala"
	_tmp20_ = self->priv->_categories;
#line 298 "../src/font-manager/Categories.vala"
	_tmp21_ = g_ptr_array_index (_tmp20_, (guint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
#line 298 "../src/font-manager/Categories.vala"
	_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp21_, FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled));
#line 298 "../src/font-manager/Categories.vala"
	_data5_->disabled = _tmp22_;
#line 299 "../src/font-manager/Categories.vala"
	font_manager_disabled_update (_data5_->disabled, (FontManagerStringSet*) _data5_->reject, ___lambda42__gasync_ready_callback, block5_data_ref (_data5_));
#line 300 "../src/font-manager/Categories.vala"
	g_signal_connect_data ((FontManagerSelections*) _data5_->reject, "changed", (GCallback) ___lambda43__font_manager_selections_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 308 "../src/font-manager/Categories.vala"
	_g_object_unref0 (lang_filter);
#line 308 "../src/font-manager/Categories.vala"
	block5_data_unref (_data5_);
#line 308 "../src/font-manager/Categories.vala"
	_data5_ = NULL;
#line 308 "../src/font-manager/Categories.vala"
	return;
#line 2595 "Categories.c"
}

FontManagerCategoryModel*
font_manager_category_model_construct (GType object_type)
{
	FontManagerCategoryModel * self = NULL;
#line 49 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryModel*) g_object_new (object_type, NULL);
#line 49 "../src/font-manager/Categories.vala"
	return self;
#line 2606 "Categories.c"
}

FontManagerCategoryModel*
font_manager_category_model_new (void)
{
#line 49 "../src/font-manager/Categories.vala"
	return font_manager_category_model_construct (FONT_MANAGER_TYPE_CATEGORY_MODEL);
#line 2614 "Categories.c"
}

GPtrArray*
font_manager_category_model_get_categories (FontManagerCategoryModel* self)
{
	GPtrArray* result;
	GPtrArray* _tmp0_;
#line 54 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_categories;
#line 54 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 54 "../src/font-manager/Categories.vala"
	return result;
#line 2630 "Categories.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 54 "../src/font-manager/Categories.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 2638 "Categories.c"
}

void
font_manager_category_model_set_categories (FontManagerCategoryModel* self,
                                            GPtrArray* value)
{
	GPtrArray* old_value;
#line 54 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_model_get_categories (self);
#line 54 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 2652 "Categories.c"
		GPtrArray* _tmp0_;
#line 54 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_ptr_array_ref0 (value);
#line 54 "../src/font-manager/Categories.vala"
		_g_ptr_array_unref0 (self->priv->_categories);
#line 54 "../src/font-manager/Categories.vala"
		self->priv->_categories = _tmp0_;
#line 54 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY]);
#line 2662 "Categories.c"
	}
}

static GObject *
font_manager_category_model_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerCategoryModel * self;
#line 59 "../src/font-manager/Categories.vala"
	parent_class = G_OBJECT_CLASS (font_manager_category_model_parent_class);
#line 59 "../src/font-manager/Categories.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
#line 2680 "Categories.c"
	{
		gboolean _tmp0_ = FALSE;
#line 60 "../src/font-manager/Categories.vala"
		_tmp0_ = TRUE;
#line 60 "../src/font-manager/Categories.vala"
		while (TRUE) {
#line 60 "../src/font-manager/Categories.vala"
			if (!_tmp0_) {
#line 60 "../src/font-manager/Categories.vala"
				if (!(self->priv->stamp == 0)) {
#line 60 "../src/font-manager/Categories.vala"
					break;
#line 2693 "Categories.c"
				}
			}
#line 60 "../src/font-manager/Categories.vala"
			_tmp0_ = FALSE;
#line 60 "../src/font-manager/Categories.vala"
			self->priv->stamp = (gint) g_random_int ();
#line 2700 "Categories.c"
		}
	}
#line 59 "../src/font-manager/Categories.vala"
	return obj;
#line 2705 "Categories.c"
}

static void
font_manager_category_model_class_init (FontManagerCategoryModelClass * klass,
                                        gpointer klass_data)
{
#line 49 "../src/font-manager/Categories.vala"
	font_manager_category_model_parent_class = g_type_class_peek_parent (klass);
#line 49 "../src/font-manager/Categories.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryModel_private_offset);
#line 49 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_category_model_get_property;
#line 49 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_category_model_set_property;
#line 49 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_category_model_constructor;
#line 49 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_model_finalize;
#line 49 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY, font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY] = g_param_spec_boxed ("categories", "categories", "categories", G_TYPE_PTR_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/font-manager/Categories.vala"
	font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL] = g_signal_new ("update-begin", FONT_MANAGER_TYPE_CATEGORY_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 49 "../src/font-manager/Categories.vala"
	font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL] = g_signal_new ("update-complete", FONT_MANAGER_TYPE_CATEGORY_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2730 "Categories.c"
}

static void
font_manager_category_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                           gpointer iface_data)
{
#line 49 "../src/font-manager/Categories.vala"
	font_manager_category_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 49 "../src/font-manager/Categories.vala"
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) font_manager_category_model_real_get_flags;
#line 49 "../src/font-manager/Categories.vala"
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) font_manager_category_model_real_get_n_columns;
#line 49 "../src/font-manager/Categories.vala"
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) font_manager_category_model_real_get_column_type;
#line 49 "../src/font-manager/Categories.vala"
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) font_manager_category_model_real_get_iter;
#line 49 "../src/font-manager/Categories.vala"
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_get_path;
#line 49 "../src/font-manager/Categories.vala"
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) font_manager_category_model_real_get_value;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_next;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_previous = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_previous;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) font_manager_category_model_real_iter_children;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_has_child;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_n_children;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) font_manager_category_model_real_iter_nth_child;
#line 49 "../src/font-manager/Categories.vala"
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) font_manager_category_model_real_iter_parent;
#line 2765 "Categories.c"
}

static void
font_manager_category_model_instance_init (FontManagerCategoryModel * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
#line 49 "../src/font-manager/Categories.vala"
	self->priv = font_manager_category_model_get_instance_private (self);
#line 54 "../src/font-manager/Categories.vala"
	self->priv->_categories = NULL;
#line 56 "../src/font-manager/Categories.vala"
	self->priv->stamp = 0;
#line 57 "../src/font-manager/Categories.vala"
	_tmp0_ = g_strdup (DEFAULT_LANGUAGE_FILTER_COMMENT);
#line 57 "../src/font-manager/Categories.vala"
	self->priv->language_filter_tooltip = _tmp0_;
#line 2783 "Categories.c"
}

static void
font_manager_category_model_finalize (GObject * obj)
{
	FontManagerCategoryModel * self;
#line 49 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
#line 54 "../src/font-manager/Categories.vala"
	_g_ptr_array_unref0 (self->priv->_categories);
#line 57 "../src/font-manager/Categories.vala"
	_g_free0 (self->priv->language_filter_tooltip);
#line 49 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (font_manager_category_model_parent_class)->finalize (obj);
#line 2798 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_category_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryModel), 0, (GInstanceInitFunc) font_manager_category_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) font_manager_category_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType font_manager_category_model_type_id;
	font_manager_category_model_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerCategoryModel", &g_define_type_info, 0);
	g_type_add_interface_static (font_manager_category_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	FontManagerCategoryModel_private_offset = g_type_add_instance_private (font_manager_category_model_type_id, sizeof (FontManagerCategoryModelPrivate));
	return font_manager_category_model_type_id;
}

GType
font_manager_category_model_get_type (void)
{
	static volatile gsize font_manager_category_model_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_model_type_id__once)) {
		GType font_manager_category_model_type_id;
		font_manager_category_model_type_id = font_manager_category_model_get_type_once ();
		g_once_init_leave (&font_manager_category_model_type_id__once, font_manager_category_model_type_id);
	}
	return font_manager_category_model_type_id__once;
}

static void
_vala_font_manager_category_model_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerCategoryModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
#line 49 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 49 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY:
#line 49 "../src/font-manager/Categories.vala"
		g_value_set_boxed (value, font_manager_category_model_get_categories (self));
#line 49 "../src/font-manager/Categories.vala"
		break;
#line 2841 "Categories.c"
		default:
#line 49 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 49 "../src/font-manager/Categories.vala"
		break;
#line 2847 "Categories.c"
	}
}

static void
_vala_font_manager_category_model_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerCategoryModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
#line 49 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 49 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY:
#line 49 "../src/font-manager/Categories.vala"
		font_manager_category_model_set_categories (self, g_value_get_boxed (value));
#line 49 "../src/font-manager/Categories.vala"
		break;
#line 2867 "Categories.c"
		default:
#line 49 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 49 "../src/font-manager/Categories.vala"
		break;
#line 2873 "Categories.c"
	}
}

static inline gpointer
font_manager_category_tree_get_instance_private (FontManagerCategoryTree* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryTree_private_offset);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 357 "../src/font-manager/Categories.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 357 "../src/font-manager/Categories.vala"
	return _data7_;
#line 2890 "Categories.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 357 "../src/font-manager/Categories.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2900 "Categories.c"
		FontManagerCategoryTree* self;
#line 357 "../src/font-manager/Categories.vala"
		self = _data7_->self;
#line 357 "../src/font-manager/Categories.vala"
		_g_object_unref0 (_data7_->db);
#line 357 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self);
#line 357 "../src/font-manager/Categories.vala"
		g_slice_free (Block7Data, _data7_);
#line 2910 "Categories.c"
	}
}

static void
_font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                             gpointer self)
{
#line 358 "../src/font-manager/Categories.vala"
	font_manager_category_tree_on_selection_changed ((FontManagerCategoryTree*) self, _sender);
#line 2920 "Categories.c"
}

static void
__lambda50_ (FontManagerCategoryTree* self)
{
#line 366 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
#line 367 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_update_in_progress (self, TRUE);
#line 2930 "Categories.c"
}

static void
___lambda50__font_manager_category_model_update_begin (FontManagerCategoryModel* _sender,
                                                       gpointer self)
{
#line 365 "../src/font-manager/Categories.vala"
	__lambda50_ ((FontManagerCategoryTree*) self);
#line 2939 "Categories.c"
}

static void
__lambda51_ (FontManagerCategoryTree* self)
{
	FontManagerCategoryModel* _tmp0_;
#line 370 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_update_in_progress (self, FALSE);
#line 371 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_model_;
#line 371 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp0_);
#line 372 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL], 0);
#line 2954 "Categories.c"
}

static void
___lambda51__font_manager_category_model_update_complete (FontManagerCategoryModel* _sender,
                                                          gpointer self)
{
#line 369 "../src/font-manager/Categories.vala"
	__lambda51_ ((FontManagerCategoryTree*) self);
#line 2963 "Categories.c"
}

static gboolean
____lambda53_ (FontManagerCategoryTree* self)
{
	gboolean result;
#line 381 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL], 0);
#line 382 "../src/font-manager/Categories.vala"
	_g_free0 (self->priv->change_timeout);
#line 382 "../src/font-manager/Categories.vala"
	self->priv->change_timeout = NULL;
#line 383 "../src/font-manager/Categories.vala"
	result = G_SOURCE_REMOVE;
#line 383 "../src/font-manager/Categories.vala"
	return result;
#line 2980 "Categories.c"
}

static gboolean
_____lambda53__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda53_ ((FontManagerCategoryTree*) self);
#line 380 "../src/font-manager/Categories.vala"
	return result;
#line 2990 "Categories.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 380 "../src/font-manager/Categories.vala"
	dup = g_new0 (guint, 1);
#line 380 "../src/font-manager/Categories.vala"
	memcpy (dup, self, sizeof (guint));
#line 380 "../src/font-manager/Categories.vala"
	return dup;
#line 3003 "Categories.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 380 "../src/font-manager/Categories.vala"
	return self ? _uint_dup (self) : NULL;
#line 3011 "Categories.c"
}

static void
__lambda52_ (FontManagerCategoryTree* self,
             GtkTreePath* path,
             GtkTreeIter* iter)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
#line 374 "../src/font-manager/Categories.vala"
	g_return_if_fail (path != NULL);
#line 374 "../src/font-manager/Categories.vala"
	g_return_if_fail (iter != NULL);
#line 378 "../src/font-manager/Categories.vala"
	_tmp0_ = gtk_tree_path_to_string (path);
#line 378 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 378 "../src/font-manager/Categories.vala"
	_tmp2_ = self->priv->_selected_iter;
#line 378 "../src/font-manager/Categories.vala"
	_tmp3_ = g_strcmp0 (_tmp1_, _tmp2_) == 0;
#line 378 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp1_);
#line 378 "../src/font-manager/Categories.vala"
	if (_tmp3_) {
#line 3039 "Categories.c"
		guint* _tmp4_;
#line 379 "../src/font-manager/Categories.vala"
		_tmp4_ = self->priv->change_timeout;
#line 379 "../src/font-manager/Categories.vala"
		if (_tmp4_ == NULL) {
#line 3045 "Categories.c"
			guint _tmp5_;
			guint* _tmp6_;
#line 380 "../src/font-manager/Categories.vala"
			_tmp5_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _____lambda53__gsource_func, g_object_ref (self), g_object_unref);
#line 380 "../src/font-manager/Categories.vala"
			_tmp6_ = __uint_dup0 (&_tmp5_);
#line 380 "../src/font-manager/Categories.vala"
			_g_free0 (self->priv->change_timeout);
#line 380 "../src/font-manager/Categories.vala"
			self->priv->change_timeout = _tmp6_;
#line 3056 "Categories.c"
		}
	}
}

static void
___lambda52__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
#line 374 "../src/font-manager/Categories.vala"
	__lambda52_ ((FontManagerCategoryTree*) self, path, iter);
#line 3069 "Categories.c"
}

static void
__lambda49_ (FontManagerCategoryTree* self)
{
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	FontManagerCategoryModel* _tmp5_;
	FontManagerCategoryModel* _tmp6_;
	FontManagerCategoryModel* _tmp7_;
#line 360 "../src/font-manager/Categories.vala"
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 360 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 360 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 361 "../src/font-manager/Categories.vala"
		return;
#line 3088 "Categories.c"
	} else {
		GtkTreeModel* _tmp2_;
		GtkTreeModel* _tmp3_;
		FontManagerCategoryModel* _tmp4_;
#line 363 "../src/font-manager/Categories.vala"
		_tmp2_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 363 "../src/font-manager/Categories.vala"
		_tmp3_ = _tmp2_;
#line 363 "../src/font-manager/Categories.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel));
#line 363 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_model_);
#line 363 "../src/font-manager/Categories.vala"
		self->priv->_model_ = _tmp4_;
#line 3103 "Categories.c"
	}
#line 364 "../src/font-manager/Categories.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 365 "../src/font-manager/Categories.vala"
	_tmp5_ = self->priv->_model_;
#line 365 "../src/font-manager/Categories.vala"
	g_signal_connect_object (_tmp5_, "update-begin", (GCallback) ___lambda50__font_manager_category_model_update_begin, self, 0);
#line 369 "../src/font-manager/Categories.vala"
	_tmp6_ = self->priv->_model_;
#line 369 "../src/font-manager/Categories.vala"
	g_signal_connect_object (_tmp6_, "update-complete", (GCallback) ___lambda51__font_manager_category_model_update_complete, self, 0);
#line 374 "../src/font-manager/Categories.vala"
	_tmp7_ = self->priv->_model_;
#line 374 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-changed", (GCallback) ___lambda52__gtk_tree_model_row_changed, self, 0);
#line 3119 "Categories.c"
}

static void
___lambda49__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 359 "../src/font-manager/Categories.vala"
	__lambda49_ ((FontManagerCategoryTree*) self);
#line 3129 "Categories.c"
}

static void
__lambda57_ (FontManagerCategoryTree* self)
{
#line 391 "../src/font-manager/Categories.vala"
	self->priv->refresh_required = TRUE;
#line 3137 "Categories.c"
}

static void
___lambda57__font_manager_database_proxy_update_started (FontManagerDatabaseProxy* _sender,
                                                         gpointer self)
{
#line 391 "../src/font-manager/Categories.vala"
	__lambda57_ ((FontManagerCategoryTree*) self);
#line 3146 "Categories.c"
}

static void
__lambda58_ (Block7Data* _data7_)
{
	FontManagerCategoryTree* self;
	gboolean _tmp0_ = FALSE;
#line 392 "../src/font-manager/Categories.vala"
	self = _data7_->self;
#line 393 "../src/font-manager/Categories.vala"
	if (self->priv->refresh_required) {
#line 393 "../src/font-manager/Categories.vala"
		_tmp0_ = font_manager_database_proxy_ready (_data7_->db, FONT_MANAGER_DATABASE_TYPE_METADATA);
#line 3160 "Categories.c"
	} else {
#line 393 "../src/font-manager/Categories.vala"
		_tmp0_ = FALSE;
#line 3164 "Categories.c"
	}
#line 393 "../src/font-manager/Categories.vala"
	if (_tmp0_) {
#line 394 "../src/font-manager/Categories.vala"
		self->priv->refresh_required = FALSE;
#line 395 "../src/font-manager/Categories.vala"
		font_manager_category_tree_update (self);
#line 3172 "Categories.c"
	}
}

static void
___lambda58__font_manager_database_proxy_status_changed (FontManagerDatabaseProxy* _sender,
                                                         gpointer self)
{
#line 392 "../src/font-manager/Categories.vala"
	__lambda58_ (self);
#line 3182 "Categories.c"
}

static void
__lambda59_ (FontManagerCategoryTree* self)
{
#line 399 "../src/font-manager/Categories.vala"
	if (self->priv->refresh_required) {
#line 400 "../src/font-manager/Categories.vala"
		self->priv->refresh_required = FALSE;
#line 401 "../src/font-manager/Categories.vala"
		font_manager_category_tree_update (self);
#line 3194 "Categories.c"
	}
}

static void
___lambda59__font_manager_database_proxy_update_complete (FontManagerDatabaseProxy* _sender,
                                                          gpointer self)
{
#line 398 "../src/font-manager/Categories.vala"
	__lambda59_ ((FontManagerCategoryTree*) self);
#line 3204 "Categories.c"
}

static void
font_manager_category_tree_connect_signals (FontManagerCategoryTree* self)
{
	Block7Data* _data7_;
	GtkTreeSelection* _tmp0_;
	FontManagerApplication* _tmp1_;
	FontManagerApplication* _tmp2_;
	FontManagerDatabaseProxy* _tmp3_;
	FontManagerDatabaseProxy* _tmp4_;
	FontManagerDatabaseProxy* _tmp5_;
	FontManagerDatabaseProxy* _tmp6_;
#line 357 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/font-manager/Categories.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 357 "../src/font-manager/Categories.vala"
	_data7_->_ref_count_ = 1;
#line 357 "../src/font-manager/Categories.vala"
	_data7_->self = g_object_ref (self);
#line 358 "../src/font-manager/Categories.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 358 "../src/font-manager/Categories.vala"
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed, self, 0);
#line 359 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GObject*) self, "notify::model", (GCallback) ___lambda49__g_object_notify, self, 0);
#line 389 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_get_default_application ();
#line 389 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 389 "../src/font-manager/Categories.vala"
	_tmp3_ = font_manager_application_get_db (_tmp2_);
#line 389 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_;
#line 389 "../src/font-manager/Categories.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 389 "../src/font-manager/Categories.vala"
	_tmp6_ = _tmp5_;
#line 389 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_tmp2_);
#line 389 "../src/font-manager/Categories.vala"
	_data7_->db = _tmp6_;
#line 390 "../src/font-manager/Categories.vala"
	_vala_assert (_data7_->db != NULL, "db != null");
#line 391 "../src/font-manager/Categories.vala"
	g_signal_connect_object (_data7_->db, "update-started", (GCallback) ___lambda57__font_manager_database_proxy_update_started, self, 0);
#line 392 "../src/font-manager/Categories.vala"
	g_signal_connect_data (_data7_->db, "status-changed", (GCallback) ___lambda58__font_manager_database_proxy_status_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 398 "../src/font-manager/Categories.vala"
	g_signal_connect_object (_data7_->db, "update-complete", (GCallback) ___lambda59__font_manager_database_proxy_update_complete, self, 0);
#line 404 "../src/font-manager/Categories.vala"
	block7_data_unref (_data7_);
#line 404 "../src/font-manager/Categories.vala"
	_data7_ = NULL;
#line 404 "../src/font-manager/Categories.vala"
	return;
#line 3262 "Categories.c"
}

void
font_manager_category_tree_select_first_row (FontManagerCategoryTree* self)
{
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp2_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp3_;
	GtkTreeSelection* _tmp4_;
	GtkTreeSelection* _tmp5_;
	GtkTreeSelection* _tmp6_;
	GtkTreePath* _tmp7_;
	GtkTreeSelection* _tmp8_;
	GtkTreePath* _tmp9_;
#line 407 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/font-manager/Categories.vala"
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 408 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/font-manager/Categories.vala"
	if (_tmp1_ == NULL) {
#line 409 "../src/font-manager/Categories.vala"
		return;
#line 3290 "Categories.c"
	}
#line 410 "../src/font-manager/Categories.vala"
	_tmp2_ = gtk_tree_path_new_first ();
#line 410 "../src/font-manager/Categories.vala"
	path = _tmp2_;
#line 411 "../src/font-manager/Categories.vala"
	_tmp3_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 411 "../src/font-manager/Categories.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 411 "../src/font-manager/Categories.vala"
	selection = _tmp4_;
#line 412 "../src/font-manager/Categories.vala"
	_tmp5_ = selection;
#line 412 "../src/font-manager/Categories.vala"
	gtk_tree_selection_unselect_all (_tmp5_);
#line 413 "../src/font-manager/Categories.vala"
	_tmp6_ = selection;
#line 413 "../src/font-manager/Categories.vala"
	_tmp7_ = path;
#line 413 "../src/font-manager/Categories.vala"
	gtk_tree_selection_select_path (_tmp6_, _tmp7_);
#line 414 "../src/font-manager/Categories.vala"
	_tmp8_ = selection;
#line 414 "../src/font-manager/Categories.vala"
	_tmp9_ = path;
#line 414 "../src/font-manager/Categories.vala"
	if (gtk_tree_selection_path_is_selected (_tmp8_, _tmp9_)) {
#line 3318 "Categories.c"
		GtkTreePath* _tmp10_;
#line 415 "../src/font-manager/Categories.vala"
		_tmp10_ = path;
#line 415 "../src/font-manager/Categories.vala"
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp10_, NULL, TRUE, 0.5f, 0.5f);
#line 3324 "Categories.c"
	}
#line 416 "../src/font-manager/Categories.vala"
	_g_object_unref0 (selection);
#line 416 "../src/font-manager/Categories.vala"
	__vala_GtkTreePath_free0 (path);
#line 416 "../src/font-manager/Categories.vala"
	return;
#line 3332 "Categories.c"
}

void
font_manager_category_tree_update (FontManagerCategoryTree* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	FontManagerCategory* _tmp4_;
#line 419 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/font-manager/Categories.vala"
	_tmp1_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 420 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 420 "../src/font-manager/Categories.vala"
	if (_tmp2_ == NULL) {
#line 420 "../src/font-manager/Categories.vala"
		_tmp0_ = TRUE;
#line 3352 "Categories.c"
	} else {
		FontManagerCategoryModel* _tmp3_;
#line 420 "../src/font-manager/Categories.vala"
		_tmp3_ = self->priv->_model_;
#line 420 "../src/font-manager/Categories.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 3359 "Categories.c"
	}
#line 420 "../src/font-manager/Categories.vala"
	if (_tmp0_) {
#line 421 "../src/font-manager/Categories.vala"
		return;
#line 3365 "Categories.c"
	}
#line 423 "../src/font-manager/Categories.vala"
	_tmp4_ = self->priv->_selected_filter;
#line 423 "../src/font-manager/Categories.vala"
	if (_tmp4_ != NULL) {
#line 3371 "Categories.c"
		gint index = 0;
		FontManagerCategory* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp8_;
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp9_;
		GtkTreeSelection* _tmp10_;
		GtkTreeSelection* _tmp11_;
		FontManagerCategoryModel* _tmp12_;
		GtkTreeSelection* _tmp13_;
		GtkTreePath* _tmp14_;
#line 424 "../src/font-manager/Categories.vala"
		_tmp5_ = self->priv->_selected_filter;
#line 424 "../src/font-manager/Categories.vala"
		_tmp6_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp5_);
#line 424 "../src/font-manager/Categories.vala"
		_tmp7_ = _tmp6_;
#line 424 "../src/font-manager/Categories.vala"
		index = _tmp7_;
#line 425 "../src/font-manager/Categories.vala"
		_tmp8_ = gtk_tree_path_new_from_indices (index, -1, -1);
#line 425 "../src/font-manager/Categories.vala"
		path = _tmp8_;
#line 426 "../src/font-manager/Categories.vala"
		_tmp9_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 426 "../src/font-manager/Categories.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 426 "../src/font-manager/Categories.vala"
		selection = _tmp10_;
#line 427 "../src/font-manager/Categories.vala"
		_tmp11_ = selection;
#line 427 "../src/font-manager/Categories.vala"
		gtk_tree_selection_unselect_all (_tmp11_);
#line 428 "../src/font-manager/Categories.vala"
		_tmp12_ = self->priv->_model_;
#line 428 "../src/font-manager/Categories.vala"
		font_manager_category_model_update (_tmp12_);
#line 429 "../src/font-manager/Categories.vala"
		_tmp13_ = selection;
#line 429 "../src/font-manager/Categories.vala"
		_tmp14_ = path;
#line 429 "../src/font-manager/Categories.vala"
		gtk_tree_selection_select_path (_tmp13_, _tmp14_);
#line 423 "../src/font-manager/Categories.vala"
		_g_object_unref0 (selection);
#line 423 "../src/font-manager/Categories.vala"
		__vala_GtkTreePath_free0 (path);
#line 3421 "Categories.c"
	} else {
		FontManagerCategoryModel* _tmp15_;
#line 431 "../src/font-manager/Categories.vala"
		_tmp15_ = self->priv->_model_;
#line 431 "../src/font-manager/Categories.vala"
		font_manager_category_model_update (_tmp15_);
#line 432 "../src/font-manager/Categories.vala"
		font_manager_category_tree_select_first_row (self);
#line 3430 "Categories.c"
	}
#line 434 "../src/font-manager/Categories.vala"
	return;
#line 3434 "Categories.c"
}

static void
font_manager_category_tree_count_cell_data_func (FontManagerCategoryTree* self,
                                                 GtkTreeViewColumn* layout,
                                                 GtkCellRenderer* cell,
                                                 GtkTreeModel* model,
                                                 GtkTreeIter* treeiter)
{
	GValue _tmp0_ = {0};
	GtkTreeIter _tmp1_;
	GValue val = {0};
	GtkTreeIter _tmp2_;
	GValue _tmp3_ = {0};
	FontManagerCategory* obj = NULL;
	GObject* _tmp4_;
	FontManagerCategory* _tmp5_;
	gboolean _tmp6_ = FALSE;
	FontManagerCategory* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 437 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/font-manager/Categories.vala"
	g_return_if_fail (layout != NULL);
#line 437 "../src/font-manager/Categories.vala"
	g_return_if_fail (cell != NULL);
#line 437 "../src/font-manager/Categories.vala"
	g_return_if_fail (model != NULL);
#line 437 "../src/font-manager/Categories.vala"
	g_return_if_fail (treeiter != NULL);
#line 442 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp0_, G_TYPE_BOOLEAN);
#line 442 "../src/font-manager/Categories.vala"
	g_value_set_boolean (&_tmp0_, FALSE);
#line 442 "../src/font-manager/Categories.vala"
	g_object_set_property ((GObject*) cell, "visible", &_tmp0_);
#line 442 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&_tmp0_) ? (g_value_unset (&_tmp0_), NULL) : NULL;
#line 443 "../src/font-manager/Categories.vala"
	_tmp1_ = *treeiter;
#line 443 "../src/font-manager/Categories.vala"
	if (gtk_tree_model_iter_has_child (model, &_tmp1_)) {
#line 444 "../src/font-manager/Categories.vala"
		return;
#line 3480 "Categories.c"
	}
#line 446 "../src/font-manager/Categories.vala"
	_tmp2_ = *treeiter;
#line 446 "../src/font-manager/Categories.vala"
	gtk_tree_model_get_value (model, &_tmp2_, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, &_tmp3_);
#line 446 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 446 "../src/font-manager/Categories.vala"
	val = _tmp3_;
#line 447 "../src/font-manager/Categories.vala"
	_tmp4_ = g_value_get_object (&val);
#line 447 "../src/font-manager/Categories.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 447 "../src/font-manager/Categories.vala"
	obj = _tmp5_;
#line 449 "../src/font-manager/Categories.vala"
	_tmp7_ = obj;
#line 449 "../src/font-manager/Categories.vala"
	_tmp8_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp7_);
#line 449 "../src/font-manager/Categories.vala"
	_tmp9_ = _tmp8_;
#line 449 "../src/font-manager/Categories.vala"
	if (_tmp9_ < ((gint) FONT_MANAGER_CATEGORY_INDEX_UNSORTED)) {
#line 449 "../src/font-manager/Categories.vala"
		_tmp6_ = TRUE;
#line 3506 "Categories.c"
	} else {
		FontManagerCategory* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 449 "../src/font-manager/Categories.vala"
		_tmp10_ = obj;
#line 449 "../src/font-manager/Categories.vala"
		_tmp11_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp10_);
#line 449 "../src/font-manager/Categories.vala"
		_tmp12_ = _tmp11_;
#line 449 "../src/font-manager/Categories.vala"
		_tmp6_ = _tmp12_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
#line 3519 "Categories.c"
	}
#line 449 "../src/font-manager/Categories.vala"
	if (_tmp6_) {
#line 3523 "Categories.c"
		FontManagerCategory* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GValue _tmp16_ = {0};
		GValue _tmp17_ = {0};
#line 450 "../src/font-manager/Categories.vala"
		_tmp13_ = obj;
#line 450 "../src/font-manager/Categories.vala"
		_tmp14_ = font_manager_filter_get_size ((FontManagerFilter*) _tmp13_);
#line 450 "../src/font-manager/Categories.vala"
		_tmp15_ = _tmp14_;
#line 450 "../src/font-manager/Categories.vala"
		g_value_init (&_tmp16_, G_TYPE_INT);
#line 450 "../src/font-manager/Categories.vala"
		g_value_set_int (&_tmp16_, _tmp15_);
#line 450 "../src/font-manager/Categories.vala"
		g_object_set_property ((GObject*) cell, "count", &_tmp16_);
#line 450 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
#line 451 "../src/font-manager/Categories.vala"
		g_value_init (&_tmp17_, G_TYPE_BOOLEAN);
#line 451 "../src/font-manager/Categories.vala"
		g_value_set_boolean (&_tmp17_, TRUE);
#line 451 "../src/font-manager/Categories.vala"
		g_object_set_property ((GObject*) cell, "visible", &_tmp17_);
#line 451 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
#line 3551 "Categories.c"
	}
#line 453 "../src/font-manager/Categories.vala"
	g_value_unset (&val);
#line 454 "../src/font-manager/Categories.vala"
	_g_object_unref0 (obj);
#line 454 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 454 "../src/font-manager/Categories.vala"
	return;
#line 3561 "Categories.c"
}

static void
font_manager_category_tree_pixbuf_cell_data_func (FontManagerCategoryTree* self,
                                                  GtkTreeViewColumn* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* model,
                                                  GtkTreeIter* treeiter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GObject* obj = NULL;
	GObject* _tmp2_;
	GObject* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	gboolean _tmp7_;
#line 457 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/font-manager/Categories.vala"
	g_return_if_fail (layout != NULL);
#line 457 "../src/font-manager/Categories.vala"
	g_return_if_fail (cell != NULL);
#line 457 "../src/font-manager/Categories.vala"
	g_return_if_fail (model != NULL);
#line 457 "../src/font-manager/Categories.vala"
	g_return_if_fail (treeiter != NULL);
#line 462 "../src/font-manager/Categories.vala"
	_tmp0_ = *treeiter;
#line 462 "../src/font-manager/Categories.vala"
	gtk_tree_model_get_value (model, &_tmp0_, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, &_tmp1_);
#line 462 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 462 "../src/font-manager/Categories.vala"
	val = _tmp1_;
#line 463 "../src/font-manager/Categories.vala"
	_tmp2_ = g_value_get_object (&val);
#line 463 "../src/font-manager/Categories.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 463 "../src/font-manager/Categories.vala"
	obj = _tmp3_;
#line 464 "../src/font-manager/Categories.vala"
	_tmp4_ = *treeiter;
#line 464 "../src/font-manager/Categories.vala"
	_tmp5_ = gtk_tree_model_get_path (model, &_tmp4_);
#line 464 "../src/font-manager/Categories.vala"
	_tmp6_ = _tmp5_;
#line 464 "../src/font-manager/Categories.vala"
	_tmp7_ = gtk_tree_view_row_expanded ((GtkTreeView*) self, _tmp6_);
#line 464 "../src/font-manager/Categories.vala"
	__vala_GtkTreePath_free0 (_tmp6_);
#line 464 "../src/font-manager/Categories.vala"
	if (_tmp7_) {
#line 3617 "Categories.c"
		GValue _tmp8_ = {0};
#line 465 "../src/font-manager/Categories.vala"
		g_value_init (&_tmp8_, G_TYPE_STRING);
#line 465 "../src/font-manager/Categories.vala"
		g_value_set_string (&_tmp8_, "folder-open-symbolic");
#line 465 "../src/font-manager/Categories.vala"
		g_object_set_property ((GObject*) cell, "icon-name", &_tmp8_);
#line 465 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 3627 "Categories.c"
	} else {
		GObject* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GValue _tmp12_ = {0};
#line 467 "../src/font-manager/Categories.vala"
		_tmp9_ = obj;
#line 467 "../src/font-manager/Categories.vala"
		_tmp10_ = font_manager_filter_get_icon ((FontManagerFilter*) G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
#line 467 "../src/font-manager/Categories.vala"
		_tmp11_ = _tmp10_;
#line 467 "../src/font-manager/Categories.vala"
		g_value_init (&_tmp12_, G_TYPE_STRING);
#line 467 "../src/font-manager/Categories.vala"
		g_value_take_string (&_tmp12_, _tmp11_);
#line 467 "../src/font-manager/Categories.vala"
		g_object_set_property ((GObject*) cell, "icon-name", &_tmp12_);
#line 467 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
#line 3647 "Categories.c"
	}
#line 468 "../src/font-manager/Categories.vala"
	g_value_unset (&val);
#line 469 "../src/font-manager/Categories.vala"
	_g_object_unref0 (obj);
#line 469 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 469 "../src/font-manager/Categories.vala"
	return;
#line 3657 "Categories.c"
}

static void
___lambda46_ (FontManagerCategoryTree* self)
{
#line 495 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL], 0);
#line 3665 "Categories.c"
}

static void
____lambda46__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                               gpointer self)
{
#line 495 "../src/font-manager/Categories.vala"
	___lambda46_ ((FontManagerCategoryTree*) self);
#line 3674 "Categories.c"
}

static gboolean
__lambda45_ (FontManagerCategoryTree* self)
{
	gboolean is_language_filter = FALSE;
	FontManagerCategory* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	FontManagerLanguageFilter* _tmp3_;
	gboolean result;
#line 490 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_selected_filter;
#line 490 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp0_);
#line 490 "../src/font-manager/Categories.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/font-manager/Categories.vala"
	is_language_filter = _tmp2_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
#line 491 "../src/font-manager/Categories.vala"
	_tmp3_ = self->priv->_language_filter;
#line 491 "../src/font-manager/Categories.vala"
	if (_tmp3_ != NULL) {
#line 492 "../src/font-manager/Categories.vala"
		result = G_SOURCE_REMOVE;
#line 492 "../src/font-manager/Categories.vala"
		return result;
#line 3702 "Categories.c"
	}
#line 493 "../src/font-manager/Categories.vala"
	if (is_language_filter) {
#line 3706 "Categories.c"
		FontManagerCategory* _tmp4_;
		FontManagerLanguageFilter* _tmp5_;
#line 494 "../src/font-manager/Categories.vala"
		_tmp4_ = self->priv->_selected_filter;
#line 494 "../src/font-manager/Categories.vala"
		font_manager_category_tree_set_language_filter (self, FONT_MANAGER_IS_LANGUAGE_FILTER (_tmp4_) ? ((FontManagerLanguageFilter*) _tmp4_) : NULL);
#line 495 "../src/font-manager/Categories.vala"
		_tmp5_ = self->priv->_language_filter;
#line 495 "../src/font-manager/Categories.vala"
		g_signal_connect_object (_tmp5_, "selections-changed", (GCallback) ____lambda46__font_manager_language_filter_selections_changed, self, 0);
#line 3717 "Categories.c"
	}
#line 497 "../src/font-manager/Categories.vala"
	result = G_SOURCE_REMOVE;
#line 497 "../src/font-manager/Categories.vala"
	return result;
#line 3723 "Categories.c"
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((FontManagerCategoryTree*) self);
#line 489 "../src/font-manager/Categories.vala"
	return result;
#line 3733 "Categories.c"
}

static gboolean
___lambda47_ (FontManagerCategoryTree* self)
{
	gboolean _tmp0_ = FALSE;
	FontManagerCategory* _tmp1_;
	gboolean _tmp5_ = FALSE;
	FontManagerCategory* _tmp6_;
	gboolean result;
#line 509 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_selected_filter;
#line 509 "../src/font-manager/Categories.vala"
	if (_tmp1_ != NULL) {
#line 3748 "Categories.c"
		FontManagerCategory* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 509 "../src/font-manager/Categories.vala"
		_tmp2_ = self->priv->_selected_filter;
#line 509 "../src/font-manager/Categories.vala"
		_tmp3_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp2_);
#line 509 "../src/font-manager/Categories.vala"
		_tmp4_ = _tmp3_;
#line 509 "../src/font-manager/Categories.vala"
		_tmp0_ = !_tmp4_;
#line 3760 "Categories.c"
	} else {
#line 509 "../src/font-manager/Categories.vala"
		_tmp0_ = FALSE;
#line 3764 "Categories.c"
	}
#line 509 "../src/font-manager/Categories.vala"
	if (_tmp0_) {
#line 510 "../src/font-manager/Categories.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 3770 "Categories.c"
	}
#line 511 "../src/font-manager/Categories.vala"
	_tmp6_ = self->priv->_selected_filter;
#line 511 "../src/font-manager/Categories.vala"
	if (_tmp6_ != NULL) {
#line 3776 "Categories.c"
		FontManagerCategory* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 511 "../src/font-manager/Categories.vala"
		_tmp7_ = self->priv->_selected_filter;
#line 511 "../src/font-manager/Categories.vala"
		_tmp8_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp7_);
#line 511 "../src/font-manager/Categories.vala"
		_tmp9_ = _tmp8_;
#line 511 "../src/font-manager/Categories.vala"
		_tmp5_ = _tmp9_;
#line 3788 "Categories.c"
	} else {
#line 511 "../src/font-manager/Categories.vala"
		_tmp5_ = FALSE;
#line 3792 "Categories.c"
	}
#line 511 "../src/font-manager/Categories.vala"
	result = _tmp5_;
#line 511 "../src/font-manager/Categories.vala"
	return result;
#line 3798 "Categories.c"
}

static gboolean
____lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda47_ ((FontManagerCategoryTree*) self);
#line 507 "../src/font-manager/Categories.vala"
	return result;
#line 3808 "Categories.c"
}

static void
____lambda48_ (FontManagerCategoryTree* self,
               GObject* obj,
               GAsyncResult* res)
{
	FontManagerCategory* _tmp0_;
	FontManagerCategory* _tmp1_;
#line 514 "../src/font-manager/Categories.vala"
	g_return_if_fail (res != NULL);
#line 515 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_selected_filter;
#line 515 "../src/font-manager/Categories.vala"
	font_manager_category_update_finish (_tmp0_, res);
#line 516 "../src/font-manager/Categories.vala"
	_tmp1_ = self->priv->_selected_filter;
#line 516 "../src/font-manager/Categories.vala"
	font_manager_filter_set_requires_update ((FontManagerFilter*) _tmp1_, FALSE);
#line 3828 "Categories.c"
}

static void
_____lambda48__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 514 "../src/font-manager/Categories.vala"
	____lambda48_ ((FontManagerCategoryTree*) self, source_object, res);
#line 514 "../src/font-manager/Categories.vala"
	g_object_unref (self);
#line 3840 "Categories.c"
}

static void
font_manager_category_tree_on_selection_changed (FontManagerCategoryTree* self,
                                                 GtkTreeSelection* selection)
{
	GtkTreeIter iter = {0};
	GtkTreeModel* model = NULL;
	GValue val = {0};
	GtkTreeModel* _tmp0_ = NULL;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	GtkTreePath* path = NULL;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	GtkTreePath* _tmp9_;
	GValue _tmp10_;
	FontManagerCategory* _tmp11_;
	GtkTreeModel* _tmp12_;
	GtkTreeIter _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkTreePath* _tmp16_;
	GtkTreePath* _tmp18_;
	gboolean _tmp19_ = FALSE;
	FontManagerCategory* _tmp20_;
	FontManagerCategory* _tmp30_;
#line 472 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/font-manager/Categories.vala"
	g_return_if_fail (selection != NULL);
#line 476 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_selected_filter (self, NULL);
#line 477 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_selected_iter (self, "-1");
#line 478 "../src/font-manager/Categories.vala"
	_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp0_, &_tmp1_);
#line 478 "../src/font-manager/Categories.vala"
	_g_object_unref0 (model);
#line 478 "../src/font-manager/Categories.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 478 "../src/font-manager/Categories.vala"
	model = _tmp3_;
#line 478 "../src/font-manager/Categories.vala"
	iter = _tmp1_;
#line 478 "../src/font-manager/Categories.vala"
	if (!_tmp2_) {
#line 479 "../src/font-manager/Categories.vala"
		g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL], 0, NULL);
#line 480 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 480 "../src/font-manager/Categories.vala"
		_g_object_unref0 (model);
#line 480 "../src/font-manager/Categories.vala"
		return;
#line 3900 "Categories.c"
	}
#line 482 "../src/font-manager/Categories.vala"
	_tmp4_ = model;
#line 482 "../src/font-manager/Categories.vala"
	_tmp5_ = iter;
#line 482 "../src/font-manager/Categories.vala"
	gtk_tree_model_get_value (_tmp4_, &_tmp5_, 0, &_tmp6_);
#line 482 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 482 "../src/font-manager/Categories.vala"
	val = _tmp6_;
#line 483 "../src/font-manager/Categories.vala"
	_tmp7_ = model;
#line 483 "../src/font-manager/Categories.vala"
	_tmp8_ = iter;
#line 483 "../src/font-manager/Categories.vala"
	_tmp9_ = gtk_tree_model_get_path (_tmp7_, &_tmp8_);
#line 483 "../src/font-manager/Categories.vala"
	path = _tmp9_;
#line 484 "../src/font-manager/Categories.vala"
	_tmp10_ = val;
#line 484 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_selected_filter (self, g_value_get_object (&_tmp10_));
#line 485 "../src/font-manager/Categories.vala"
	g_value_unset (&val);
#line 486 "../src/font-manager/Categories.vala"
	_tmp11_ = self->priv->_selected_filter;
#line 486 "../src/font-manager/Categories.vala"
	if (_tmp11_ == NULL) {
#line 487 "../src/font-manager/Categories.vala"
		__vala_GtkTreePath_free0 (path);
#line 487 "../src/font-manager/Categories.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 487 "../src/font-manager/Categories.vala"
		_g_object_unref0 (model);
#line 487 "../src/font-manager/Categories.vala"
		return;
#line 3938 "Categories.c"
	}
#line 488 "../src/font-manager/Categories.vala"
	_tmp12_ = model;
#line 488 "../src/font-manager/Categories.vala"
	_tmp13_ = iter;
#line 488 "../src/font-manager/Categories.vala"
	_tmp14_ = gtk_tree_model_get_string_from_iter (_tmp12_, &_tmp13_);
#line 488 "../src/font-manager/Categories.vala"
	_tmp15_ = _tmp14_;
#line 488 "../src/font-manager/Categories.vala"
	font_manager_category_tree_set_selected_iter (self, _tmp15_);
#line 488 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp15_);
#line 489 "../src/font-manager/Categories.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda45__gsource_func, g_object_ref (self), g_object_unref);
#line 499 "../src/font-manager/Categories.vala"
	_tmp16_ = path;
#line 499 "../src/font-manager/Categories.vala"
	if (gtk_tree_path_get_depth (_tmp16_) < 2) {
#line 3958 "Categories.c"
		GtkTreeViewColumn* _tmp17_;
#line 500 "../src/font-manager/Categories.vala"
		gtk_tree_view_collapse_all ((GtkTreeView*) self);
#line 501 "../src/font-manager/Categories.vala"
		_tmp17_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
#line 501 "../src/font-manager/Categories.vala"
		gtk_tree_view_column_queue_resize (_tmp17_);
#line 3966 "Categories.c"
	}
#line 503 "../src/font-manager/Categories.vala"
	_tmp18_ = path;
#line 503 "../src/font-manager/Categories.vala"
	gtk_tree_view_expand_to_path ((GtkTreeView*) self, _tmp18_);
#line 506 "../src/font-manager/Categories.vala"
	_tmp20_ = self->priv->_selected_filter;
#line 506 "../src/font-manager/Categories.vala"
	if (_tmp20_ != NULL) {
#line 3976 "Categories.c"
		FontManagerCategory* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
#line 506 "../src/font-manager/Categories.vala"
		_tmp21_ = self->priv->_selected_filter;
#line 506 "../src/font-manager/Categories.vala"
		_tmp22_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp21_);
#line 506 "../src/font-manager/Categories.vala"
		_tmp23_ = _tmp22_;
#line 506 "../src/font-manager/Categories.vala"
		_tmp19_ = _tmp23_;
#line 3988 "Categories.c"
	} else {
#line 506 "../src/font-manager/Categories.vala"
		_tmp19_ = FALSE;
#line 3992 "Categories.c"
	}
#line 506 "../src/font-manager/Categories.vala"
	if (_tmp19_) {
#line 3996 "Categories.c"
		gboolean _tmp24_ = FALSE;
		FontManagerCategory* _tmp25_;
#line 507 "../src/font-manager/Categories.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda47__gsource_func, g_object_ref (self), g_object_unref);
#line 513 "../src/font-manager/Categories.vala"
		_tmp25_ = self->priv->_selected_filter;
#line 513 "../src/font-manager/Categories.vala"
		if (_tmp25_ != NULL) {
#line 4005 "Categories.c"
			FontManagerCategory* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
#line 513 "../src/font-manager/Categories.vala"
			_tmp26_ = self->priv->_selected_filter;
#line 513 "../src/font-manager/Categories.vala"
			_tmp27_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp26_);
#line 513 "../src/font-manager/Categories.vala"
			_tmp28_ = _tmp27_;
#line 513 "../src/font-manager/Categories.vala"
			_tmp24_ = _tmp28_ < ((gint) FONT_MANAGER_CATEGORY_INDEX_UNSORTED);
#line 4017 "Categories.c"
		} else {
#line 513 "../src/font-manager/Categories.vala"
			_tmp24_ = FALSE;
#line 4021 "Categories.c"
		}
#line 513 "../src/font-manager/Categories.vala"
		if (_tmp24_) {
#line 4025 "Categories.c"
			FontManagerCategory* _tmp29_;
#line 514 "../src/font-manager/Categories.vala"
			_tmp29_ = self->priv->_selected_filter;
#line 514 "../src/font-manager/Categories.vala"
			font_manager_category_update (_tmp29_, _____lambda48__gasync_ready_callback, g_object_ref (self));
#line 4031 "Categories.c"
		}
	}
#line 520 "../src/font-manager/Categories.vala"
	_tmp30_ = self->priv->_selected_filter;
#line 520 "../src/font-manager/Categories.vala"
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL], 0, _tmp30_);
#line 521 "../src/font-manager/Categories.vala"
	__vala_GtkTreePath_free0 (path);
#line 521 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 521 "../src/font-manager/Categories.vala"
	_g_object_unref0 (model);
#line 521 "../src/font-manager/Categories.vala"
	return;
#line 4046 "Categories.c"
}

FontManagerCategoryTree*
font_manager_category_tree_construct (GType object_type)
{
	FontManagerCategoryTree * self = NULL;
#line 313 "../src/font-manager/Categories.vala"
	self = (FontManagerCategoryTree*) font_manager_base_tree_view_construct (object_type);
#line 313 "../src/font-manager/Categories.vala"
	return self;
#line 4057 "Categories.c"
}

FontManagerCategoryTree*
font_manager_category_tree_new (void)
{
#line 313 "../src/font-manager/Categories.vala"
	return font_manager_category_tree_construct (FONT_MANAGER_TYPE_CATEGORY_TREE);
#line 4065 "Categories.c"
}

gboolean
font_manager_category_tree_get_update_in_progress (FontManagerCategoryTree* self)
{
	gboolean result;
#line 319 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 319 "../src/font-manager/Categories.vala"
	result = self->priv->_update_in_progress;
#line 319 "../src/font-manager/Categories.vala"
	return result;
#line 4078 "Categories.c"
}

void
font_manager_category_tree_set_update_in_progress (FontManagerCategoryTree* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 319 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_tree_get_update_in_progress (self);
#line 319 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 319 "../src/font-manager/Categories.vala"
		self->priv->_update_in_progress = value;
#line 319 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY]);
#line 4096 "Categories.c"
	}
}

const gchar*
font_manager_category_tree_get_selected_iter (FontManagerCategoryTree* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 321 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 321 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_selected_iter;
#line 321 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 321 "../src/font-manager/Categories.vala"
	return result;
#line 4113 "Categories.c"
}

void
font_manager_category_tree_set_selected_iter (FontManagerCategoryTree* self,
                                              const gchar* value)
{
	gchar* old_value;
#line 321 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_tree_get_selected_iter (self);
#line 321 "../src/font-manager/Categories.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4127 "Categories.c"
		gchar* _tmp0_;
#line 321 "../src/font-manager/Categories.vala"
		_tmp0_ = g_strdup (value);
#line 321 "../src/font-manager/Categories.vala"
		_g_free0 (self->priv->_selected_iter);
#line 321 "../src/font-manager/Categories.vala"
		self->priv->_selected_iter = _tmp0_;
#line 321 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY]);
#line 4137 "Categories.c"
	}
}

FontManagerCategory*
font_manager_category_tree_get_selected_filter (FontManagerCategoryTree* self)
{
	FontManagerCategory* result;
	FontManagerCategory* _tmp0_;
#line 322 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 322 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_selected_filter;
#line 322 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 322 "../src/font-manager/Categories.vala"
	return result;
#line 4154 "Categories.c"
}

void
font_manager_category_tree_set_selected_filter (FontManagerCategoryTree* self,
                                                FontManagerCategory* value)
{
	FontManagerCategory* old_value;
#line 322 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_tree_get_selected_filter (self);
#line 322 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 4168 "Categories.c"
		FontManagerCategory* _tmp0_;
#line 322 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 322 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_selected_filter);
#line 322 "../src/font-manager/Categories.vala"
		self->priv->_selected_filter = _tmp0_;
#line 322 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY]);
#line 4178 "Categories.c"
	}
}

FontManagerLanguageFilter*
font_manager_category_tree_get_language_filter (FontManagerCategoryTree* self)
{
	FontManagerLanguageFilter* result;
	FontManagerLanguageFilter* _tmp0_;
#line 323 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/font-manager/Categories.vala"
	_tmp0_ = self->priv->_language_filter;
#line 323 "../src/font-manager/Categories.vala"
	result = _tmp0_;
#line 323 "../src/font-manager/Categories.vala"
	return result;
#line 4195 "Categories.c"
}

void
font_manager_category_tree_set_language_filter (FontManagerCategoryTree* self,
                                                FontManagerLanguageFilter* value)
{
	FontManagerLanguageFilter* old_value;
#line 323 "../src/font-manager/Categories.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/font-manager/Categories.vala"
	old_value = font_manager_category_tree_get_language_filter (self);
#line 323 "../src/font-manager/Categories.vala"
	if (old_value != value) {
#line 4209 "Categories.c"
		FontManagerLanguageFilter* _tmp0_;
#line 323 "../src/font-manager/Categories.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 323 "../src/font-manager/Categories.vala"
		_g_object_unref0 (self->priv->_language_filter);
#line 323 "../src/font-manager/Categories.vala"
		self->priv->_language_filter = _tmp0_;
#line 323 "../src/font-manager/Categories.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY]);
#line 4219 "Categories.c"
	}
}

static void
_font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self)
{
#line 345 "../src/font-manager/Categories.vala"
	font_manager_category_tree_pixbuf_cell_data_func ((FontManagerCategoryTree*) self, tree_column, cell, tree_model, iter);
#line 4232 "Categories.c"
}

static void
_font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                          GtkCellRenderer* cell,
                                                                          GtkTreeModel* tree_model,
                                                                          GtkTreeIter* iter,
                                                                          gpointer self)
{
#line 347 "../src/font-manager/Categories.vala"
	font_manager_category_tree_count_cell_data_func ((FontManagerCategoryTree*) self, tree_column, cell, tree_model, iter);
#line 4244 "Categories.c"
}

static gboolean
_font_manager_category_tree___lambda60_ (FontManagerCategoryTree* self,
                                         GtkTreeView* t,
                                         GtkTreeIter* i,
                                         GtkTreePath* p)
{
	gboolean result;
#line 350 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (t != NULL, FALSE);
#line 350 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (i != NULL, FALSE);
#line 350 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 350 "../src/font-manager/Categories.vala"
	gtk_tree_view_collapse_all (t);
#line 350 "../src/font-manager/Categories.vala"
	result = GDK_EVENT_PROPAGATE;
#line 350 "../src/font-manager/Categories.vala"
	return result;
#line 4266 "Categories.c"
}

static gboolean
__font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row (GtkTreeView* _sender,
                                                                        GtkTreeIter* iter,
                                                                        GtkTreePath* path,
                                                                        gpointer self)
{
	gboolean result;
	result = _font_manager_category_tree___lambda60_ ((FontManagerCategoryTree*) self, _sender, iter, path);
#line 350 "../src/font-manager/Categories.vala"
	return result;
#line 4279 "Categories.c"
}

static GObject *
font_manager_category_tree_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerCategoryTree * self;
	GtkCellRendererText* _tmp0_;
	FontManagerCellRendererCount* _tmp1_;
	GtkCellRendererPixbuf* _tmp2_;
	GtkCellRendererPixbuf* _tmp3_;
	GtkCellRendererText* _tmp4_;
	GValue _tmp5_ = {0};
	GtkCellRendererText* _tmp6_;
	GValue _tmp7_ = {0};
	GtkCellRendererPixbuf* _tmp8_;
	GtkCellRendererText* _tmp9_;
	FontManagerCellRendererCount* _tmp10_;
	FontManagerCategoryModel* _tmp14_;
	FontManagerCategoryModel* _tmp15_;
#line 332 "../src/font-manager/Categories.vala"
	parent_class = G_OBJECT_CLASS (font_manager_category_tree_parent_class);
#line 332 "../src/font-manager/Categories.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 332 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
#line 333 "../src/font-manager/Categories.vala"
	gtk_widget_set_name ((GtkWidget*) self, "FontManagerCategoryTree");
#line 334 "../src/font-manager/Categories.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 335 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_level_indentation ((GtkTreeView*) self, 12);
#line 336 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
#line 337 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
#line 338 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_tooltip_column ((GtkTreeView*) self, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT);
#line 339 "../src/font-manager/Categories.vala"
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 339 "../src/font-manager/Categories.vala"
	g_object_ref_sink (_tmp0_);
#line 339 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->renderer);
#line 339 "../src/font-manager/Categories.vala"
	self->priv->renderer = _tmp0_;
#line 340 "../src/font-manager/Categories.vala"
	_tmp1_ = font_manager_cell_renderer_count_new ();
#line 340 "../src/font-manager/Categories.vala"
	g_object_ref_sink (_tmp1_);
#line 340 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->count_renderer);
#line 340 "../src/font-manager/Categories.vala"
	self->priv->count_renderer = _tmp1_;
#line 341 "../src/font-manager/Categories.vala"
	_tmp2_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 341 "../src/font-manager/Categories.vala"
	g_object_ref_sink (_tmp2_);
#line 341 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->pixbuf_renderer);
#line 341 "../src/font-manager/Categories.vala"
	self->priv->pixbuf_renderer = _tmp2_;
#line 342 "../src/font-manager/Categories.vala"
	_tmp3_ = self->priv->pixbuf_renderer;
#line 342 "../src/font-manager/Categories.vala"
	g_object_set ((GtkCellRenderer*) _tmp3_, "xpad", (guint) 2, NULL);
#line 343 "../src/font-manager/Categories.vala"
	_tmp4_ = self->priv->renderer;
#line 343 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp5_, pango_ellipsize_mode_get_type ());
#line 343 "../src/font-manager/Categories.vala"
	g_value_set_enum (&_tmp5_, PANGO_ELLIPSIZE_END);
#line 343 "../src/font-manager/Categories.vala"
	g_object_set_property ((GObject*) _tmp4_, "ellipsize", &_tmp5_);
#line 343 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
#line 344 "../src/font-manager/Categories.vala"
	_tmp6_ = self->priv->renderer;
#line 344 "../src/font-manager/Categories.vala"
	g_value_init (&_tmp7_, G_TYPE_BOOLEAN);
#line 344 "../src/font-manager/Categories.vala"
	g_value_set_boolean (&_tmp7_, TRUE);
#line 344 "../src/font-manager/Categories.vala"
	g_object_set_property ((GObject*) _tmp6_, "ellipsize-set", &_tmp7_);
#line 344 "../src/font-manager/Categories.vala"
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
#line 345 "../src/font-manager/Categories.vala"
	_tmp8_ = self->priv->pixbuf_renderer;
#line 345 "../src/font-manager/Categories.vala"
	gtk_tree_view_insert_column_with_data_func ((GtkTreeView*) self, 0, "", (GtkCellRenderer*) _tmp8_, _font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func, g_object_ref (self), g_object_unref);
#line 346 "../src/font-manager/Categories.vala"
	_tmp9_ = self->priv->renderer;
#line 346 "../src/font-manager/Categories.vala"
	gtk_tree_view_insert_column_with_attributes ((GtkTreeView*) self, 1, "", (GtkCellRenderer*) _tmp9_, "text", FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME, NULL, NULL);
#line 347 "../src/font-manager/Categories.vala"
	_tmp10_ = self->priv->count_renderer;
#line 347 "../src/font-manager/Categories.vala"
	gtk_tree_view_insert_column_with_data_func ((GtkTreeView*) self, 2, "", (GtkCellRenderer*) _tmp10_, _font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func, g_object_ref (self), g_object_unref);
#line 4381 "Categories.c"
	{
		gint i = 0;
#line 348 "../src/font-manager/Categories.vala"
		i = 0;
#line 4386 "Categories.c"
		{
			gboolean _tmp11_ = FALSE;
#line 348 "../src/font-manager/Categories.vala"
			_tmp11_ = TRUE;
#line 348 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 4393 "Categories.c"
				GtkTreeViewColumn* _tmp13_;
#line 348 "../src/font-manager/Categories.vala"
				if (!_tmp11_) {
#line 4397 "Categories.c"
					gint _tmp12_;
#line 348 "../src/font-manager/Categories.vala"
					_tmp12_ = i;
#line 348 "../src/font-manager/Categories.vala"
					i = _tmp12_ + 1;
#line 4403 "Categories.c"
				}
#line 348 "../src/font-manager/Categories.vala"
				_tmp11_ = FALSE;
#line 348 "../src/font-manager/Categories.vala"
				if (!(i < 3)) {
#line 348 "../src/font-manager/Categories.vala"
					break;
#line 4411 "Categories.c"
				}
#line 349 "../src/font-manager/Categories.vala"
				_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, i);
#line 349 "../src/font-manager/Categories.vala"
				gtk_tree_view_column_set_expand (_tmp13_, i == 1);
#line 4417 "Categories.c"
			}
		}
	}
#line 350 "../src/font-manager/Categories.vala"
	g_signal_connect_object ((GtkTreeView*) self, "test-expand-row", (GCallback) __font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row, self, 0);
#line 351 "../src/font-manager/Categories.vala"
	font_manager_category_tree_connect_signals (self);
#line 352 "../src/font-manager/Categories.vala"
	_tmp14_ = font_manager_category_model_new ();
#line 352 "../src/font-manager/Categories.vala"
	_tmp15_ = _tmp14_;
#line 352 "../src/font-manager/Categories.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp15_);
#line 352 "../src/font-manager/Categories.vala"
	_g_object_unref0 (_tmp15_);
#line 353 "../src/font-manager/Categories.vala"
	font_manager_category_tree_update (self);
#line 354 "../src/font-manager/Categories.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 332 "../src/font-manager/Categories.vala"
	return obj;
#line 4439 "Categories.c"
}

static void
font_manager_category_tree_class_init (FontManagerCategoryTreeClass * klass,
                                       gpointer klass_data)
{
#line 313 "../src/font-manager/Categories.vala"
	font_manager_category_tree_parent_class = g_type_class_peek_parent (klass);
#line 313 "../src/font-manager/Categories.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryTree_private_offset);
#line 313 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_category_tree_get_property;
#line 313 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_category_tree_set_property;
#line 313 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_category_tree_constructor;
#line 313 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_tree_finalize;
#line 313 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY] = g_param_spec_boolean ("update-in-progress", "update-in-progress", "update-in-progress", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 313 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY] = g_param_spec_string ("selected-iter", "selected-iter", "selected-iter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 313 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY] = g_param_spec_object ("selected-filter", "selected-filter", "selected-filter", FONT_MANAGER_TYPE_CATEGORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 313 "../src/font-manager/Categories.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY] = g_param_spec_object ("language-filter", "language-filter", "language-filter", FONT_MANAGER_TYPE_LANGUAGE_FILTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 313 "../src/font-manager/Categories.vala"
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 313 "../src/font-manager/Categories.vala"
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, FONT_MANAGER_TYPE_CATEGORY);
#line 313 "../src/font-manager/Categories.vala"
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL] = g_signal_new ("update-complete", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4472 "Categories.c"
}

static void
font_manager_category_tree_instance_init (FontManagerCategoryTree * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 313 "../src/font-manager/Categories.vala"
	self->priv = font_manager_category_tree_get_instance_private (self);
#line 319 "../src/font-manager/Categories.vala"
	self->priv->_update_in_progress = TRUE;
#line 321 "../src/font-manager/Categories.vala"
	_tmp0_ = g_strdup ("0");
#line 321 "../src/font-manager/Categories.vala"
	self->priv->_selected_iter = _tmp0_;
#line 322 "../src/font-manager/Categories.vala"
	self->priv->_selected_filter = NULL;
#line 323 "../src/font-manager/Categories.vala"
	self->priv->_language_filter = NULL;
#line 325 "../src/font-manager/Categories.vala"
	self->priv->change_timeout = NULL;
#line 326 "../src/font-manager/Categories.vala"
	self->priv->refresh_required = FALSE;
#line 4496 "Categories.c"
}

static void
font_manager_category_tree_finalize (GObject * obj)
{
	FontManagerCategoryTree * self;
#line 313 "../src/font-manager/Categories.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
#line 321 "../src/font-manager/Categories.vala"
	_g_free0 (self->priv->_selected_iter);
#line 322 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_selected_filter);
#line 323 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_language_filter);
#line 325 "../src/font-manager/Categories.vala"
	_g_free0 (self->priv->change_timeout);
#line 327 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->renderer);
#line 328 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->count_renderer);
#line 329 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->pixbuf_renderer);
#line 330 "../src/font-manager/Categories.vala"
	_g_object_unref0 (self->priv->_model_);
#line 313 "../src/font-manager/Categories.vala"
	G_OBJECT_CLASS (font_manager_category_tree_parent_class)->finalize (obj);
#line 4523 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_category_tree_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryTree), 0, (GInstanceInitFunc) font_manager_category_tree_instance_init, NULL };
	GType font_manager_category_tree_type_id;
	font_manager_category_tree_type_id = g_type_register_static (FONT_MANAGER_TYPE_BASE_TREE_VIEW, "FontManagerCategoryTree", &g_define_type_info, 0);
	FontManagerCategoryTree_private_offset = g_type_add_instance_private (font_manager_category_tree_type_id, sizeof (FontManagerCategoryTreePrivate));
	return font_manager_category_tree_type_id;
}

GType
font_manager_category_tree_get_type (void)
{
	static volatile gsize font_manager_category_tree_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_tree_type_id__once)) {
		GType font_manager_category_tree_type_id;
		font_manager_category_tree_type_id = font_manager_category_tree_get_type_once ();
		g_once_init_leave (&font_manager_category_tree_type_id__once, font_manager_category_tree_type_id);
	}
	return font_manager_category_tree_type_id__once;
}

static void
_vala_font_manager_category_tree_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	FontManagerCategoryTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
#line 313 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		g_value_set_boolean (value, font_manager_category_tree_get_update_in_progress (self));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		g_value_set_string (value, font_manager_category_tree_get_selected_iter (self));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_tree_get_selected_filter (self));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		g_value_set_object (value, font_manager_category_tree_get_language_filter (self));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 4582 "Categories.c"
		default:
#line 313 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 4588 "Categories.c"
	}
}

static void
_vala_font_manager_category_tree_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	FontManagerCategoryTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
#line 313 "../src/font-manager/Categories.vala"
	switch (property_id) {
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		font_manager_category_tree_set_update_in_progress (self, g_value_get_boolean (value));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		font_manager_category_tree_set_selected_iter (self, g_value_get_string (value));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		font_manager_category_tree_set_selected_filter (self, g_value_get_object (value));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 313 "../src/font-manager/Categories.vala"
		case FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY:
#line 313 "../src/font-manager/Categories.vala"
		font_manager_category_tree_set_language_filter (self, g_value_get_object (value));
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 4626 "Categories.c"
		default:
#line 313 "../src/font-manager/Categories.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 313 "../src/font-manager/Categories.vala"
		break;
#line 4632 "Categories.c"
	}
}

void
font_manager_filter_data_copy (const FontManagerFilterData* self,
                               FontManagerFilterData* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 526 "../src/font-manager/Categories.vala"
	(*dest).index = (*self).index;
#line 526 "../src/font-manager/Categories.vala"
	_tmp0_ = (*self).name;
#line 526 "../src/font-manager/Categories.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 526 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).name);
#line 526 "../src/font-manager/Categories.vala"
	(*dest).name = _tmp1_;
#line 526 "../src/font-manager/Categories.vala"
	_tmp2_ = (*self).comment;
#line 526 "../src/font-manager/Categories.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 526 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).comment);
#line 526 "../src/font-manager/Categories.vala"
	(*dest).comment = _tmp3_;
#line 526 "../src/font-manager/Categories.vala"
	_tmp4_ = (*self).column;
#line 526 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 526 "../src/font-manager/Categories.vala"
	_g_free0 ((*dest).column);
#line 526 "../src/font-manager/Categories.vala"
	(*dest).column = _tmp5_;
#line 4672 "Categories.c"
}

void
font_manager_filter_data_destroy (FontManagerFilterData* self)
{
#line 528 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).name);
#line 529 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).comment);
#line 530 "../src/font-manager/Categories.vala"
	_g_free0 ((*self).column);
#line 4684 "Categories.c"
}

FontManagerFilterData*
font_manager_filter_data_dup (const FontManagerFilterData* self)
{
	FontManagerFilterData* dup;
#line 526 "../src/font-manager/Categories.vala"
	dup = g_new0 (FontManagerFilterData, 1);
#line 526 "../src/font-manager/Categories.vala"
	font_manager_filter_data_copy (self, dup);
#line 526 "../src/font-manager/Categories.vala"
	return dup;
#line 4697 "Categories.c"
}

void
font_manager_filter_data_free (FontManagerFilterData* self)
{
#line 526 "../src/font-manager/Categories.vala"
	font_manager_filter_data_destroy (self);
#line 526 "../src/font-manager/Categories.vala"
	g_free (self);
#line 4707 "Categories.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_filter_data_get_type_once (void)
{
	GType font_manager_filter_data_type_id;
	font_manager_filter_data_type_id = g_boxed_type_register_static ("FontManagerFilterData", (GBoxedCopyFunc) font_manager_filter_data_dup, (GBoxedFreeFunc) font_manager_filter_data_free);
	return font_manager_filter_data_type_id;
}

GType
font_manager_filter_data_get_type (void)
{
	static volatile gsize font_manager_filter_data_type_id__once = 0;
	if (g_once_init_enter (&font_manager_filter_data_type_id__once)) {
		GType font_manager_filter_data_type_id;
		font_manager_filter_data_type_id = font_manager_filter_data_get_type_once ();
		g_once_init_leave (&font_manager_filter_data_type_id__once, font_manager_filter_data_type_id);
	}
	return font_manager_filter_data_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 550 "../src/font-manager/Categories.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4735 "Categories.c"
}

GPtrArray*
font_manager_get_default_categories (FontManagerDatabase* db)
{
	GPtrArray* filters = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FontManagerCategory* _tmp4_;
	GPtrArray* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	FontManagerCategory* _tmp8_;
	GPtrArray* _tmp9_;
	FontManagerUserFonts* _tmp10_;
	GPtrArray* _tmp11_;
	FontManagerCategory* _tmp12_;
	GPtrArray* _tmp19_;
	FontManagerUnsorted* _tmp20_;
	GPtrArray* _tmp21_;
	FontManagerDisabled* _tmp22_;
	GPtrArray* _tmp23_;
	FontManagerLanguageFilter* _tmp24_;
	GPtrArray* result;
#line 549 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 550 "../src/font-manager/Categories.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 550 "../src/font-manager/Categories.vala"
	filters = _tmp0_;
#line 551 "../src/font-manager/Categories.vala"
	_tmp1_ = filters;
#line 551 "../src/font-manager/Categories.vala"
	_tmp2_ = g_strdup_printf ("%s;", FONT_MANAGER_SELECT_FROM_FONTS);
#line 551 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 551 "../src/font-manager/Categories.vala"
	_tmp4_ = font_manager_category_new (_ ("All"), _ ("All Fonts"), "format-text-bold-symbolic", _tmp3_, (gint) FONT_MANAGER_CATEGORY_INDEX_ALL);
#line 551 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp1_, _tmp4_);
#line 551 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp3_);
#line 552 "../src/font-manager/Categories.vala"
	_tmp5_ = filters;
#line 552 "../src/font-manager/Categories.vala"
	_tmp6_ = g_strdup_printf ("%s owner!=0 AND filepath LIKE '/usr%';", FONT_MANAGER_SELECT_FROM_METADATA_WHERE);
#line 552 "../src/font-manager/Categories.vala"
	_tmp7_ = _tmp6_;
#line 552 "../src/font-manager/Categories.vala"
	_tmp8_ = font_manager_category_new (_ ("System"), _ ("Fonts available to all users"), "computer-symbolic", _tmp7_, (gint) FONT_MANAGER_CATEGORY_INDEX_SYSTEM);
#line 552 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp5_, _tmp8_);
#line 552 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp7_);
#line 553 "../src/font-manager/Categories.vala"
	_tmp9_ = filters;
#line 553 "../src/font-manager/Categories.vala"
	_tmp10_ = font_manager_user_fonts_new ();
#line 553 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp9_, (FontManagerCategory*) _tmp10_);
#line 554 "../src/font-manager/Categories.vala"
	_tmp11_ = filters;
#line 554 "../src/font-manager/Categories.vala"
	_tmp12_ = font_manager_construct_panose_filter ();
#line 554 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp11_, _tmp12_);
#line 4804 "Categories.c"
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 555 "../src/font-manager/Categories.vala"
		entry_collection = FONT_MANAGER_attributes;
#line 555 "../src/font-manager/Categories.vala"
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_attributes);
#line 555 "../src/font-manager/Categories.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 4816 "Categories.c"
			FontManagerFilterData entry = {0};
#line 555 "../src/font-manager/Categories.vala"
			entry = entry_collection[entry_it];
#line 4820 "Categories.c"
			{
				GPtrArray* _tmp13_;
				FontManagerFilterData _tmp14_;
				FontManagerCategory* _tmp15_;
#line 556 "../src/font-manager/Categories.vala"
				_tmp13_ = filters;
#line 556 "../src/font-manager/Categories.vala"
				_tmp14_ = entry;
#line 556 "../src/font-manager/Categories.vala"
				_tmp15_ = font_manager_construct_attribute_filter (db, &_tmp14_);
#line 556 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp13_, _tmp15_);
#line 4833 "Categories.c"
			}
		}
	}
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 557 "../src/font-manager/Categories.vala"
		entry_collection = FONT_MANAGER_metadata;
#line 557 "../src/font-manager/Categories.vala"
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_metadata);
#line 557 "../src/font-manager/Categories.vala"
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
#line 4848 "Categories.c"
			FontManagerFilterData entry = {0};
#line 557 "../src/font-manager/Categories.vala"
			entry = entry_collection[entry_it];
#line 4852 "Categories.c"
			{
				GPtrArray* _tmp16_;
				FontManagerFilterData _tmp17_;
				FontManagerCategory* _tmp18_;
#line 558 "../src/font-manager/Categories.vala"
				_tmp16_ = filters;
#line 558 "../src/font-manager/Categories.vala"
				_tmp17_ = entry;
#line 558 "../src/font-manager/Categories.vala"
				_tmp18_ = font_manager_construct_info_filter (db, &_tmp17_);
#line 558 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp16_, _tmp18_);
#line 4865 "Categories.c"
			}
		}
	}
#line 559 "../src/font-manager/Categories.vala"
	_tmp19_ = filters;
#line 559 "../src/font-manager/Categories.vala"
	_tmp20_ = font_manager_unsorted_new ();
#line 559 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp19_, (FontManagerCategory*) _tmp20_);
#line 560 "../src/font-manager/Categories.vala"
	_tmp21_ = filters;
#line 560 "../src/font-manager/Categories.vala"
	_tmp22_ = font_manager_disabled_new ();
#line 560 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp21_, (FontManagerCategory*) _tmp22_);
#line 561 "../src/font-manager/Categories.vala"
	_tmp23_ = filters;
#line 561 "../src/font-manager/Categories.vala"
	_tmp24_ = font_manager_language_filter_new ();
#line 561 "../src/font-manager/Categories.vala"
	g_ptr_array_add (_tmp23_, (FontManagerCategory*) _tmp24_);
#line 562 "../src/font-manager/Categories.vala"
	result = filters;
#line 562 "../src/font-manager/Categories.vala"
	return result;
#line 4891 "Categories.c"
}

FontManagerCategory*
font_manager_construct_panose_filter (void)
{
	FontManagerCategory* panose = NULL;
	FontManagerCategory* _tmp0_;
	gchar** kind = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint kind_length1;
	gint _kind_size_;
	FontManagerCategory* result;
#line 566 "../src/font-manager/Categories.vala"
	_tmp0_ = font_manager_category_new (_ ("Family Kind"), _ ("Only fonts which include Panose information will be grouped here."), "folder-symbolic", NULL, (gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE);
#line 566 "../src/font-manager/Categories.vala"
	panose = _tmp0_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp1_ = g_strdup (_ ("Any"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp2_ = g_strdup (_ ("No Fit"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp3_ = g_strdup (_ ("Text and Display"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp4_ = g_strdup (_ ("Script"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (_ ("Decorative"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp6_ = g_strdup (_ ("Pictorial"));
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_ = g_new0 (gchar*, 6 + 1);
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[0] = _tmp1_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[1] = _tmp2_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[2] = _tmp3_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[3] = _tmp4_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[4] = _tmp5_;
#line 567 "../src/font-manager/Categories.vala"
	_tmp7_[5] = _tmp6_;
#line 567 "../src/font-manager/Categories.vala"
	kind = _tmp7_;
#line 567 "../src/font-manager/Categories.vala"
	kind_length1 = 6;
#line 567 "../src/font-manager/Categories.vala"
	_kind_size_ = kind_length1;
#line 4946 "Categories.c"
	{
		gint i = 0;
#line 568 "../src/font-manager/Categories.vala"
		i = 0;
#line 4951 "Categories.c"
		{
			gboolean _tmp8_ = FALSE;
#line 568 "../src/font-manager/Categories.vala"
			_tmp8_ = TRUE;
#line 568 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 4958 "Categories.c"
				gchar** _tmp10_;
				gint _tmp10__length1;
				FontManagerCategory* _tmp11_;
				GPtrArray* _tmp12_;
				GPtrArray* _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				FontManagerCategory* _tmp20_;
#line 568 "../src/font-manager/Categories.vala"
				if (!_tmp8_) {
#line 4975 "Categories.c"
					gint _tmp9_;
#line 568 "../src/font-manager/Categories.vala"
					_tmp9_ = i;
#line 568 "../src/font-manager/Categories.vala"
					i = _tmp9_ + 1;
#line 4981 "Categories.c"
				}
#line 568 "../src/font-manager/Categories.vala"
				_tmp8_ = FALSE;
#line 568 "../src/font-manager/Categories.vala"
				_tmp10_ = kind;
#line 568 "../src/font-manager/Categories.vala"
				_tmp10__length1 = kind_length1;
#line 568 "../src/font-manager/Categories.vala"
				if (!(i < _tmp10__length1)) {
#line 568 "../src/font-manager/Categories.vala"
					break;
#line 4993 "Categories.c"
				}
#line 569 "../src/font-manager/Categories.vala"
				_tmp11_ = panose;
#line 569 "../src/font-manager/Categories.vala"
				_tmp12_ = font_manager_category_get_children (_tmp11_);
#line 569 "../src/font-manager/Categories.vala"
				_tmp13_ = _tmp12_;
#line 569 "../src/font-manager/Categories.vala"
				_tmp14_ = kind;
#line 569 "../src/font-manager/Categories.vala"
				_tmp14__length1 = kind_length1;
#line 569 "../src/font-manager/Categories.vala"
				_tmp15_ = _tmp14_[i];
#line 569 "../src/font-manager/Categories.vala"
				_tmp16_ = kind;
#line 569 "../src/font-manager/Categories.vala"
				_tmp16__length1 = kind_length1;
#line 569 "../src/font-manager/Categories.vala"
				_tmp17_ = _tmp16_[i];
#line 569 "../src/font-manager/Categories.vala"
				_tmp18_ = g_strdup_printf ("%s P0 = '%i';", FONT_MANAGER_SELECT_FROM_PANOSE_WHERE, i);
#line 569 "../src/font-manager/Categories.vala"
				_tmp19_ = _tmp18_;
#line 569 "../src/font-manager/Categories.vala"
				_tmp20_ = font_manager_category_new (_tmp15_, _tmp17_, "emblem-documents-symbolic", _tmp19_, i);
#line 569 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp13_, _tmp20_);
#line 569 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp19_);
#line 5023 "Categories.c"
			}
		}
	}
#line 570 "../src/font-manager/Categories.vala"
	result = panose;
#line 570 "../src/font-manager/Categories.vala"
	kind = (_vala_array_free (kind, kind_length1, (GDestroyNotify) g_free), NULL);
#line 570 "../src/font-manager/Categories.vala"
	return result;
#line 5033 "Categories.c"
}

FontManagerCategory*
font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                         FontManagerFilterData* data)
{
	gchar* name = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	FontManagerFilterData _tmp8_;
	FontManagerCategory* _tmp9_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
#line 573 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 573 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 574 "../src/font-manager/Categories.vala"
	_tmp0_ = *data;
#line 574 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_.name;
#line 574 "../src/font-manager/Categories.vala"
	_tmp2_ = g_strdup (g_dgettext (NULL, _tmp1_));
#line 574 "../src/font-manager/Categories.vala"
	name = _tmp2_;
#line 575 "../src/font-manager/Categories.vala"
	_tmp3_ = *data;
#line 575 "../src/font-manager/Categories.vala"
	_tmp4_ = _tmp3_.comment;
#line 575 "../src/font-manager/Categories.vala"
	_tmp5_ = g_strdup (g_dgettext (NULL, _tmp4_));
#line 575 "../src/font-manager/Categories.vala"
	comment = _tmp5_;
#line 576 "../src/font-manager/Categories.vala"
	_tmp6_ = name;
#line 576 "../src/font-manager/Categories.vala"
	_tmp7_ = comment;
#line 576 "../src/font-manager/Categories.vala"
	_tmp8_ = *data;
#line 576 "../src/font-manager/Categories.vala"
	_tmp9_ = font_manager_category_new (_tmp6_, _tmp7_, "folder-symbolic", NULL, _tmp8_.index);
#line 576 "../src/font-manager/Categories.vala"
	filter = _tmp9_;
#line 5085 "Categories.c"
	{
		gchar* keyword = NULL;
		FontManagerFilterData _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 578 "../src/font-manager/Categories.vala"
		_tmp10_ = *data;
#line 578 "../src/font-manager/Categories.vala"
		_tmp11_ = _tmp10_.column;
#line 578 "../src/font-manager/Categories.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 578 "../src/font-manager/Categories.vala"
		keyword = _tmp12_;
#line 579 "../src/font-manager/Categories.vala"
		_tmp13_ = keyword;
#line 579 "../src/font-manager/Categories.vala"
		_tmp14_ = keyword;
#line 579 "../src/font-manager/Categories.vala"
		_tmp15_ = g_strdup_printf ("SELECT DISTINCT %s FROM Fonts ORDER BY %s;", _tmp13_, _tmp14_);
#line 579 "../src/font-manager/Categories.vala"
		_tmp16_ = _tmp15_;
#line 579 "../src/font-manager/Categories.vala"
		font_manager_database_execute_query (db, _tmp16_, &_inner_error0_);
#line 579 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp16_);
#line 579 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 579 "../src/font-manager/Categories.vala"
			_g_free0 (keyword);
#line 579 "../src/font-manager/Categories.vala"
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 5121 "Categories.c"
				goto __catch0_font_manager_database_error;
			}
#line 579 "../src/font-manager/Categories.vala"
			_g_object_unref0 (filter);
#line 579 "../src/font-manager/Categories.vala"
			_g_free0 (comment);
#line 579 "../src/font-manager/Categories.vala"
			_g_free0 (name);
#line 579 "../src/font-manager/Categories.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 579 "../src/font-manager/Categories.vala"
			g_clear_error (&_inner_error0_);
#line 579 "../src/font-manager/Categories.vala"
			return NULL;
#line 5136 "Categories.c"
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp17_;
#line 580 "../src/font-manager/Categories.vala"
			_tmp17_ = font_manager_database_iterator (db);
#line 580 "../src/font-manager/Categories.vala"
			_row_it = _tmp17_;
#line 580 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 5147 "Categories.c"
				FontManagerDatabaseIterator* _tmp18_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp19_;
				sqlite3_stmt* _tmp20_;
				gint val = 0;
				sqlite3_stmt* _tmp21_;
				gchar* type = NULL;
				const gchar* _tmp22_;
				const gchar* _tmp34_;
				FontManagerCategory* _tmp45_;
				GPtrArray* _tmp46_;
				GPtrArray* _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				FontManagerFilterData _tmp53_;
				FontManagerCategory* _tmp54_;
#line 580 "../src/font-manager/Categories.vala"
				_tmp18_ = _row_it;
#line 580 "../src/font-manager/Categories.vala"
				if (!font_manager_database_iterator_next (_tmp18_)) {
#line 580 "../src/font-manager/Categories.vala"
					break;
#line 5173 "Categories.c"
				}
#line 580 "../src/font-manager/Categories.vala"
				_tmp19_ = _row_it;
#line 580 "../src/font-manager/Categories.vala"
				_tmp20_ = font_manager_database_iterator_get (_tmp19_);
#line 580 "../src/font-manager/Categories.vala"
				row = _tmp20_;
#line 581 "../src/font-manager/Categories.vala"
				_tmp21_ = row;
#line 581 "../src/font-manager/Categories.vala"
				val = sqlite3_column_int (_tmp21_, 0);
#line 582 "../src/font-manager/Categories.vala"
				type = NULL;
#line 583 "../src/font-manager/Categories.vala"
				_tmp22_ = keyword;
#line 583 "../src/font-manager/Categories.vala"
				if (g_strcmp0 (_tmp22_, "slant") == 0) {
#line 5191 "Categories.c"
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 584 "../src/font-manager/Categories.vala"
					_tmp23_ = font_manager_slant_to_string ((FontManagerSlant) val);
#line 584 "../src/font-manager/Categories.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 584 "../src/font-manager/Categories.vala"
					_g_free0 (type);
#line 584 "../src/font-manager/Categories.vala"
					type = _tmp24_;
#line 5202 "Categories.c"
				} else {
					const gchar* _tmp25_;
#line 585 "../src/font-manager/Categories.vala"
					_tmp25_ = keyword;
#line 585 "../src/font-manager/Categories.vala"
					if (g_strcmp0 (_tmp25_, "spacing") == 0) {
#line 5209 "Categories.c"
						const gchar* _tmp26_;
						gchar* _tmp27_;
#line 586 "../src/font-manager/Categories.vala"
						_tmp26_ = font_manager_spacing_to_string ((FontManagerSpacing) val);
#line 586 "../src/font-manager/Categories.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 586 "../src/font-manager/Categories.vala"
						_g_free0 (type);
#line 586 "../src/font-manager/Categories.vala"
						type = _tmp27_;
#line 5220 "Categories.c"
					} else {
						const gchar* _tmp28_;
#line 587 "../src/font-manager/Categories.vala"
						_tmp28_ = keyword;
#line 587 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp28_, "weight") == 0) {
#line 5227 "Categories.c"
							const gchar* _tmp29_;
							gchar* _tmp30_;
#line 588 "../src/font-manager/Categories.vala"
							_tmp29_ = font_manager_weight_to_string ((FontManagerWeight) val);
#line 588 "../src/font-manager/Categories.vala"
							_tmp30_ = g_strdup (_tmp29_);
#line 588 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 588 "../src/font-manager/Categories.vala"
							type = _tmp30_;
#line 5238 "Categories.c"
						} else {
							const gchar* _tmp31_;
#line 589 "../src/font-manager/Categories.vala"
							_tmp31_ = keyword;
#line 589 "../src/font-manager/Categories.vala"
							if (g_strcmp0 (_tmp31_, "width") == 0) {
#line 5245 "Categories.c"
								const gchar* _tmp32_;
								gchar* _tmp33_;
#line 590 "../src/font-manager/Categories.vala"
								_tmp32_ = font_manager_width_to_string ((FontManagerWidth) val);
#line 590 "../src/font-manager/Categories.vala"
								_tmp33_ = g_strdup (_tmp32_);
#line 590 "../src/font-manager/Categories.vala"
								_g_free0 (type);
#line 590 "../src/font-manager/Categories.vala"
								type = _tmp33_;
#line 5256 "Categories.c"
							}
						}
					}
				}
#line 591 "../src/font-manager/Categories.vala"
				_tmp34_ = type;
#line 591 "../src/font-manager/Categories.vala"
				if (_tmp34_ == NULL) {
#line 5265 "Categories.c"
					gboolean _tmp35_ = FALSE;
					const gchar* _tmp36_;
#line 592 "../src/font-manager/Categories.vala"
					_tmp36_ = keyword;
#line 592 "../src/font-manager/Categories.vala"
					if (g_strcmp0 (_tmp36_, "slant") == 0) {
#line 592 "../src/font-manager/Categories.vala"
						_tmp35_ = TRUE;
#line 5274 "Categories.c"
					} else {
						gboolean _tmp37_ = FALSE;
						const gchar* _tmp38_;
#line 592 "../src/font-manager/Categories.vala"
						_tmp38_ = keyword;
#line 592 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp38_, "width") == 0) {
#line 592 "../src/font-manager/Categories.vala"
							_tmp37_ = font_manager_width_defined ((FontManagerWidth) val);
#line 5284 "Categories.c"
						} else {
#line 592 "../src/font-manager/Categories.vala"
							_tmp37_ = FALSE;
#line 5288 "Categories.c"
						}
#line 592 "../src/font-manager/Categories.vala"
						_tmp35_ = _tmp37_;
#line 5292 "Categories.c"
					}
#line 592 "../src/font-manager/Categories.vala"
					if (_tmp35_) {
#line 5296 "Categories.c"
						gchar* _tmp39_;
#line 593 "../src/font-manager/Categories.vala"
						_tmp39_ = g_strdup (_ ("Normal"));
#line 593 "../src/font-manager/Categories.vala"
						_g_free0 (type);
#line 593 "../src/font-manager/Categories.vala"
						type = _tmp39_;
#line 5304 "Categories.c"
					} else {
						gboolean _tmp40_ = FALSE;
						const gchar* _tmp41_;
#line 595 "../src/font-manager/Categories.vala"
						_tmp41_ = keyword;
#line 595 "../src/font-manager/Categories.vala"
						if (g_strcmp0 (_tmp41_, "width") == 0) {
#line 595 "../src/font-manager/Categories.vala"
							_tmp40_ = TRUE;
#line 5314 "Categories.c"
						} else {
							gboolean _tmp42_ = FALSE;
							const gchar* _tmp43_;
#line 595 "../src/font-manager/Categories.vala"
							_tmp43_ = keyword;
#line 595 "../src/font-manager/Categories.vala"
							if (g_strcmp0 (_tmp43_, "weight") == 0) {
#line 595 "../src/font-manager/Categories.vala"
								_tmp42_ = !font_manager_weight_defined ((FontManagerWeight) val);
#line 5324 "Categories.c"
							} else {
#line 595 "../src/font-manager/Categories.vala"
								_tmp42_ = FALSE;
#line 5328 "Categories.c"
							}
#line 595 "../src/font-manager/Categories.vala"
							_tmp40_ = _tmp42_;
#line 5332 "Categories.c"
						}
#line 595 "../src/font-manager/Categories.vala"
						if (_tmp40_) {
#line 596 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 596 "../src/font-manager/Categories.vala"
							continue;
#line 5340 "Categories.c"
						} else {
							gchar* _tmp44_;
#line 598 "../src/font-manager/Categories.vala"
							_tmp44_ = g_strdup (_ ("Regular"));
#line 598 "../src/font-manager/Categories.vala"
							_g_free0 (type);
#line 598 "../src/font-manager/Categories.vala"
							type = _tmp44_;
#line 5349 "Categories.c"
						}
					}
				}
#line 599 "../src/font-manager/Categories.vala"
				_tmp45_ = filter;
#line 599 "../src/font-manager/Categories.vala"
				_tmp46_ = font_manager_category_get_children (_tmp45_);
#line 599 "../src/font-manager/Categories.vala"
				_tmp47_ = _tmp46_;
#line 599 "../src/font-manager/Categories.vala"
				_tmp48_ = type;
#line 599 "../src/font-manager/Categories.vala"
				_tmp49_ = type;
#line 599 "../src/font-manager/Categories.vala"
				_tmp50_ = keyword;
#line 599 "../src/font-manager/Categories.vala"
				_tmp51_ = g_strdup_printf ("%s WHERE %s=\"%i\";", FONT_MANAGER_SELECT_FROM_FONTS, _tmp50_, val);
#line 599 "../src/font-manager/Categories.vala"
				_tmp52_ = _tmp51_;
#line 599 "../src/font-manager/Categories.vala"
				_tmp53_ = *data;
#line 599 "../src/font-manager/Categories.vala"
				_tmp54_ = font_manager_category_new (_tmp48_, _tmp49_, "emblem-documents-symbolic", _tmp52_, _tmp53_.index);
#line 599 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp47_, _tmp54_);
#line 599 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp52_);
#line 580 "../src/font-manager/Categories.vala"
				_g_free0 (type);
#line 5379 "Categories.c"
			}
#line 580 "../src/font-manager/Categories.vala"
			_g_object_unref0 (_row_it);
#line 5383 "Categories.c"
		}
#line 577 "../src/font-manager/Categories.vala"
		_g_free0 (keyword);
#line 5387 "Categories.c"
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
#line 577 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 5394 "Categories.c"
	}
	__finally0:
#line 577 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "../src/font-manager/Categories.vala"
		_g_object_unref0 (filter);
#line 577 "../src/font-manager/Categories.vala"
		_g_free0 (comment);
#line 577 "../src/font-manager/Categories.vala"
		_g_free0 (name);
#line 577 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 577 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 577 "../src/font-manager/Categories.vala"
		return NULL;
#line 5411 "Categories.c"
	}
#line 602 "../src/font-manager/Categories.vala"
	result = filter;
#line 602 "../src/font-manager/Categories.vala"
	_g_free0 (comment);
#line 602 "../src/font-manager/Categories.vala"
	_g_free0 (name);
#line 602 "../src/font-manager/Categories.vala"
	return result;
#line 5421 "Categories.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 5443 "Categories.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 5447 "Categories.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 5453 "Categories.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 5457 "Categories.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 5461 "Categories.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 5469 "Categories.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5497 "Categories.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 5506 "Categories.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5520 "Categories.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 5529 "Categories.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 5543 "Categories.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 5552 "Categories.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 5561 "Categories.c"
}

FontManagerCategory*
font_manager_construct_info_filter (FontManagerDatabase* db,
                                    FontManagerFilterData* data)
{
	gchar* keyword = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* name = NULL;
	FontManagerFilterData _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	FontManagerFilterData _tmp14_;
	FontManagerCategory* _tmp15_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
#line 605 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (db != NULL, NULL);
#line 605 "../src/font-manager/Categories.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 606 "../src/font-manager/Categories.vala"
	_tmp0_ = *data;
#line 606 "../src/font-manager/Categories.vala"
	_tmp1_ = _tmp0_.column;
#line 606 "../src/font-manager/Categories.vala"
	_tmp2_ = string_replace (_tmp1_, "\"", "\\\"");
#line 606 "../src/font-manager/Categories.vala"
	_tmp3_ = _tmp2_;
#line 606 "../src/font-manager/Categories.vala"
	_tmp4_ = string_replace (_tmp3_, "'", "''");
#line 606 "../src/font-manager/Categories.vala"
	_tmp5_ = _tmp4_;
#line 606 "../src/font-manager/Categories.vala"
	_g_free0 (_tmp3_);
#line 606 "../src/font-manager/Categories.vala"
	keyword = _tmp5_;
#line 607 "../src/font-manager/Categories.vala"
	_tmp6_ = *data;
#line 607 "../src/font-manager/Categories.vala"
	_tmp7_ = _tmp6_.name;
#line 607 "../src/font-manager/Categories.vala"
	_tmp8_ = g_strdup (g_dgettext (NULL, _tmp7_));
#line 607 "../src/font-manager/Categories.vala"
	name = _tmp8_;
#line 608 "../src/font-manager/Categories.vala"
	_tmp9_ = *data;
#line 608 "../src/font-manager/Categories.vala"
	_tmp10_ = _tmp9_.comment;
#line 608 "../src/font-manager/Categories.vala"
	_tmp11_ = g_strdup (g_dgettext (NULL, _tmp10_));
#line 608 "../src/font-manager/Categories.vala"
	comment = _tmp11_;
#line 609 "../src/font-manager/Categories.vala"
	_tmp12_ = name;
#line 609 "../src/font-manager/Categories.vala"
	_tmp13_ = comment;
#line 609 "../src/font-manager/Categories.vala"
	_tmp14_ = *data;
#line 609 "../src/font-manager/Categories.vala"
	_tmp15_ = font_manager_category_new (_tmp12_, _tmp13_, "folder-symbolic", NULL, _tmp14_.index);
#line 609 "../src/font-manager/Categories.vala"
	filter = _tmp15_;
#line 5636 "Categories.c"
	{
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 611 "../src/font-manager/Categories.vala"
		_tmp16_ = keyword;
#line 611 "../src/font-manager/Categories.vala"
		_tmp17_ = keyword;
#line 611 "../src/font-manager/Categories.vala"
		_tmp18_ = g_strdup_printf ("SELECT DISTINCT [%s] FROM Metadata ORDER BY [%s];", _tmp16_, _tmp17_);
#line 611 "../src/font-manager/Categories.vala"
		_tmp19_ = _tmp18_;
#line 611 "../src/font-manager/Categories.vala"
		font_manager_database_execute_query (db, _tmp19_, &_inner_error0_);
#line 611 "../src/font-manager/Categories.vala"
		_g_free0 (_tmp19_);
#line 611 "../src/font-manager/Categories.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 611 "../src/font-manager/Categories.vala"
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 5658 "Categories.c"
				goto __catch0_font_manager_database_error;
			}
#line 611 "../src/font-manager/Categories.vala"
			_g_object_unref0 (filter);
#line 611 "../src/font-manager/Categories.vala"
			_g_free0 (comment);
#line 611 "../src/font-manager/Categories.vala"
			_g_free0 (name);
#line 611 "../src/font-manager/Categories.vala"
			_g_free0 (keyword);
#line 611 "../src/font-manager/Categories.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 611 "../src/font-manager/Categories.vala"
			g_clear_error (&_inner_error0_);
#line 611 "../src/font-manager/Categories.vala"
			return NULL;
#line 5675 "Categories.c"
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp20_;
#line 612 "../src/font-manager/Categories.vala"
			_tmp20_ = font_manager_database_iterator (db);
#line 612 "../src/font-manager/Categories.vala"
			_row_it = _tmp20_;
#line 612 "../src/font-manager/Categories.vala"
			while (TRUE) {
#line 5686 "Categories.c"
				FontManagerDatabaseIterator* _tmp21_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp22_;
				sqlite3_stmt* _tmp23_;
				gchar* _type = NULL;
				sqlite3_stmt* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* type = NULL;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				FontManagerCategory* _tmp29_;
				GPtrArray* _tmp30_;
				GPtrArray* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				FontManagerFilterData _tmp38_;
				FontManagerCategory* _tmp39_;
#line 612 "../src/font-manager/Categories.vala"
				_tmp21_ = _row_it;
#line 612 "../src/font-manager/Categories.vala"
				if (!font_manager_database_iterator_next (_tmp21_)) {
#line 612 "../src/font-manager/Categories.vala"
					break;
#line 5715 "Categories.c"
				}
#line 612 "../src/font-manager/Categories.vala"
				_tmp22_ = _row_it;
#line 612 "../src/font-manager/Categories.vala"
				_tmp23_ = font_manager_database_iterator_get (_tmp22_);
#line 612 "../src/font-manager/Categories.vala"
				row = _tmp23_;
#line 613 "../src/font-manager/Categories.vala"
				_tmp24_ = row;
#line 613 "../src/font-manager/Categories.vala"
				_tmp25_ = (const gchar*) sqlite3_column_text (_tmp24_, 0);
#line 613 "../src/font-manager/Categories.vala"
				_tmp26_ = g_strdup (_tmp25_);
#line 613 "../src/font-manager/Categories.vala"
				_type = _tmp26_;
#line 614 "../src/font-manager/Categories.vala"
				_tmp27_ = _type;
#line 614 "../src/font-manager/Categories.vala"
				_tmp28_ = g_strdup (g_dgettext (NULL, _tmp27_));
#line 614 "../src/font-manager/Categories.vala"
				type = _tmp28_;
#line 615 "../src/font-manager/Categories.vala"
				_tmp29_ = filter;
#line 615 "../src/font-manager/Categories.vala"
				_tmp30_ = font_manager_category_get_children (_tmp29_);
#line 615 "../src/font-manager/Categories.vala"
				_tmp31_ = _tmp30_;
#line 615 "../src/font-manager/Categories.vala"
				_tmp32_ = type;
#line 615 "../src/font-manager/Categories.vala"
				_tmp33_ = type;
#line 615 "../src/font-manager/Categories.vala"
				_tmp34_ = keyword;
#line 615 "../src/font-manager/Categories.vala"
				_tmp35_ = _type;
#line 615 "../src/font-manager/Categories.vala"
				_tmp36_ = g_strdup_printf ("%s [%s]=\"%s\";", FONT_MANAGER_SELECT_FROM_METADATA_WHERE, _tmp34_, _tmp35_);
#line 615 "../src/font-manager/Categories.vala"
				_tmp37_ = _tmp36_;
#line 615 "../src/font-manager/Categories.vala"
				_tmp38_ = *data;
#line 615 "../src/font-manager/Categories.vala"
				_tmp39_ = font_manager_category_new (_tmp32_, _tmp33_, "emblem-documents", _tmp37_, _tmp38_.index);
#line 615 "../src/font-manager/Categories.vala"
				g_ptr_array_add (_tmp31_, _tmp39_);
#line 615 "../src/font-manager/Categories.vala"
				_g_free0 (_tmp37_);
#line 612 "../src/font-manager/Categories.vala"
				_g_free0 (type);
#line 612 "../src/font-manager/Categories.vala"
				_g_free0 (_type);
#line 5767 "Categories.c"
			}
#line 612 "../src/font-manager/Categories.vala"
			_g_object_unref0 (_row_it);
#line 5771 "Categories.c"
		}
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
#line 610 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 5779 "Categories.c"
	}
	__finally0:
#line 610 "../src/font-manager/Categories.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 610 "../src/font-manager/Categories.vala"
		_g_object_unref0 (filter);
#line 610 "../src/font-manager/Categories.vala"
		_g_free0 (comment);
#line 610 "../src/font-manager/Categories.vala"
		_g_free0 (name);
#line 610 "../src/font-manager/Categories.vala"
		_g_free0 (keyword);
#line 610 "../src/font-manager/Categories.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 610 "../src/font-manager/Categories.vala"
		g_clear_error (&_inner_error0_);
#line 610 "../src/font-manager/Categories.vala"
		return NULL;
#line 5798 "Categories.c"
	}
#line 618 "../src/font-manager/Categories.vala"
	result = filter;
#line 618 "../src/font-manager/Categories.vala"
	_g_free0 (comment);
#line 618 "../src/font-manager/Categories.vala"
	_g_free0 (name);
#line 618 "../src/font-manager/Categories.vala"
	_g_free0 (keyword);
#line 618 "../src/font-manager/Categories.vala"
	return result;
#line 5810 "Categories.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

