/* PreviewPane.c generated by valac 0.56.3, the Vala compiler
 * generated from PreviewPane.vala, do not modify */

/* PreviewPane.vala
 *
 * Copyright (C) 2020-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <webkit2/webkit2.h>
#include "font-manager.h"
#include <gdk/gdk.h>
#include "config.h"
#include <libsoup/soup.h>
#include <pango/pango.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define HEADER "\n" \
"<html dir=\"%s\">\n" \
"  <head>\n" \
"    <style>\n" \
"      body {\n" \
"        color: %s;\n" \
"        background-color: %s;\n" \
"      }\n" \
"      .noWrap {\n" \
"        overflow: visible;\n" \
"        white-space: nowrap;\n" \
"        display:block;\n" \
"        width:100%;\n" \
"      }\n" \
"      .bodyText {\n" \
"        margin: 12px 8px 12px 8px;\n" \
"        text-align: justify;\n" \
"      }\n" \
"      .previewText {\n" \
"        font-family: %s;\n" \
"        font-style: %s;\n" \
"        font-weight: %i;\n" \
"      }\n" \
"      %s\n" \
"    </style>\n" \
"  </head>\n" \
"  <body oncontextmenu=\"return false;\">\n" \
"    <div>\n"
#define WATERFALL_ROW "\n" \
"      <p id=\"%.0lf\" class=\"noWrap\">\n" \
"        <span style=\"font-family: monospace;font-size: 10px;\">%s</sp" \
"an>\n" \
"        <span class=\"previewText\" style=\"font-size:%.0lfpx;\">%s</s" \
"pan>\n" \
"      </p>\n"
#define BODY_TEXT "\n" \
"      <p class=\"bodyText\" style=\"font-size:%0.1fpx;\">\n" \
"        <span class=\"previewText\">%s</span>\n" \
"      </p>\n"
#define FOOTER "\n    </div>\n  </body>\n</html>\n"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM
} FontManagerGoogleFontsPreviewMode;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_MODE (font_manager_google_fonts_preview_mode_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE (font_manager_google_fonts_preview_pane_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPaneClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPaneClass))

typedef struct _FontManagerGoogleFontsPreviewPane FontManagerGoogleFontsPreviewPane;
typedef struct _FontManagerGoogleFontsPreviewPaneClass FontManagerGoogleFontsPreviewPaneClass;
typedef struct _FontManagerGoogleFontsPreviewPanePrivate FontManagerGoogleFontsPreviewPanePrivate;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;

#define FONT_MANAGER_TYPE_PREVIEW_ENTRY (font_manager_preview_entry_get_type ())
#define FONT_MANAGER_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntry))
#define FONT_MANAGER_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))
#define FONT_MANAGER_IS_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_IS_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_PREVIEW_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))

typedef struct _FontManagerPreviewEntry FontManagerPreviewEntry;
typedef struct _FontManagerPreviewEntryClass FontManagerPreviewEntryClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST (font_manager_google_fonts_sample_list_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleList))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))

typedef struct _FontManagerGoogleFontsSampleList FontManagerGoogleFontsSampleList;
typedef struct _FontManagerGoogleFontsSampleListClass FontManagerGoogleFontsSampleListClass;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_layout_line_unref0(var) ((var == NULL) ? NULL : (var = (pango_layout_line_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE
} FontManagerGoogleFontsFileStatus;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FILE_STATUS (font_manager_google_fonts_file_status_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL (font_manager_google_fonts_sample_model_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModel))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))

typedef struct _FontManagerGoogleFontsSampleModel FontManagerGoogleFontsSampleModel;
typedef struct _FontManagerGoogleFontsSampleModelClass FontManagerGoogleFontsSampleModelClass;
typedef struct _Block76Data Block76Data;
typedef struct _Block77Data Block77Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_MANAGER_TYPE_APPLICATION (font_manager_application_get_type ())
#define FONT_MANAGER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplication))
#define FONT_MANAGER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))
#define FONT_MANAGER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))

typedef struct _FontManagerApplication FontManagerApplication;
typedef struct _FontManagerApplicationClass FontManagerApplicationClass;

#define FONT_MANAGER_TYPE_MAIN_WINDOW (font_manager_main_window_get_type ())
#define FONT_MANAGER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindow))
#define FONT_MANAGER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))
#define FONT_MANAGER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))

typedef struct _FontManagerMainWindow FontManagerMainWindow;
typedef struct _FontManagerMainWindowClass FontManagerMainWindowClass;
typedef struct _Block78Data Block78Data;

struct _FontManagerGoogleFontsPreviewPane {
	GtkBox parent_instance;
	FontManagerGoogleFontsPreviewPanePrivate * priv;
};

struct _FontManagerGoogleFontsPreviewPaneClass {
	GtkBoxClass parent_class;
};

struct _FontManagerGoogleFontsPreviewPanePrivate {
	FontManagerGoogleFontsFamily* _family;
	FontManagerGoogleFontsFont* _font;
	gboolean _refresh_required;
	gboolean _show_line_size;
	gdouble _preview_size;
	gdouble _min_waterfall_size;
	gdouble _max_waterfall_size;
	gdouble _waterfall_size_ratio;
	WebKitWebView* _preview;
	FontManagerGoogleFontsPreviewMode _mode;
	GtkBox* controls;
	GtkBox* scale_container;
	GtkButton* download_button;
	GtkScrolledWindow* preview_box;
	GtkColorButton* bg_color_button;
	GtkColorButton* fg_color_button;
	GtkMenuButton* menu_button;
	FontManagerPreviewEntry* entry;
	FontManagerFontScale* fontscale;
	GtkRadioButton* lorem_ipsum;
	gchar* _preview_text;
	gchar* default_preview_text;
	gboolean restore_default_preview;
	FontManagerGoogleFontsFont* stored_font;
	FontManagerGoogleFontsSampleList* sample_list;
};

struct _Block76Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	GSettings* settings;
};

struct _Block77Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerGoogleFontsFont** update;
	gint update_length1;
	gint _update_size_;
};

struct _Block78Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerMainWindow* main_window;
};

static gint FontManagerGoogleFontsPreviewPane_private_offset;
static gpointer font_manager_google_fonts_preview_pane_parent_class = NULL;

VALA_EXTERN GType font_manager_google_fonts_preview_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_google_fonts_preview_pane_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsPreviewPane, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN GType font_manager_preview_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPreviewEntry, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_sample_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleList, g_object_unref)
static WebKitWebContext* font_manager_google_fonts_preview_pane_get_webkit_context (FontManagerGoogleFontsPreviewPane* self);
static WebKitWebView* font_manager_google_fonts_preview_pane_get_webkit_webview (FontManagerGoogleFontsPreviewPane* self);
static gboolean font_manager_google_fonts_preview_pane_on_event (FontManagerGoogleFontsPreviewPane* self,
                                                          GtkWidget* widget,
                                                          GdkEvent* event);
static gboolean _font_manager_google_fonts_preview_pane_on_event_gtk_widget_event (GtkWidget* _sender,
                                                                            GdkEvent* event,
                                                                            gpointer self);
static void __lambda208_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebView* view,
                   WebKitWebResource* resource,
                   WebKitURIRequest* request);
static void __lambda209_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebResource* resource,
                   GError* _error_);
static void ___lambda209__webkit_web_resource_failed (WebKitWebResource* _sender,
                                               GError* _error_,
                                               gpointer self);
static void __lambda210_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebResource* resource);
static void ___lambda210__webkit_web_resource_finished (WebKitWebResource* _sender,
                                                 gpointer self);
static void ___lambda208__webkit_web_view_resource_load_started (WebKitWebView* _sender,
                                                          WebKitWebResource* resource,
                                                          WebKitURIRequest* request,
                                                          gpointer self);
static gboolean _vala_gdk_event_type_array_contains (GdkEventType * stack,
                                              gssize stack_length,
                                              const GdkEventType needle);
static gchar* font_manager_google_fonts_preview_pane_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_preview_pane_get_font (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_preview_size (FontManagerGoogleFontsPreviewPane* self);
static gdouble font_manager_google_fonts_preview_pane_get_next_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                                   gdouble current);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self);
static gchar* font_manager_google_fonts_preview_pane_generate_waterfall (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gboolean font_manager_google_fonts_preview_pane_get_show_line_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN const gchar* font_manager_google_fonts_preview_pane_get_preview_text (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN GType font_manager_google_fonts_file_status_get_type (void) G_GNUC_CONST ;
static void font_manager_google_fonts_preview_pane_selection_changed (FontManagerGoogleFontsPreviewPane* self,
                                                               FontManagerGoogleFontsFileStatus* status);
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_preview_pane_get_family (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_sample_list_set_items (FontManagerGoogleFontsSampleList* self,
                                                      FontManagerStringSet* value);
VALA_EXTERN GType font_manager_google_fonts_sample_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleModel, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsSampleModel* font_manager_google_fonts_sample_list_get_model (FontManagerGoogleFontsSampleList* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_update_preview (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN WebKitWebView* font_manager_google_fonts_preview_pane_get_preview (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview_text (FontManagerGoogleFontsPreviewPane* self,
                                                              const gchar* value);
VALA_EXTERN FontManagerGoogleFontsPreviewMode font_manager_google_fonts_preview_pane_get_mode (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                gdouble min_size,
                                                                gdouble max_size,
                                                                gdouble ratio);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self,
                                                                      gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_restore_state (FontManagerGoogleFontsPreviewPane* self,
                                                           GSettings* settings);
static Block76Data* block76_data_ref (Block76Data* _data76_);
static void block76_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview_size (FontManagerGoogleFontsPreviewPane* self,
                                                              gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_mode (FontManagerGoogleFontsPreviewPane* self,
                                                      FontManagerGoogleFontsPreviewMode value);
static gboolean __lambda211_ (Block76Data* _data76_);
static gboolean ___lambda211__gsource_func (gpointer self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_save_state (FontManagerGoogleFontsPreviewPane* self,
                                                        GSettings* settings);
static void font_manager_google_fonts_preview_pane_on_mode_toggled (FontManagerGoogleFontsPreviewPane* self,
                                                             GtkToggleButton* widget);
static void _font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                        gpointer self);
static void font_manager_google_fonts_preview_pane_on_download_button_clicked (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gchar* font_manager_google_fonts_get_font_directory (void);
static Block77Data* block77_data_ref (Block77Data* _data77_);
static void block77_data_unref (void * _userdata_);
VALA_EXTERN GPtrArray* font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self);
static void _vala_array_add9 (FontManagerGoogleFontsFont** * array,
                       gint* length,
                       gint* size,
                       FontManagerGoogleFontsFont* value);
VALA_EXTERN gboolean font_manager_remove_directory (GFile* dir,
                                        gboolean recursive);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_refresh_required (FontManagerGoogleFontsPreviewPane* self,
                                                                  gboolean value);
static FontManagerGoogleFontsFont** _vala_array_dup10 (FontManagerGoogleFontsFont** self,
                                                gssize length);
VALA_EXTERN void font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                                    gint fonts_length1,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_);
static void ____lambda213_ (Block77Data* _data77_,
                     GObject* obj,
                     GAsyncResult* res);
static void _____lambda213__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self);
VALA_EXTERN gboolean font_manager_remove_directory_tree_if_empty (GFile* dir);
static void ____lambda214_ (FontManagerGoogleFontsPreviewPane* self,
                     GObject* obj,
                     GAsyncResult* res);
static void _____lambda214__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void _font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                            gpointer self);
static void font_manager_google_fonts_preview_pane_on_entry_changed (FontManagerGoogleFontsPreviewPane* self);
static void _font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                                    gpointer self);
VALA_EXTERN FontManagerGoogleFontsPreviewPane* font_manager_google_fonts_preview_pane_new (void);
VALA_EXTERN FontManagerGoogleFontsPreviewPane* font_manager_google_fonts_preview_pane_construct (GType object_type);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_family (FontManagerGoogleFontsPreviewPane* self,
                                                        FontManagerGoogleFontsFamily* value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_font (FontManagerGoogleFontsPreviewPane* self,
                                                      FontManagerGoogleFontsFont* value);
VALA_EXTERN gboolean font_manager_google_fonts_preview_pane_get_refresh_required (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_show_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview (FontManagerGoogleFontsPreviewPane* self,
                                                         WebKitWebView* value);
static GObject * font_manager_google_fonts_preview_pane_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties);
static void _font_manager_google_fonts_preview_pane___lambda215_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map (GtkWidget* _sender,
                                                                           gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda216_ (FontManagerGoogleFontsPreviewPane* self);
static gboolean __lambda217_ (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN GType font_manager_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerApplication, g_object_unref)
VALA_EXTERN guint font_manager_application_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN FontManagerApplication* font_manager_get_default_application (void);
VALA_EXTERN void font_manager_application_refresh (FontManagerApplication* self);
static gboolean ___lambda217__gsource_func (gpointer self);
static void __font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap (GtkWidget* _sender,
                                                                             gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda218_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
VALA_EXTERN GType font_manager_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerMainWindow, g_object_unref)
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
VALA_EXTERN FontManagerMainWindow* font_manager_application_get_main_window (FontManagerApplication* self);
static gboolean ___lambda219_ (Block78Data* _data78_);
VALA_EXTERN void font_manager_main_window_set_model (FontManagerMainWindow* self,
                                         FontManagerFontModel* value);
static gboolean ____lambda219__gsource_func (gpointer self);
static void __font_manager_google_fonts_preview_pane___lambda218__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda220_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda220__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda221_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda221__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda222_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda222__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda223_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda223__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda224_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda224__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda225_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                       gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda226_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                       gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda227_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda227__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda228_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda228__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda229_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda229__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda230_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda230__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
VALA_EXTERN void font_manager_set_button_relief_style (GtkContainer* container,
                                           GtkReliefStyle relief);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_new (void);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_construct (GType object_type);
static void _font_manager_google_fonts_preview_pane___lambda231_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GtkEntry* entry,
                                                           GtkEntryIconPosition position,
                                                           GdkEvent* event);
VALA_EXTERN void font_manager_google_fonts_sample_list_unselect_all (FontManagerGoogleFontsSampleList* self);
static void __font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press (GtkEntry* _sender,
                                                                                 GtkEntryIconPosition icon_pos,
                                                                                 GdkEvent* event,
                                                                                 gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda232_ (FontManagerGoogleFontsPreviewPane* self,
                                                           const gchar* s);
static void __font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                               const gchar* sample,
                                                                                                               gpointer self);
static void font_manager_google_fonts_preview_pane_finalize (GObject * obj);
static GType font_manager_google_fonts_preview_pane_get_type_once (void);
static void _vala_font_manager_google_fonts_preview_pane_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_font_manager_google_fonts_preview_pane_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL, "FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL", "waterfall"}, {FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM, "FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM", "lorem-ipsum"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_preview_mode_type_id;
	font_manager_google_fonts_preview_mode_type_id = g_enum_register_static ("FontManagerGoogleFontsPreviewMode", values);
	return font_manager_google_fonts_preview_mode_type_id;
}

GType
font_manager_google_fonts_preview_mode_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_mode_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_mode_type_id__once)) {
		GType font_manager_google_fonts_preview_mode_type_id;
		font_manager_google_fonts_preview_mode_type_id = font_manager_google_fonts_preview_mode_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_mode_type_id__once, font_manager_google_fonts_preview_mode_type_id);
	}
	return font_manager_google_fonts_preview_mode_type_id__once;
}

static inline gpointer
font_manager_google_fonts_preview_pane_get_instance_private (FontManagerGoogleFontsPreviewPane* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsPreviewPane_private_offset);
}

static WebKitWebContext*
font_manager_google_fonts_preview_pane_get_webkit_context (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebContext* web_context = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* result;
#line 120 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = webkit_web_context_new_ephemeral ();
#line 121 "../src/font-manager/web/google/PreviewPane.vala"
	web_context = _tmp0_;
#line 122 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_web_context_set_cache_model (web_context, WEBKIT_CACHE_MODEL_DOCUMENT_BROWSER);
#line 123 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_web_context_prefetch_dns (web_context, "http://fonts.gstatic.com/");
#line 124 "../src/font-manager/web/google/PreviewPane.vala"
	result = web_context;
#line 124 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 559 "PreviewPane.c"
}

static gboolean
_font_manager_google_fonts_preview_pane_on_event_gtk_widget_event (GtkWidget* _sender,
                                                                   GdkEvent* event,
                                                                   gpointer self)
{
	gboolean result;
	result = font_manager_google_fonts_preview_pane_on_event ((FontManagerGoogleFontsPreviewPane*) self, _sender, event);
#line 131 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 571 "PreviewPane.c"
}

static void
__lambda209_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebResource* resource,
              GError* _error_)
{
#line 146 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (resource != NULL);
#line 146 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (_error_ != NULL);
#line 148 "../src/font-manager/web/google/PreviewPane.vala"
	if (_error_->code != 302) {
#line 585 "PreviewPane.c"
		const gchar* _tmp0_;
#line 149 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _error_->message;
#line 149 "../src/font-manager/web/google/PreviewPane.vala"
		g_warning ("PreviewPane.vala:149: %i : %s", _error_->code, _tmp0_);
#line 591 "PreviewPane.c"
	}
}

static void
___lambda209__webkit_web_resource_failed (WebKitWebResource* _sender,
                                          GError* _error_,
                                          gpointer self)
{
#line 146 "../src/font-manager/web/google/PreviewPane.vala"
	__lambda209_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, _error_);
#line 602 "PreviewPane.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 152 "../src/font-manager/web/google/PreviewPane.vala"
	return self ? g_object_ref (self) : NULL;
#line 610 "PreviewPane.c"
}

static void
__lambda210_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebResource* resource)
{
	WebKitURIResponse* response = NULL;
	WebKitURIResponse* _tmp0_;
	WebKitURIResponse* _tmp1_;
	WebKitURIResponse* _tmp2_;
	SoupStatus status = 0;
	WebKitURIResponse* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* uri = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
#line 151 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (resource != NULL);
#line 152 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = webkit_web_resource_get_response (resource);
#line 152 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 152 "../src/font-manager/web/google/PreviewPane.vala"
	response = _tmp1_;
#line 153 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = response;
#line 153 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp2_ == NULL) {
#line 154 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (response);
#line 154 "../src/font-manager/web/google/PreviewPane.vala"
		return;
#line 646 "PreviewPane.c"
	}
#line 155 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = response;
#line 155 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = webkit_uri_response_get_status_code (_tmp3_);
#line 155 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = _tmp4_;
#line 155 "../src/font-manager/web/google/PreviewPane.vala"
	status = (SoupStatus) _tmp5_;
#line 156 "../src/font-manager/web/google/PreviewPane.vala"
	if (status == SOUP_STATUS_OK) {
#line 157 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (response);
#line 157 "../src/font-manager/web/google/PreviewPane.vala"
		return;
#line 662 "PreviewPane.c"
	}
#line 158 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = webkit_web_resource_get_uri (resource);
#line 158 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 158 "../src/font-manager/web/google/PreviewPane.vala"
	uri = _tmp7_;
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp9_ = uri;
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
	if (g_str_has_suffix (_tmp9_, "ttf")) {
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = TRUE;
#line 676 "PreviewPane.c"
	} else {
		const gchar* _tmp10_;
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp10_ = uri;
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = g_str_has_suffix (_tmp10_, "otf");
#line 683 "PreviewPane.c"
	}
#line 159 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp8_) {
#line 687 "PreviewPane.c"
		const gchar* _tmp11_;
#line 160 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp11_ = uri;
#line 160 "../src/font-manager/web/google/PreviewPane.vala"
		g_warning ("PreviewPane.vala:160: Failed to load font resource : %s", _tmp11_);
#line 161 "../src/font-manager/web/google/PreviewPane.vala"
		g_message ("PreviewPane.vala:161: HTTP status code : %i", (gint) status);
#line 695 "PreviewPane.c"
	}
#line 151 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (uri);
#line 151 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (response);
#line 701 "PreviewPane.c"
}

static void
___lambda210__webkit_web_resource_finished (WebKitWebResource* _sender,
                                            gpointer self)
{
#line 151 "../src/font-manager/web/google/PreviewPane.vala"
	__lambda210_ ((FontManagerGoogleFontsPreviewPane*) self, _sender);
#line 710 "PreviewPane.c"
}

static void
__lambda208_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebView* view,
              WebKitWebResource* resource,
              WebKitURIRequest* request)
{
#line 145 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (view != NULL);
#line 145 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (resource != NULL);
#line 145 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (request != NULL);
#line 146 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (resource, "failed", (GCallback) ___lambda209__webkit_web_resource_failed, self, 0);
#line 151 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (resource, "finished", (GCallback) ___lambda210__webkit_web_resource_finished, self, 0);
#line 729 "PreviewPane.c"
}

static void
___lambda208__webkit_web_view_resource_load_started (WebKitWebView* _sender,
                                                     WebKitWebResource* resource,
                                                     WebKitURIRequest* request,
                                                     gpointer self)
{
#line 145 "../src/font-manager/web/google/PreviewPane.vala"
	__lambda208_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, resource, request);
#line 740 "PreviewPane.c"
}

static WebKitWebView*
font_manager_google_fonts_preview_pane_get_webkit_webview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* preview = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* _tmp1_;
	WebKitWebView* _tmp2_;
	WebKitWebView* _tmp3_;
	GtkScrolledWindow* _tmp4_;
	WebKitSettings* settings = NULL;
	WebKitSettings* _tmp5_ = NULL;
	WebKitWebView* result;
#line 127 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = font_manager_google_fonts_preview_pane_get_webkit_context (self);
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _tmp0_;
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = (WebKitWebView*) webkit_web_view_new_with_context (_tmp1_);
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_ref_sink (_tmp2_);
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (_tmp1_);
#line 128 "../src/font-manager/web/google/PreviewPane.vala"
	preview = _tmp3_;
#line 129 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = self->priv->preview_box;
#line 129 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) preview);
#line 130 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_show ((GtkWidget*) preview);
#line 131 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GtkWidget*) preview, "event", (GCallback) _font_manager_google_fonts_preview_pane_on_event_gtk_widget_event, self, 0);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = webkit_settings_new ();
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_fullscreen (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_java (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_media (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_mediasource (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_plugins (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_site_specific_quirks (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_smooth_scrolling (_tmp5_, TRUE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_webaudio (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_enable_xss_auditor (_tmp5_, FALSE);
#line 132 "../src/font-manager/web/google/PreviewPane.vala"
	settings = _tmp5_;
#line 143 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_settings_set_user_agent_with_application_details (settings, PACKAGE_NAME, PACKAGE_VERSION);
#line 144 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_web_view_set_settings (preview, settings);
#line 145 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (preview, "resource-load-started", (GCallback) ___lambda208__webkit_web_view_resource_load_started, self, 0);
#line 165 "../src/font-manager/web/google/PreviewPane.vala"
	result = preview;
#line 165 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (settings);
#line 165 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 813 "PreviewPane.c"
}

static gboolean
_vala_gdk_event_type_array_contains (GdkEventType * stack,
                                     gssize stack_length,
                                     const GdkEventType needle)
{
	gssize i;
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
	for (i = 0; i < stack_length; i++) {
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
		if (needle == stack[i]) {
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
			return TRUE;
#line 828 "PreviewPane.c"
		}
	}
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
	return FALSE;
#line 833 "PreviewPane.c"
}

static gboolean
font_manager_google_fonts_preview_pane_on_event (FontManagerGoogleFontsPreviewPane* self,
                                                 GtkWidget* widget,
                                                 GdkEvent* event)
{
	GdkEventType* allowed_events = NULL;
	GdkEventType* _tmp0_;
	gint allowed_events_length1;
	gint _allowed_events_size_;
	GdkEventType* _tmp1_;
	gint _tmp1__length1;
	gboolean result;
#line 237 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 237 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 237 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_new0 (GdkEventType, 4);
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_[0] = GDK_SCROLL;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_[1] = GDK_TOUCH_BEGIN;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_[2] = GDK_TOUCH_END;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_[3] = GDK_TOUCH_UPDATE;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	allowed_events = _tmp0_;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	allowed_events_length1 = 4;
#line 238 "../src/font-manager/web/google/PreviewPane.vala"
	_allowed_events_size_ = allowed_events_length1;
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = allowed_events;
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1__length1 = allowed_events_length1;
#line 240 "../src/font-manager/web/google/PreviewPane.vala"
	if (_vala_gdk_event_type_array_contains (_tmp1_, _tmp1__length1, event->type)) {
#line 241 "../src/font-manager/web/google/PreviewPane.vala"
		result = GDK_EVENT_PROPAGATE;
#line 241 "../src/font-manager/web/google/PreviewPane.vala"
		allowed_events = (g_free (allowed_events), NULL);
#line 241 "../src/font-manager/web/google/PreviewPane.vala"
		return result;
#line 882 "PreviewPane.c"
	}
#line 242 "../src/font-manager/web/google/PreviewPane.vala"
	result = GDK_EVENT_STOP;
#line 242 "../src/font-manager/web/google/PreviewPane.vala"
	allowed_events = (g_free (allowed_events), NULL);
#line 242 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 890 "PreviewPane.c"
}

static gpointer
_pango_layout_line_ref0 (gpointer self)
{
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	return self ? pango_layout_line_ref (self) : NULL;
#line 898 "PreviewPane.c"
}

static gchar*
font_manager_google_fonts_preview_pane_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPane* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	PangoLayoutLine* line = NULL;
	FontManagerPreviewEntry* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutLine* _tmp3_;
	PangoLayoutLine* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	PangoLayoutLine* _tmp7_;
	gchar* text_direction = NULL;
	gchar* _tmp9_;
	GString* _tmp10_;
	GtkColorButton* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkColorButton* _tmp15_;
	GdkRGBA _tmp16_ = {0};
	gchar* _tmp17_;
	gchar* _tmp18_;
	FontManagerGoogleFontsFont* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	FontManagerGoogleFontsFont* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	FontManagerGoogleFontsFont* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	FontManagerGoogleFontsFont* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* pref_loc = NULL;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	GString* _tmp35_;
	gdouble _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GString* _tmp39_;
	GString* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* result;
#line 245 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_string_new ("");
#line 246 "../src/font-manager/web/google/PreviewPane.vala"
	builder = _tmp0_;
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->entry;
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gtk_entry_get_layout ((GtkEntry*) _tmp1_);
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = pango_layout_get_line (_tmp2_, 0);
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = _pango_layout_line_ref0 (_tmp3_);
#line 247 "../src/font-manager/web/google/PreviewPane.vala"
	line = _tmp4_;
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = line;
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp7_ != NULL) {
#line 971 "PreviewPane.c"
		PangoLayoutLine* _tmp8_;
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = line;
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = _tmp8_->resolved_dir == ((guint) PANGO_DIRECTION_RTL);
#line 977 "PreviewPane.c"
	} else {
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = FALSE;
#line 981 "PreviewPane.c"
	}
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp6_) {
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = "rtl";
#line 987 "PreviewPane.c"
	} else {
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = "ltr";
#line 991 "PreviewPane.c"
	}
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp9_ = g_strdup (_tmp5_);
#line 248 "../src/font-manager/web/google/PreviewPane.vala"
	text_direction = _tmp9_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp10_ = builder;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp11_ = self->priv->fg_color_button;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp11_, &_tmp12_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp13_ = gdk_rgba_to_string (&_tmp12_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp14_ = _tmp13_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp15_ = self->priv->bg_color_button;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp15_, &_tmp16_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp17_ = gdk_rgba_to_string (&_tmp16_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp18_ = _tmp17_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp19_ = self->priv->_font;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp20_ = font_manager_google_fonts_font_get_family (_tmp19_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp21_ = _tmp20_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp22_ = self->priv->_font;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp23_ = font_manager_google_fonts_font_get_style (_tmp22_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp24_ = _tmp23_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp25_ = self->priv->_font;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp26_ = font_manager_google_fonts_font_get_weight (_tmp25_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp27_ = _tmp26_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp28_ = self->priv->_font;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp29_ = font_manager_google_fonts_font_to_font_face_rule (_tmp28_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp30_ = _tmp29_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp31_ = g_strdup_printf (HEADER, text_direction, _tmp14_, _tmp18_, _tmp21_, _tmp24_, _tmp27_, _tmp30_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp32_ = _tmp31_;
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	g_string_append (_tmp10_, _tmp32_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp32_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp30_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp18_);
#line 249 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp14_);
#line 254 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp33_ = setlocale (LC_ALL, "");
#line 254 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 254 "../src/font-manager/web/google/PreviewPane.vala"
	pref_loc = _tmp34_;
#line 255 "../src/font-manager/web/google/PreviewPane.vala"
	setlocale (LC_ALL, "C");
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp35_ = builder;
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp36_ = self->priv->_preview_size;
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp37_ = g_strdup_printf (BODY_TEXT, _tmp36_, FONT_MANAGER_LOREM_IPSUM);
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp38_ = _tmp37_;
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	g_string_append (_tmp35_, _tmp38_);
#line 256 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp38_);
#line 257 "../src/font-manager/web/google/PreviewPane.vala"
	setlocale (LC_ALL, pref_loc);
#line 258 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp39_ = builder;
#line 258 "../src/font-manager/web/google/PreviewPane.vala"
	g_string_append (_tmp39_, FOOTER);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp40_ = builder;
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp41_ = _tmp40_->str;
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp42_;
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (pref_loc);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (text_direction);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_pango_layout_line_unref0 (line);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	_g_string_free0 (builder);
#line 259 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 1097 "PreviewPane.c"
}

static gdouble
font_manager_google_fonts_preview_pane_get_next_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gdouble current)
{
	gdouble _tmp0_;
	gdouble next = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble result;
#line 262 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 263 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_waterfall_size_ratio;
#line 263 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp0_ <= 1.0) {
#line 264 "../src/font-manager/web/google/PreviewPane.vala"
		result = current + 1.0;
#line 264 "../src/font-manager/web/google/PreviewPane.vala"
		return result;
#line 1120 "PreviewPane.c"
	}
#line 265 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_waterfall_size_ratio;
#line 265 "../src/font-manager/web/google/PreviewPane.vala"
	next = current * _tmp1_;
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = self->priv->_waterfall_size_ratio;
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp3_ > 1.1) {
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = floor (next);
#line 1132 "PreviewPane.c"
	} else {
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = ceil (next);
#line 1136 "PreviewPane.c"
	}
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp2_;
#line 266 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 1142 "PreviewPane.c"
}

static gchar*
font_manager_google_fonts_preview_pane_generate_waterfall (FontManagerGoogleFontsPreviewPane* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	PangoLayoutLine* line = NULL;
	FontManagerPreviewEntry* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutLine* _tmp3_;
	PangoLayoutLine* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	PangoLayoutLine* _tmp7_;
	gchar* text_direction = NULL;
	gchar* _tmp9_;
	GString* _tmp10_;
	const gchar* _tmp11_;
	GtkColorButton* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkColorButton* _tmp16_;
	GdkRGBA _tmp17_ = {0};
	gchar* _tmp18_;
	gchar* _tmp19_;
	FontManagerGoogleFontsFont* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	FontManagerGoogleFontsFont* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	FontManagerGoogleFontsFont* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	FontManagerGoogleFontsFont* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GString* _tmp49_;
	GString* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* result;
#line 269 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_string_new ("");
#line 270 "../src/font-manager/web/google/PreviewPane.vala"
	builder = _tmp0_;
#line 271 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->entry;
#line 271 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gtk_entry_get_layout ((GtkEntry*) _tmp1_);
#line 271 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = pango_layout_get_line (_tmp2_, 0);
#line 271 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = _pango_layout_line_ref0 (_tmp3_);
#line 271 "../src/font-manager/web/google/PreviewPane.vala"
	line = _tmp4_;
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = line;
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp7_ != NULL) {
#line 1209 "PreviewPane.c"
		PangoLayoutLine* _tmp8_;
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = line;
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = _tmp8_->resolved_dir == ((guint) PANGO_DIRECTION_RTL);
#line 1215 "PreviewPane.c"
	} else {
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = FALSE;
#line 1219 "PreviewPane.c"
	}
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp6_) {
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = "rtl";
#line 1225 "PreviewPane.c"
	} else {
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = "ltr";
#line 1229 "PreviewPane.c"
	}
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp9_ = g_strdup (_tmp5_);
#line 272 "../src/font-manager/web/google/PreviewPane.vala"
	text_direction = _tmp9_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp10_ = builder;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp11_ = text_direction;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp12_ = self->priv->fg_color_button;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp12_, &_tmp13_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp14_ = gdk_rgba_to_string (&_tmp13_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp15_ = _tmp14_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp16_ = self->priv->bg_color_button;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp16_, &_tmp17_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp18_ = gdk_rgba_to_string (&_tmp17_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp19_ = _tmp18_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp20_ = self->priv->_font;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp21_ = font_manager_google_fonts_font_get_family (_tmp20_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp22_ = _tmp21_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp23_ = self->priv->_font;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp24_ = font_manager_google_fonts_font_get_style (_tmp23_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp25_ = _tmp24_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp26_ = self->priv->_font;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp27_ = font_manager_google_fonts_font_get_weight (_tmp26_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp28_ = _tmp27_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp29_ = self->priv->_font;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp30_ = font_manager_google_fonts_font_to_font_face_rule (_tmp29_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp31_ = _tmp30_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp32_ = g_strdup_printf (HEADER, _tmp11_, _tmp15_, _tmp19_, _tmp22_, _tmp25_, _tmp28_, _tmp31_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp33_ = _tmp32_;
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	g_string_append (_tmp10_, _tmp33_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp33_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp31_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp19_);
#line 273 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp15_);
#line 1293 "PreviewPane.c"
	{
		gdouble i = 0.0;
		gdouble _tmp34_;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp34_ = self->priv->_min_waterfall_size;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
		i = _tmp34_;
#line 1301 "PreviewPane.c"
		{
			gboolean _tmp35_ = FALSE;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp35_ = TRUE;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
			while (TRUE) {
#line 1308 "PreviewPane.c"
				gdouble _tmp36_;
				gchar* pixels = NULL;
				gchar* _tmp37_;
				gboolean _tmp38_;
				GString* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
				if (!_tmp35_) {
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
					i = font_manager_google_fonts_preview_pane_get_next_line_size (self, i);
#line 1323 "PreviewPane.c"
				}
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp35_ = FALSE;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp36_ = self->priv->_max_waterfall_size;
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
				if (!(i <= _tmp36_)) {
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
					break;
#line 1333 "PreviewPane.c"
				}
#line 279 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp37_ = g_strdup ("&nbsp;");
#line 279 "../src/font-manager/web/google/PreviewPane.vala"
				pixels = _tmp37_;
#line 280 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp38_ = self->priv->_show_line_size;
#line 280 "../src/font-manager/web/google/PreviewPane.vala"
				if (_tmp38_) {
#line 1343 "PreviewPane.c"
					gchar* _tmp39_ = NULL;
					gchar* _tmp42_;
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
					if (i < ((gdouble) 10)) {
#line 1348 "PreviewPane.c"
						gchar* _tmp40_;
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp40_ = g_strdup_printf ("&nbsp;&nbsp;%.0lfpx&nbsp", i);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_g_free0 (_tmp39_);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp39_ = _tmp40_;
#line 1356 "PreviewPane.c"
					} else {
						gchar* _tmp41_;
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp41_ = g_strdup_printf ("&nbsp;%.0lfpx&nbsp;", i);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_g_free0 (_tmp39_);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp39_ = _tmp41_;
#line 1365 "PreviewPane.c"
					}
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
					_tmp42_ = g_strdup (_tmp39_);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
					_g_free0 (pixels);
#line 281 "../src/font-manager/web/google/PreviewPane.vala"
					pixels = _tmp42_;
#line 280 "../src/font-manager/web/google/PreviewPane.vala"
					_g_free0 (_tmp39_);
#line 1375 "PreviewPane.c"
				}
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp43_ = builder;
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp44_ = pixels;
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp45_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp46_ = _tmp45_;
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp47_ = g_strdup_printf (WATERFALL_ROW, i, _tmp44_, i, _tmp46_);
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp48_ = _tmp47_;
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				g_string_append (_tmp43_, _tmp48_);
#line 282 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (_tmp48_);
#line 278 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (pixels);
#line 1395 "PreviewPane.c"
			}
		}
	}
#line 284 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp49_ = builder;
#line 284 "../src/font-manager/web/google/PreviewPane.vala"
	g_string_append (_tmp49_, FOOTER);
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp50_ = builder;
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp51_ = _tmp50_->str;
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp52_ = g_strdup (_tmp51_);
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp52_;
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (text_direction);
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_pango_layout_line_unref0 (line);
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	_g_string_free0 (builder);
#line 285 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 1419 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_selection_changed (FontManagerGoogleFontsPreviewPane* self,
                                                          FontManagerGoogleFontsFileStatus* status)
{
	gchar* label = NULL;
	GtkStyleContext* ctx = NULL;
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* _tmp18_;
	const gchar* _tmp19_;
	FontManagerStringSet* _tmp20_ = NULL;
	FontManagerGoogleFontsFamily* _tmp21_;
	FontManagerGoogleFontsSampleList* _tmp28_;
	guint langs = 0U;
	FontManagerGoogleFontsSampleList* _tmp29_;
	FontManagerGoogleFontsSampleModel* _tmp30_;
	FontManagerGoogleFontsSampleModel* _tmp31_;
	FontManagerPreviewEntry* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
#line 288 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->download_button;
#line 290 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
#line 290 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 290 "../src/font-manager/web/google/PreviewPane.vala"
	ctx = _tmp2_;
#line 291 "../src/font-manager/web/google/PreviewPane.vala"
	switch (*status) {
#line 291 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE:
#line 1457 "PreviewPane.c"
		{
			const gchar* _tmp3_ = NULL;
			FontManagerGoogleFontsFamily* _tmp4_;
			gchar* _tmp5_;
			GtkStyleContext* _tmp6_;
			GtkStyleContext* _tmp7_;
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp4_ = self->priv->_family;
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
			if (_tmp4_ != NULL) {
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp3_ = _ ("Update Family");
#line 1470 "PreviewPane.c"
			} else {
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp3_ = _ ("Update Font");
#line 1474 "PreviewPane.c"
			}
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp5_ = g_strdup (_tmp3_);
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (label);
#line 293 "../src/font-manager/web/google/PreviewPane.vala"
			label = _tmp5_;
#line 294 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp6_ = ctx;
#line 294 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_remove_class (_tmp6_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 295 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp7_ = ctx;
#line 295 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_add_class (_tmp7_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 296 "../src/font-manager/web/google/PreviewPane.vala"
			break;
#line 1492 "PreviewPane.c"
		}
#line 291 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED:
#line 1496 "PreviewPane.c"
		{
			const gchar* _tmp8_ = NULL;
			FontManagerGoogleFontsFamily* _tmp9_;
			gchar* _tmp10_;
			GtkStyleContext* _tmp11_;
			GtkStyleContext* _tmp12_;
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp9_ = self->priv->_family;
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
			if (_tmp9_ != NULL) {
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp8_ = _ ("Remove Family");
#line 1509 "PreviewPane.c"
			} else {
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp8_ = _ ("Remove Font");
#line 1513 "PreviewPane.c"
			}
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp10_ = g_strdup (_tmp8_);
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (label);
#line 298 "../src/font-manager/web/google/PreviewPane.vala"
			label = _tmp10_;
#line 299 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp11_ = ctx;
#line 299 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_remove_class (_tmp11_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 300 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp12_ = ctx;
#line 300 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 301 "../src/font-manager/web/google/PreviewPane.vala"
			break;
#line 1531 "PreviewPane.c"
		}
		default:
		{
			const gchar* _tmp13_ = NULL;
			FontManagerGoogleFontsFamily* _tmp14_;
			gchar* _tmp15_;
			GtkStyleContext* _tmp16_;
			GtkStyleContext* _tmp17_;
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp14_ = self->priv->_family;
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
			if (_tmp14_ != NULL) {
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp13_ = _ ("Download Family");
#line 1546 "PreviewPane.c"
			} else {
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp13_ = _ ("Download Font");
#line 1550 "PreviewPane.c"
			}
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp15_ = g_strdup (_tmp13_);
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (label);
#line 303 "../src/font-manager/web/google/PreviewPane.vala"
			label = _tmp15_;
#line 304 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp16_ = ctx;
#line 304 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_remove_class (_tmp16_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 305 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp17_ = ctx;
#line 305 "../src/font-manager/web/google/PreviewPane.vala"
			gtk_style_context_remove_class (_tmp17_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 306 "../src/font-manager/web/google/PreviewPane.vala"
			break;
#line 1568 "PreviewPane.c"
		}
	}
#line 308 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp18_ = self->priv->download_button;
#line 308 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp19_ = label;
#line 308 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_button_set_label (_tmp18_, _tmp19_);
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp21_ = self->priv->_family;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp21_ != NULL) {
#line 1581 "PreviewPane.c"
		FontManagerGoogleFontsFamily* _tmp22_;
		FontManagerStringSet* _tmp23_;
		FontManagerStringSet* _tmp24_;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp22_ = self->priv->_family;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp23_ = font_manager_google_fonts_family_get_subsets (_tmp22_);
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp24_ = _tmp23_;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp20_ = _tmp24_;
#line 1593 "PreviewPane.c"
	} else {
		FontManagerGoogleFontsFont* _tmp25_;
		FontManagerStringSet* _tmp26_;
		FontManagerStringSet* _tmp27_;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp25_ = self->priv->_font;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp26_ = font_manager_google_fonts_font_get_subsets (_tmp25_);
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp27_ = _tmp26_;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp20_ = _tmp27_;
#line 1606 "PreviewPane.c"
	}
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp28_ = self->priv->sample_list;
#line 309 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_sample_list_set_items (_tmp28_, _tmp20_);
#line 310 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp29_ = self->priv->sample_list;
#line 310 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp30_ = font_manager_google_fonts_sample_list_get_model (_tmp29_);
#line 310 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp31_ = _tmp30_;
#line 310 "../src/font-manager/web/google/PreviewPane.vala"
	langs = g_list_model_get_n_items ((GListModel*) _tmp31_);
#line 311 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp32_ = self->priv->entry;
#line 311 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp33_ = g_strdup_printf (ngettext ("%i Language Sample Available ", "%i Language Samples Available", (gulong) langs), (gint) langs);
#line 311 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp34_ = _tmp33_;
#line 311 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_icon_tooltip_text ((GtkEntry*) _tmp32_, GTK_ENTRY_ICON_PRIMARY, _tmp34_);
#line 311 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp34_);
#line 317 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (ctx);
#line 317 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (label);
#line 317 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 1636 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_update_preview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	FontManagerGoogleFontsFont* _tmp2_;
	FontManagerGoogleFontsFont* _tmp3_;
	gchar* html = NULL;
	gchar* _tmp6_;
	FontManagerGoogleFontsFont* _tmp7_;
	WebKitWebView* _tmp11_;
	const gchar* _tmp12_;
#line 320 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_preview;
#line 321 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp0_ == NULL) {
#line 322 "../src/font-manager/web/google/PreviewPane.vala"
		return;
#line 1659 "PreviewPane.c"
	}
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = self->priv->_font;
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = self->priv->stored_font;
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp2_ != _tmp3_) {
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp1_ = self->priv->restore_default_preview;
#line 1669 "PreviewPane.c"
	} else {
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp1_ = FALSE;
#line 1673 "PreviewPane.c"
	}
#line 324 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp1_) {
#line 1677 "PreviewPane.c"
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
#line 325 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp4_ = self->priv->entry;
#line 325 "../src/font-manager/web/google/PreviewPane.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp4_, "");
#line 326 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = self->priv->default_preview_text;
#line 326 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_preview_text (self, _tmp5_);
#line 327 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->restore_default_preview = FALSE;
#line 1690 "PreviewPane.c"
	}
#line 329 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = g_strdup ("<html><body><p> </p></body></html>");
#line 329 "../src/font-manager/web/google/PreviewPane.vala"
	html = _tmp6_;
#line 330 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = self->priv->_font;
#line 330 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp7_ != NULL) {
#line 1700 "PreviewPane.c"
		FontManagerGoogleFontsPreviewMode _tmp8_;
#line 331 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = self->priv->_mode;
#line 331 "../src/font-manager/web/google/PreviewPane.vala"
		switch (_tmp8_) {
#line 331 "../src/font-manager/web/google/PreviewPane.vala"
			case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL:
#line 1708 "PreviewPane.c"
			{
				gchar* _tmp9_;
#line 333 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp9_ = font_manager_google_fonts_preview_pane_generate_waterfall (self);
#line 333 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (html);
#line 333 "../src/font-manager/web/google/PreviewPane.vala"
				html = _tmp9_;
#line 334 "../src/font-manager/web/google/PreviewPane.vala"
				break;
#line 1719 "PreviewPane.c"
			}
#line 331 "../src/font-manager/web/google/PreviewPane.vala"
			case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM:
#line 1723 "PreviewPane.c"
			{
				gchar* _tmp10_;
#line 336 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp10_ = font_manager_google_fonts_preview_pane_generate_lorem_ipsum (self);
#line 336 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (html);
#line 336 "../src/font-manager/web/google/PreviewPane.vala"
				html = _tmp10_;
#line 337 "../src/font-manager/web/google/PreviewPane.vala"
				break;
#line 1734 "PreviewPane.c"
			}
			default:
			{
#line 339 "../src/font-manager/web/google/PreviewPane.vala"
				g_assert_not_reached ();
#line 1740 "PreviewPane.c"
			}
		}
	}
#line 342 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp11_ = self->priv->_preview;
#line 342 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp12_ = html;
#line 342 "../src/font-manager/web/google/PreviewPane.vala"
	webkit_web_view_load_html (_tmp11_, _tmp12_, NULL);
#line 343 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (html);
#line 343 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 1754 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gdouble min_size,
                                                           gdouble max_size,
                                                           gdouble ratio)
{
#line 346 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_min_waterfall_size (self, min_size);
#line 348 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_max_waterfall_size (self, max_size);
#line 349 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (self, ratio);
#line 350 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 351 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 1775 "PreviewPane.c"
}

static Block76Data*
block76_data_ref (Block76Data* _data76_)
{
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	g_atomic_int_inc (&_data76_->_ref_count_);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	return _data76_;
#line 1785 "PreviewPane.c"
}

static void
block76_data_unref (void * _userdata_)
{
	Block76Data* _data76_;
	_data76_ = (Block76Data*) _userdata_;
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	if (g_atomic_int_dec_and_test (&_data76_->_ref_count_)) {
#line 1795 "PreviewPane.c"
		FontManagerGoogleFontsPreviewPane* self;
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
		self = _data76_->self;
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (_data76_->settings);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
		g_slice_free (Block76Data, _data76_);
#line 1805 "PreviewPane.c"
	}
}

static gboolean
__lambda211_ (Block76Data* _data76_)
{
	FontManagerGoogleFontsPreviewPane* self;
	GdkRGBA foreground = {0};
	GdkRGBA background = {0};
	gboolean foreground_set = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean background_set = FALSE;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 359 "../src/font-manager/web/google/PreviewPane.vala"
	self = _data76_->self;
#line 360 "../src/font-manager/web/google/PreviewPane.vala"
	memset (&foreground, 0, sizeof (GdkRGBA));
#line 361 "../src/font-manager/web/google/PreviewPane.vala"
	memset (&background, 0, sizeof (GdkRGBA));
#line 362 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_settings_get_string (_data76_->settings, "google-fonts-foreground-color");
#line 362 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _tmp0_;
#line 362 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gdk_rgba_parse (&foreground, _tmp1_);
#line 362 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp1_);
#line 362 "../src/font-manager/web/google/PreviewPane.vala"
	foreground_set = _tmp2_;
#line 363 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = g_settings_get_string (_data76_->settings, "google-fonts-background-color");
#line 363 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = _tmp3_;
#line 363 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = gdk_rgba_parse (&background, _tmp4_);
#line 363 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp4_);
#line 363 "../src/font-manager/web/google/PreviewPane.vala"
	background_set = _tmp5_;
#line 364 "../src/font-manager/web/google/PreviewPane.vala"
	if (foreground_set) {
#line 1852 "PreviewPane.c"
		GdkRGBA _tmp6_;
		GtkColorButton* _tmp7_;
		GdkRGBA _tmp8_;
#line 365 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = foreground;
#line 365 "../src/font-manager/web/google/PreviewPane.vala"
		if (_tmp6_.alpha == 0.0) {
#line 366 "../src/font-manager/web/google/PreviewPane.vala"
			foreground.alpha = 1.0;
#line 1862 "PreviewPane.c"
		}
#line 367 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp7_ = self->priv->fg_color_button;
#line 367 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = foreground;
#line 367 "../src/font-manager/web/google/PreviewPane.vala"
		gtk_color_chooser_set_rgba (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_color_chooser_get_type (), GtkColorChooser), &_tmp8_);
#line 1870 "PreviewPane.c"
	}
#line 369 "../src/font-manager/web/google/PreviewPane.vala"
	if (background_set) {
#line 1874 "PreviewPane.c"
		GdkRGBA _tmp9_;
		GtkColorButton* _tmp10_;
		GdkRGBA _tmp11_;
#line 370 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp9_ = background;
#line 370 "../src/font-manager/web/google/PreviewPane.vala"
		if (_tmp9_.alpha == 0.0) {
#line 371 "../src/font-manager/web/google/PreviewPane.vala"
			background.alpha = 1.0;
#line 1884 "PreviewPane.c"
		}
#line 372 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp10_ = self->priv->bg_color_button;
#line 372 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp11_ = background;
#line 372 "../src/font-manager/web/google/PreviewPane.vala"
		gtk_color_chooser_set_rgba (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_color_chooser_get_type (), GtkColorChooser), &_tmp11_);
#line 1892 "PreviewPane.c"
	}
#line 374 "../src/font-manager/web/google/PreviewPane.vala"
	result = G_SOURCE_REMOVE;
#line 374 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 1898 "PreviewPane.c"
}

static gboolean
___lambda211__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda211_ (self);
#line 359 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 1908 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_restore_state (FontManagerGoogleFontsPreviewPane* self,
                                                      GSettings* settings)
{
	Block76Data* _data76_;
	GSettings* _tmp0_;
	FontManagerPreviewEntry* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkRadioButton* _tmp4_;
	FontManagerGoogleFontsPreviewMode _tmp5_;
	FontManagerPreviewEntry* _tmp6_;
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (settings != NULL);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_data76_ = g_slice_new0 (Block76Data);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_data76_->_ref_count_ = 1;
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_data76_->self = g_object_ref (self);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (_data76_->settings);
#line 354 "../src/font-manager/web/google/PreviewPane.vala"
	_data76_->settings = _tmp0_;
#line 355 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_preview_size (self, g_settings_get_double (_data76_->settings, "google-fonts-font-size"));
#line 356 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->entry;
#line 356 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = g_settings_get_string (_data76_->settings, "google-fonts-preview-text");
#line 356 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 356 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp1_, _tmp3_);
#line 356 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp3_);
#line 357 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_mode (self, (FontManagerGoogleFontsPreviewMode) g_settings_get_enum (_data76_->settings, "google-fonts-preview-mode"));
#line 358 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = self->priv->lorem_ipsum;
#line 358 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = self->priv->_mode;
#line 358 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, _tmp5_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
#line 359 "../src/font-manager/web/google/PreviewPane.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda211__gsource_func, block76_data_ref (_data76_), block76_data_unref);
#line 376 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = self->priv->entry;
#line 376 "../src/font-manager/web/google/PreviewPane.vala"
	g_settings_bind (_data76_->settings, "google-fonts-preview-text", (GObject*) _tmp6_, "text", G_SETTINGS_BIND_DEFAULT);
#line 377 "../src/font-manager/web/google/PreviewPane.vala"
	g_settings_bind (_data76_->settings, "google-fonts-font-size", (GObject*) self, "preview-size", G_SETTINGS_BIND_DEFAULT);
#line 378 "../src/font-manager/web/google/PreviewPane.vala"
	g_settings_bind (_data76_->settings, "google-fonts-preview-mode", (GObject*) self, "mode", G_SETTINGS_BIND_DEFAULT);
#line 379 "../src/font-manager/web/google/PreviewPane.vala"
	block76_data_unref (_data76_);
#line 379 "../src/font-manager/web/google/PreviewPane.vala"
	_data76_ = NULL;
#line 379 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 1975 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_save_state (FontManagerGoogleFontsPreviewPane* self,
                                                   GSettings* settings)
{
	GtkColorButton* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkColorButton* _tmp4_;
	GdkRGBA _tmp5_ = {0};
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 382 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (settings != NULL);
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->fg_color_button;
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp0_, &_tmp1_);
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gdk_rgba_to_string (&_tmp1_);
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	g_settings_set_string (settings, "google-fonts-foreground-color", _tmp3_);
#line 383 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp3_);
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = self->priv->bg_color_button;
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp4_, &_tmp5_);
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = gdk_rgba_to_string (&_tmp5_);
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = _tmp6_;
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	g_settings_set_string (settings, "google-fonts-background-color", _tmp7_);
#line 384 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp7_);
#line 385 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 2020 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_on_mode_toggled (FontManagerGoogleFontsPreviewPane* self,
                                                        GtkToggleButton* widget)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkMenuButton* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
#line 389 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 389 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (widget != NULL);
#line 390 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = gtk_toggle_button_get_active (widget);
#line 390 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _tmp0_;
#line 390 "../src/font-manager/web/google/PreviewPane.vala"
	if (!_tmp1_) {
#line 391 "../src/font-manager/web/google/PreviewPane.vala"
		return;
#line 2046 "PreviewPane.c"
	}
#line 392 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gtk_widget_get_name ((GtkWidget*) widget);
#line 392 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 392 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_mode (self, (FontManagerGoogleFontsPreviewMode) atoi (_tmp3_));
#line 393 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = self->priv->menu_button;
#line 393 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = gtk_menu_button_get_popover (_tmp4_);
#line 393 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = _tmp5_;
#line 393 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_popover_popdown (_tmp6_);
#line 394 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 395 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 2066 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                   gpointer self)
{
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_on_mode_toggled ((FontManagerGoogleFontsPreviewPane*) self, _sender);
#line 2075 "PreviewPane.c"
}

static Block77Data*
block77_data_ref (Block77Data* _data77_)
{
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
	g_atomic_int_inc (&_data77_->_ref_count_);
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
	return _data77_;
#line 2085 "PreviewPane.c"
}

static void
block77_data_unref (void * _userdata_)
{
	Block77Data* _data77_;
	_data77_ = (Block77Data*) _userdata_;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
	if (g_atomic_int_dec_and_test (&_data77_->_ref_count_)) {
#line 2095 "PreviewPane.c"
		FontManagerGoogleFontsPreviewPane* self;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		self = _data77_->self;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->update = (_vala_array_free (_data77_->update, _data77_->update_length1, (GDestroyNotify) g_object_unref), NULL);
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self);
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		g_slice_free (Block77Data, _data77_);
#line 2105 "PreviewPane.c"
	}
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5795 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5796 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5796 "glib-2.0.vapi"
	return result;
#line 2119 "PreviewPane.c"
}

static void
_vala_array_add9 (FontManagerGoogleFontsFont** * array,
                  gint* length,
                  gint* size,
                  FontManagerGoogleFontsFont* value)
{
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
	if ((*length) == (*size)) {
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
		*array = g_renew (FontManagerGoogleFontsFont*, *array, (*size) + 1);
#line 2134 "PreviewPane.c"
	}
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
	(*array)[(*length)++] = value;
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
	(*array)[*length] = NULL;
#line 2140 "PreviewPane.c"
}

static FontManagerGoogleFontsFont**
_vala_array_dup10 (FontManagerGoogleFontsFont** self,
                   gssize length)
{
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
	if (length >= 0) {
#line 2149 "PreviewPane.c"
		FontManagerGoogleFontsFont** result;
		gssize i;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
		result = g_new0 (FontManagerGoogleFontsFont*, length + 1);
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
		for (i = 0; i < length; i++) {
#line 2156 "PreviewPane.c"
			FontManagerGoogleFontsFont* _tmp0_;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
			result[i] = _tmp0_;
#line 2162 "PreviewPane.c"
		}
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
		return result;
#line 2166 "PreviewPane.c"
	}
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
	return NULL;
#line 2170 "PreviewPane.c"
}

static void
____lambda213_ (Block77Data* _data77_,
                GObject* obj,
                GAsyncResult* res)
{
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerGoogleFontsFont** _tmp1_;
	gint _tmp1__length1;
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
	self = _data77_->self;
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (res != NULL);
#line 424 "../src/font-manager/web/google/PreviewPane.vala"
	if (font_manager_google_fonts_download_font_files_finish (res)) {
#line 2187 "PreviewPane.c"
		FontManagerGoogleFontsFileStatus _tmp0_;
#line 425 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
#line 425 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp0_);
#line 426 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
#line 2195 "PreviewPane.c"
	}
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _data77_->update;
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1__length1 = _data77_->update_length1;
#line 2201 "PreviewPane.c"
	{
		FontManagerGoogleFontsFont** font_collection = NULL;
		gint font_collection_length1 = 0;
		gint _font_collection_size_ = 0;
		gint font_it = 0;
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
		font_collection = _tmp1_;
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
		font_collection_length1 = _tmp1__length1;
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
		for (font_it = 0; font_it < font_collection_length1; font_it = font_it + 1) {
#line 2213 "PreviewPane.c"
			FontManagerGoogleFontsFont* _tmp2_;
			FontManagerGoogleFontsFont* font = NULL;
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp2_ = _g_object_ref0 (font_collection[font_it]);
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
			font = _tmp2_;
#line 2220 "PreviewPane.c"
			{
				FontManagerGoogleFontsFont* _tmp3_;
#line 429 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp3_ = font;
#line 429 "../src/font-manager/web/google/PreviewPane.vala"
				g_object_unref ((GObject*) _tmp3_);
#line 428 "../src/font-manager/web/google/PreviewPane.vala"
				_g_object_unref0 (font);
#line 2229 "PreviewPane.c"
			}
		}
	}
}

static void
_____lambda213__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
	____lambda213_ (self, source_object, res);
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
	block77_data_unref (self);
#line 2244 "PreviewPane.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2266 "PreviewPane.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2270 "PreviewPane.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2276 "PreviewPane.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2280 "PreviewPane.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2284 "PreviewPane.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 2292 "PreviewPane.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2320 "PreviewPane.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 2329 "PreviewPane.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2343 "PreviewPane.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 2352 "PreviewPane.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 2366 "PreviewPane.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2375 "PreviewPane.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 2384 "PreviewPane.c"
}

static void
____lambda214_ (FontManagerGoogleFontsPreviewPane* self,
                GObject* obj,
                GAsyncResult* res)
{
	FontManagerGoogleFontsFont* _tmp1_;
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (res != NULL);
#line 457 "../src/font-manager/web/google/PreviewPane.vala"
	if (font_manager_google_fonts_download_font_files_finish (res)) {
#line 2397 "PreviewPane.c"
		FontManagerGoogleFontsFileStatus _tmp0_;
#line 458 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
#line 458 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp0_);
#line 459 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
#line 2405 "PreviewPane.c"
	}
#line 461 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_font;
#line 461 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_unref ((GObject*) _tmp1_);
#line 2411 "PreviewPane.c"
}

static void
_____lambda214__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
	____lambda214_ ((FontManagerGoogleFontsPreviewPane*) self, source_object, res);
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_unref (self);
#line 2423 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_on_download_button_clicked (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFileStatus _tmp0_ = 0;
	FontManagerGoogleFontsFamily* _tmp1_;
	FontManagerGoogleFontsFileStatus status = 0;
	const gchar* _tmp4_ = NULL;
	FontManagerGoogleFontsFamily* _tmp5_;
	gchar* dirname = NULL;
	gchar* _tmp12_;
	GFile* font_dir = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	FontManagerGoogleFontsFamily* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 399 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_family;
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp1_ != NULL) {
#line 2452 "PreviewPane.c"
		FontManagerGoogleFontsFamily* _tmp2_;
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = self->priv->_family;
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = font_manager_google_fonts_family_get_installation_status (_tmp2_);
#line 2458 "PreviewPane.c"
	} else {
		FontManagerGoogleFontsFont* _tmp3_;
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp3_ = self->priv->_font;
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = font_manager_google_fonts_font_get_installation_status (_tmp3_);
#line 2465 "PreviewPane.c"
	}
#line 400 "../src/font-manager/web/google/PreviewPane.vala"
	status = _tmp0_;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = self->priv->_family;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp5_ != NULL) {
#line 2473 "PreviewPane.c"
		FontManagerGoogleFontsFamily* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = self->priv->_family;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp7_ = font_manager_google_fonts_family_get_family (_tmp6_);
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = _tmp7_;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp4_ = _tmp8_;
#line 2485 "PreviewPane.c"
	} else {
		FontManagerGoogleFontsFont* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp9_ = self->priv->_font;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp10_ = font_manager_google_fonts_font_get_family (_tmp9_);
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp11_ = _tmp10_;
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp4_ = _tmp11_;
#line 2498 "PreviewPane.c"
	}
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp12_ = g_strdup (_tmp4_);
#line 401 "../src/font-manager/web/google/PreviewPane.vala"
	dirname = _tmp12_;
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp13_ = font_manager_google_fonts_get_font_directory ();
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp14_ = _tmp13_;
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp15_ = dirname;
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp16_ = g_build_filename (_tmp14_, _tmp15_, NULL);
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp17_ = _tmp16_;
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp18_ = g_file_new_for_path (_tmp17_);
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp19_ = _tmp18_;
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp17_);
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (_tmp14_);
#line 402 "../src/font-manager/web/google/PreviewPane.vala"
	font_dir = _tmp19_;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp20_ = self->priv->_family;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp20_ != NULL) {
#line 2528 "PreviewPane.c"
		Block77Data* _data77_;
		GFile* _tmp36_;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_ = g_slice_new0 (Block77Data);
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->_ref_count_ = 1;
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->self = g_object_ref (self);
#line 404 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->update = NULL;
#line 404 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->update_length1 = 0;
#line 404 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_->_update_size_ = _data77_->update_length1;
#line 405 "../src/font-manager/web/google/PreviewPane.vala"
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE) {
#line 2545 "PreviewPane.c"
			{
				gint i = 0;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
				i = 0;
#line 2550 "PreviewPane.c"
				{
					gboolean _tmp21_ = FALSE;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
					_tmp21_ = TRUE;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
					while (TRUE) {
#line 2557 "PreviewPane.c"
						FontManagerGoogleFontsFamily* _tmp23_;
						GPtrArray* _tmp24_;
						GPtrArray* _tmp25_;
						gint _tmp26_;
						gint _tmp27_;
						FontManagerGoogleFontsFont* variant = NULL;
						FontManagerGoogleFontsFamily* _tmp28_;
						GPtrArray* _tmp29_;
						GPtrArray* _tmp30_;
						gconstpointer _tmp31_;
						FontManagerGoogleFontsFont* _tmp32_;
						FontManagerGoogleFontsFont* _tmp33_;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						if (!_tmp21_) {
#line 2572 "PreviewPane.c"
							gint _tmp22_;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
							_tmp22_ = i;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
							i = _tmp22_ + 1;
#line 2578 "PreviewPane.c"
						}
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp21_ = FALSE;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp23_ = self->priv->_family;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp24_ = font_manager_google_fonts_family_get_variants (_tmp23_);
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp25_ = _tmp24_;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp26_ = vala_g_ptr_array_get_length (_tmp25_);
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp27_ = _tmp26_;
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						if (!(i < _tmp27_)) {
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
							break;
#line 2596 "PreviewPane.c"
						}
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp28_ = self->priv->_family;
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp29_ = font_manager_google_fonts_family_get_variants (_tmp28_);
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp30_ = _tmp29_;
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp31_ = g_ptr_array_index (_tmp30_, (guint) i);
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp32_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) _tmp31_);
#line 407 "../src/font-manager/web/google/PreviewPane.vala"
						variant = _tmp32_;
#line 408 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp33_ = variant;
#line 408 "../src/font-manager/web/google/PreviewPane.vala"
						if (font_manager_google_fonts_font_get_installation_status (_tmp33_) != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
#line 2614 "PreviewPane.c"
							FontManagerGoogleFontsFont* _tmp34_;
							FontManagerGoogleFontsFont* _tmp35_;
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
							_tmp34_ = variant;
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
							_tmp35_ = _g_object_ref0 (_tmp34_);
#line 409 "../src/font-manager/web/google/PreviewPane.vala"
							_vala_array_add9 (&_data77_->update, &_data77_->update_length1, &_data77_->_update_size_, _tmp35_);
#line 2623 "PreviewPane.c"
						}
#line 406 "../src/font-manager/web/google/PreviewPane.vala"
						_g_object_unref0 (variant);
#line 2627 "PreviewPane.c"
					}
				}
			}
		}
#line 412 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp36_ = font_dir;
#line 412 "../src/font-manager/web/google/PreviewPane.vala"
		if (g_file_query_exists (_tmp36_, NULL)) {
#line 2636 "PreviewPane.c"
			GFile* _tmp37_;
#line 413 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp37_ = font_dir;
#line 413 "../src/font-manager/web/google/PreviewPane.vala"
			font_manager_remove_directory (_tmp37_, TRUE);
#line 2642 "PreviewPane.c"
		}
#line 414 "../src/font-manager/web/google/PreviewPane.vala"
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED) {
#line 2646 "PreviewPane.c"
			FontManagerGoogleFontsFileStatus _tmp38_;
#line 415 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp38_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 415 "../src/font-manager/web/google/PreviewPane.vala"
			font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp38_);
#line 416 "../src/font-manager/web/google/PreviewPane.vala"
			font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
#line 2654 "PreviewPane.c"
		} else {
			FontManagerGoogleFontsFont** _tmp39_;
			gint _tmp39__length1;
			FontManagerGoogleFontsFont** _tmp45_;
			gint _tmp45__length1;
			FontManagerGoogleFontsFont** _tmp48_;
			gint _tmp48__length1;
#line 418 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp39_ = _data77_->update;
#line 418 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp39__length1 = _data77_->update_length1;
#line 418 "../src/font-manager/web/google/PreviewPane.vala"
			if (_tmp39_ == NULL) {
#line 2668 "PreviewPane.c"
				FontManagerGoogleFontsFamily* _tmp40_;
				GPtrArray* _tmp41_;
				GPtrArray* _tmp42_;
				gpointer* _tmp43_;
				gint _tmp43__length1;
				FontManagerGoogleFontsFont** _tmp44_;
				gint _tmp44__length1;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp40_ = self->priv->_family;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp41_ = font_manager_google_fonts_family_get_variants (_tmp40_);
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp42_ = _tmp41_;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp43_ = _tmp42_->pdata;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp43__length1 = _tmp42_->len;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp44_ = (_tmp43_ != NULL) ? _vala_array_dup10 (_tmp43_, _tmp43__length1) : _tmp43_;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp44__length1 = _tmp43__length1;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_data77_->update = (_vala_array_free (_data77_->update, _data77_->update_length1, (GDestroyNotify) g_object_unref), NULL);
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_data77_->update = _tmp44_;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_data77_->update_length1 = _tmp44__length1;
#line 419 "../src/font-manager/web/google/PreviewPane.vala"
				_data77_->_update_size_ = _data77_->update_length1;
#line 2698 "PreviewPane.c"
			}
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp45_ = _data77_->update;
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp45__length1 = _data77_->update_length1;
#line 2704 "PreviewPane.c"
			{
				FontManagerGoogleFontsFont** font_collection = NULL;
				gint font_collection_length1 = 0;
				gint _font_collection_size_ = 0;
				gint font_it = 0;
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
				font_collection = _tmp45_;
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
				font_collection_length1 = _tmp45__length1;
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
				for (font_it = 0; font_it < font_collection_length1; font_it = font_it + 1) {
#line 2716 "PreviewPane.c"
					FontManagerGoogleFontsFont* _tmp46_;
					FontManagerGoogleFontsFont* font = NULL;
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
					_tmp46_ = _g_object_ref0 (font_collection[font_it]);
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
					font = _tmp46_;
#line 2723 "PreviewPane.c"
					{
						FontManagerGoogleFontsFont* _tmp47_;
#line 422 "../src/font-manager/web/google/PreviewPane.vala"
						_tmp47_ = font;
#line 422 "../src/font-manager/web/google/PreviewPane.vala"
						g_object_ref ((GObject*) _tmp47_);
#line 421 "../src/font-manager/web/google/PreviewPane.vala"
						_g_object_unref0 (font);
#line 2732 "PreviewPane.c"
					}
				}
			}
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp48_ = _data77_->update;
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp48__length1 = _data77_->update_length1;
#line 423 "../src/font-manager/web/google/PreviewPane.vala"
			font_manager_google_fonts_download_font_files (_tmp48_, (gint) _tmp48__length1, _____lambda213__gasync_ready_callback, block77_data_ref (_data77_));
#line 2742 "PreviewPane.c"
		}
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		block77_data_unref (_data77_);
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_data77_ = NULL;
#line 2748 "PreviewPane.c"
	} else {
		GFile* font_file = NULL;
		GFile* _tmp85_;
		gboolean _tmp95_ = FALSE;
#line 433 "../src/font-manager/web/google/PreviewPane.vala"
		font_file = NULL;
#line 434 "../src/font-manager/web/google/PreviewPane.vala"
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE) {
#line 2757 "PreviewPane.c"
			gchar* ext = NULL;
			FontManagerGoogleFontsFont* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* style = NULL;
			FontManagerGoogleFontsFont* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* family = NULL;
			FontManagerGoogleFontsFont* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* filename = NULL;
			const gchar* _tmp62_;
			const gchar* _tmp63_;
			FontManagerGoogleFontsFont* _tmp64_;
			gint _tmp65_;
			gint _tmp66_;
			const gchar* _tmp67_;
			gchar* _tmp68_;
			GFile* _tmp69_;
			gchar* _tmp70_;
			gchar* _tmp71_;
			const gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
			GFile* _tmp75_;
#line 435 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp49_ = self->priv->_font;
#line 435 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp50_ = font_manager_google_fonts_font_get_url (_tmp49_);
#line 435 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp51_ = _tmp50_;
#line 435 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp52_ = font_manager_get_file_extension (_tmp51_);
#line 435 "../src/font-manager/web/google/PreviewPane.vala"
			ext = _tmp52_;
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp53_ = self->priv->_font;
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp54_ = font_manager_google_fonts_font_to_description (_tmp53_);
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp55_ = _tmp54_;
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp56_ = string_replace (_tmp55_, " ", "_");
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp57_ = _tmp56_;
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (_tmp55_);
#line 436 "../src/font-manager/web/google/PreviewPane.vala"
			style = _tmp57_;
#line 437 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp58_ = self->priv->_font;
#line 437 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp59_ = font_manager_google_fonts_font_get_family (_tmp58_);
#line 437 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp60_ = _tmp59_;
#line 437 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp61_ = string_replace (_tmp60_, " ", "_");
#line 437 "../src/font-manager/web/google/PreviewPane.vala"
			family = _tmp61_;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp62_ = family;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp63_ = style;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp64_ = self->priv->_font;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp65_ = font_manager_google_fonts_font_get_version (_tmp64_);
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp66_ = _tmp65_;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp67_ = ext;
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp68_ = g_strdup_printf ("%s_%s.%i.%s", _tmp62_, _tmp63_, _tmp66_ - 1, _tmp67_);
#line 438 "../src/font-manager/web/google/PreviewPane.vala"
			filename = _tmp68_;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp69_ = font_dir;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp70_ = g_file_get_path (_tmp69_);
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp71_ = _tmp70_;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp72_ = filename;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp73_ = g_build_filename (_tmp71_, _tmp72_, NULL);
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp74_ = _tmp73_;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp75_ = g_file_new_for_path (_tmp74_);
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_g_object_unref0 (font_file);
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			font_file = _tmp75_;
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (_tmp74_);
#line 439 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (_tmp71_);
#line 434 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (filename);
#line 434 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (family);
#line 434 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (style);
#line 434 "../src/font-manager/web/google/PreviewPane.vala"
			_g_free0 (ext);
#line 2869 "PreviewPane.c"
		} else {
#line 440 "../src/font-manager/web/google/PreviewPane.vala"
			if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED) {
#line 2873 "PreviewPane.c"
				GFile* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				FontManagerGoogleFontsFont* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				GFile* _tmp84_;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp76_ = font_dir;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp77_ = g_file_get_path (_tmp76_);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp78_ = _tmp77_;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp79_ = self->priv->_font;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp80_ = font_manager_google_fonts_font_get_filename (_tmp79_);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp81_ = _tmp80_;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp82_ = g_build_filename (_tmp78_, _tmp81_, NULL);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp83_ = _tmp82_;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp84_ = g_file_new_for_path (_tmp83_);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_g_object_unref0 (font_file);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				font_file = _tmp84_;
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (_tmp83_);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (_tmp81_);
#line 441 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (_tmp78_);
#line 2911 "PreviewPane.c"
			}
		}
#line 443 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp85_ = font_file;
#line 443 "../src/font-manager/web/google/PreviewPane.vala"
		if (_tmp85_ != NULL) {
#line 2918 "PreviewPane.c"
			{
				GFile* _tmp86_;
				GFile* _tmp87_;
				FontManagerGoogleFontsFileStatus _tmp88_;
#line 445 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp86_ = font_file;
#line 445 "../src/font-manager/web/google/PreviewPane.vala"
				g_file_delete (_tmp86_, NULL, &_inner_error0_);
#line 445 "../src/font-manager/web/google/PreviewPane.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2929 "PreviewPane.c"
					goto __catch0_g_error;
				}
#line 446 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp87_ = font_dir;
#line 446 "../src/font-manager/web/google/PreviewPane.vala"
				font_manager_remove_directory_tree_if_empty (_tmp87_);
#line 447 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp88_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
#line 447 "../src/font-manager/web/google/PreviewPane.vala"
				font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp88_);
#line 448 "../src/font-manager/web/google/PreviewPane.vala"
				font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
#line 2942 "PreviewPane.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GFile* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				GError* _tmp92_;
				GError* _tmp93_;
				const gchar* _tmp94_;
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				e = _inner_error0_;
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				_inner_error0_ = NULL;
#line 450 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp89_ = font_file;
#line 450 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp90_ = g_file_get_path (_tmp89_);
#line 450 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp91_ = _tmp90_;
#line 450 "../src/font-manager/web/google/PreviewPane.vala"
				g_warning ("PreviewPane.vala:450: Failed to remove file : %s", _tmp91_);
#line 450 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (_tmp91_);
#line 451 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp92_ = e;
#line 451 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp93_ = e;
#line 451 "../src/font-manager/web/google/PreviewPane.vala"
				_tmp94_ = _tmp93_->message;
#line 451 "../src/font-manager/web/google/PreviewPane.vala"
				g_critical ("PreviewPane.vala:451: %i : %s", _tmp92_->code, _tmp94_);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				_g_error_free0 (e);
#line 2978 "PreviewPane.c"
			}
			__finally0:
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				_g_object_unref0 (font_file);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				_g_object_unref0 (font_dir);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				_g_free0 (dirname);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				g_clear_error (&_inner_error0_);
#line 444 "../src/font-manager/web/google/PreviewPane.vala"
				return;
#line 2995 "PreviewPane.c"
			}
		}
#line 454 "../src/font-manager/web/google/PreviewPane.vala"
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
#line 454 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp95_ = TRUE;
#line 3002 "PreviewPane.c"
		} else {
#line 454 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp95_ = status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE;
#line 3006 "PreviewPane.c"
		}
#line 454 "../src/font-manager/web/google/PreviewPane.vala"
		if (_tmp95_) {
#line 3010 "PreviewPane.c"
			FontManagerGoogleFontsFont* _tmp96_;
			FontManagerGoogleFontsFont* _tmp97_;
			FontManagerGoogleFontsFont* _tmp98_;
			FontManagerGoogleFontsFont** _tmp99_;
			FontManagerGoogleFontsFont** _tmp100_;
			gint _tmp100__length1;
#line 455 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp96_ = self->priv->_font;
#line 455 "../src/font-manager/web/google/PreviewPane.vala"
			g_object_ref ((GObject*) _tmp96_);
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp97_ = self->priv->_font;
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp98_ = _g_object_ref0 (_tmp97_);
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp99_ = g_new0 (FontManagerGoogleFontsFont*, 1 + 1);
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp99_[0] = _tmp98_;
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp100_ = _tmp99_;
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp100__length1 = 1;
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			font_manager_google_fonts_download_font_files (_tmp100_, (gint) 1, _____lambda214__gasync_ready_callback, g_object_ref (self));
#line 456 "../src/font-manager/web/google/PreviewPane.vala"
			_tmp100_ = (_vala_array_free (_tmp100_, _tmp100__length1, (GDestroyNotify) g_object_unref), NULL);
#line 3037 "PreviewPane.c"
		}
#line 403 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (font_file);
#line 3041 "PreviewPane.c"
	}
#line 465 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (font_dir);
#line 465 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (dirname);
#line 465 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 3049 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                       gpointer self)
{
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_on_download_button_clicked ((FontManagerGoogleFontsPreviewPane*) self);
#line 3058 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_on_entry_changed (FontManagerGoogleFontsPreviewPane* self)
{
	const gchar* _tmp0_ = NULL;
	FontManagerPreviewEntry* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 469 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->entry;
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = gtk_entry_get_text_length ((GtkEntry*) _tmp1_);
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp3_ > ((guint) 0)) {
#line 3078 "PreviewPane.c"
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp4_ = self->priv->entry;
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) _tmp4_);
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = _tmp5_;
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _tmp6_;
#line 3090 "PreviewPane.c"
	} else {
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = NULL;
#line 3094 "PreviewPane.c"
	}
#line 470 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_preview_text (self, _tmp0_);
#line 471 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 472 "../src/font-manager/web/google/PreviewPane.vala"
	return;
#line 3102 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                               gpointer self)
{
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_on_entry_changed ((FontManagerGoogleFontsPreviewPane*) self);
#line 3111 "PreviewPane.c"
}

FontManagerGoogleFontsPreviewPane*
font_manager_google_fonts_preview_pane_construct (GType object_type)
{
	FontManagerGoogleFontsPreviewPane * self = NULL;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	self = (FontManagerGoogleFontsPreviewPane*) g_object_new (object_type, NULL);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	return self;
#line 3122 "PreviewPane.c"
}

FontManagerGoogleFontsPreviewPane*
font_manager_google_fonts_preview_pane_new (void)
{
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	return font_manager_google_fonts_preview_pane_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE);
#line 3130 "PreviewPane.c"
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_preview_pane_get_family (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFamily* result;
	FontManagerGoogleFontsFamily* _tmp0_;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_family;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp0_;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3146 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_family (FontManagerGoogleFontsPreviewPane* self,
                                                   FontManagerGoogleFontsFamily* value)
{
	FontManagerGoogleFontsFamily* old_value;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_family (self);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 3160 "PreviewPane.c"
		FontManagerGoogleFontsFamily* _tmp0_;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self->priv->_family);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_family = _tmp0_;
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY]);
#line 3170 "PreviewPane.c"
	}
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_preview_pane_get_font (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFont* result;
	FontManagerGoogleFontsFont* _tmp0_;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_font;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp0_;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3187 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_font (FontManagerGoogleFontsPreviewPane* self,
                                                 FontManagerGoogleFontsFont* value)
{
	FontManagerGoogleFontsFont* old_value;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_font (self);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 3201 "PreviewPane.c"
		FontManagerGoogleFontsFont* _tmp0_;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self->priv->_font);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_font = _tmp0_;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY]);
#line 3211 "PreviewPane.c"
	}
}

gboolean
font_manager_google_fonts_preview_pane_get_refresh_required (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean result;
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_refresh_required;
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3225 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_refresh_required (FontManagerGoogleFontsPreviewPane* self,
                                                             gboolean value)
{
	gboolean old_value;
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_refresh_required (self);
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_refresh_required = value;
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY]);
#line 3243 "PreviewPane.c"
	}
}

gboolean
font_manager_google_fonts_preview_pane_get_show_line_size (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean result;
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_show_line_size;
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3257 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_show_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gboolean value)
{
	gboolean old_value;
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_show_line_size (self);
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_show_line_size = value;
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY]);
#line 3275 "PreviewPane.c"
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_preview_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_preview_size;
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3289 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_preview_size (FontManagerGoogleFontsPreviewPane* self,
                                                         gdouble value)
{
	gdouble old_value;
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_preview_size (self);
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_preview_size = value;
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY]);
#line 3307 "PreviewPane.c"
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_min_waterfall_size;
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3321 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_min_waterfall_size (self);
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_min_waterfall_size = value;
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY]);
#line 3339 "PreviewPane.c"
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_max_waterfall_size;
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3353 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                               gdouble value)
{
	gdouble old_value;
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_max_waterfall_size (self);
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_max_waterfall_size = value;
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY]);
#line 3371 "PreviewPane.c"
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_waterfall_size_ratio;
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3385 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self,
                                                                 gdouble value)
{
	gdouble old_value;
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (self);
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_waterfall_size_ratio = value;
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY]);
#line 3403 "PreviewPane.c"
	}
}

WebKitWebView*
font_manager_google_fonts_preview_pane_get_preview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* result;
	WebKitWebView* _tmp0_;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_preview;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp0_;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3420 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_preview (FontManagerGoogleFontsPreviewPane* self,
                                                    WebKitWebView* value)
{
	WebKitWebView* old_value;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_preview (self);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 3434 "PreviewPane.c"
		WebKitWebView* _tmp0_;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self->priv->_preview);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_preview = _tmp0_;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY]);
#line 3444 "PreviewPane.c"
	}
}

FontManagerGoogleFontsPreviewMode
font_manager_google_fonts_preview_pane_get_mode (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsPreviewMode result;
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	result = self->priv->_mode;
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3458 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_mode (FontManagerGoogleFontsPreviewPane* self,
                                                 FontManagerGoogleFontsPreviewMode value)
{
	FontManagerGoogleFontsPreviewMode old_value;
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	old_value = font_manager_google_fonts_preview_pane_get_mode (self);
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	if (old_value != value) {
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
		self->priv->_mode = value;
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY]);
#line 3476 "PreviewPane.c"
	}
}

const gchar*
font_manager_google_fonts_preview_pane_get_preview_text (FontManagerGoogleFontsPreviewPane* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 94 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_preview_text;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp1_ != NULL) {
#line 3492 "PreviewPane.c"
		const gchar* _tmp2_;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = self->priv->_preview_text;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _tmp2_;
#line 3498 "PreviewPane.c"
	} else {
		const gchar* _tmp3_;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp3_ = self->priv->default_preview_text;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = _tmp3_;
#line 3505 "PreviewPane.c"
	}
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
	result = _tmp0_;
#line 95 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3511 "PreviewPane.c"
}

void
font_manager_google_fonts_preview_pane_set_preview_text (FontManagerGoogleFontsPreviewPane* self,
                                                         const gchar* value)
{
	gchar* _tmp0_;
#line 97 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_strdup (value);
#line 98 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (self->priv->_preview_text);
#line 98 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_preview_text = _tmp0_;
#line 97 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY]);
#line 3529 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda215_ (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* _tmp0_;
#line 171 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_preview;
#line 171 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp0_ == NULL) {
#line 3540 "PreviewPane.c"
		WebKitWebView* _tmp1_;
		WebKitWebView* _tmp2_;
#line 172 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp1_ = font_manager_google_fonts_preview_pane_get_webkit_webview (self);
#line 172 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = _tmp1_;
#line 172 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_preview (self, _tmp2_);
#line 172 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (_tmp2_);
#line 3551 "PreviewPane.c"
	}
#line 173 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_set_refresh_required (self, FALSE);
#line 3555 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map (GtkWidget* _sender,
                                                                      gpointer self)
{
#line 170 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda215_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 3564 "PreviewPane.c"
}

static gboolean
__lambda217_ (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	gboolean result;
#line 179 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = font_manager_get_default_application ();
#line 179 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _tmp0_;
#line 179 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_application_refresh (_tmp1_);
#line 179 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (_tmp1_);
#line 180 "../src/font-manager/web/google/PreviewPane.vala"
	result = G_SOURCE_REMOVE;
#line 180 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3585 "PreviewPane.c"
}

static gboolean
___lambda217__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda217_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 178 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3595 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda216_ (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean _tmp0_;
#line 176 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_refresh_required;
#line 176 "../src/font-manager/web/google/PreviewPane.vala"
	if (!_tmp0_) {
#line 177 "../src/font-manager/web/google/PreviewPane.vala"
		return;
#line 3608 "PreviewPane.c"
	}
#line 178 "../src/font-manager/web/google/PreviewPane.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda217__gsource_func, g_object_ref (self), g_object_unref);
#line 3612 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap (GtkWidget* _sender,
                                                                        gpointer self)
{
#line 175 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda216_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 3621 "PreviewPane.c"
}

static Block78Data*
block78_data_ref (Block78Data* _data78_)
{
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	g_atomic_int_inc (&_data78_->_ref_count_);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	return _data78_;
#line 3631 "PreviewPane.c"
}

static void
block78_data_unref (void * _userdata_)
{
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
#line 3641 "PreviewPane.c"
		FontManagerGoogleFontsPreviewPane* self;
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
		self = _data78_->self;
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (_data78_->main_window);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
		_g_object_unref0 (self);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
		g_slice_free (Block78Data, _data78_);
#line 3651 "PreviewPane.c"
	}
}

static gboolean
___lambda219_ (Block78Data* _data78_)
{
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerMainWindow* _tmp0_;
	gboolean result;
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	self = _data78_->self;
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = _data78_->main_window;
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_main_window_set_model (_tmp0_, NULL);
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	result = G_SOURCE_REMOVE;
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3671 "PreviewPane.c"
}

static gboolean
____lambda219__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda219_ (self);
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
	return result;
#line 3681 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda218_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	Block78Data* _data78_;
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	FontManagerMainWindow* _tmp2_;
	FontManagerMainWindow* _tmp3_;
	FontManagerMainWindow* _tmp4_;
	FontManagerMainWindow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	_data78_ = g_slice_new0 (Block78Data);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	_data78_->_ref_count_ = 1;
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	_data78_->self = g_object_ref (self);
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = font_manager_get_default_application ();
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = font_manager_application_get_main_window (_tmp1_);
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _tmp2_;
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = _tmp4_;
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (_tmp1_);
#line 186 "../src/font-manager/web/google/PreviewPane.vala"
	_data78_->main_window = _tmp5_;
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = self->priv->_refresh_required;
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp7_) {
#line 3728 "PreviewPane.c"
		FontManagerMainWindow* _tmp8_;
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp8_ = _data78_->main_window;
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = _tmp8_ != NULL;
#line 3734 "PreviewPane.c"
	} else {
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp6_ = FALSE;
#line 3738 "PreviewPane.c"
	}
#line 187 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp6_) {
#line 188 "../src/font-manager/web/google/PreviewPane.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda219__gsource_func, block78_data_ref (_data78_), block78_data_unref);
#line 3744 "PreviewPane.c"
	}
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	block78_data_unref (_data78_);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	_data78_ = NULL;
#line 3750 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda218__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda218_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3760 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda220_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerGoogleFontsFileStatus _tmp0_ = 0;
	FontManagerGoogleFontsFamily* _tmp1_;
	FontManagerGoogleFontsFileStatus status = 0;
#line 190 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 190 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_family;
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
	if (_tmp1_ != NULL) {
#line 3779 "PreviewPane.c"
		FontManagerGoogleFontsFamily* _tmp2_;
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp2_ = self->priv->_family;
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = font_manager_google_fonts_family_get_installation_status (_tmp2_);
#line 3785 "PreviewPane.c"
	} else {
		FontManagerGoogleFontsFont* _tmp3_;
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp3_ = self->priv->_font;
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = font_manager_google_fonts_font_get_installation_status (_tmp3_);
#line 3792 "PreviewPane.c"
	}
#line 191 "../src/font-manager/web/google/PreviewPane.vala"
	status = _tmp0_;
#line 192 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_selection_changed (self, &status);
#line 3798 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda220__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 190 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda220_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3808 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda221_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerGoogleFontsFileStatus status = 0;
	FontManagerGoogleFontsFont* _tmp0_;
#line 194 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 194 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 195 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 196 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->_font;
#line 196 "../src/font-manager/web/google/PreviewPane.vala"
	status = font_manager_google_fonts_font_get_installation_status (_tmp0_);
#line 197 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_selection_changed (self, &status);
#line 3830 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda221__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 194 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda221_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3840 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda222_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerPreviewEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->entry;
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = _tmp1_;
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp0_, _tmp2_);
#line 3863 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda222__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda222_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3873 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda223_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	GtkBox* _tmp0_;
	FontManagerGoogleFontsPreviewMode _tmp1_;
	FontManagerPreviewEntry* _tmp2_;
	FontManagerGoogleFontsPreviewMode _tmp3_;
#line 200 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 200 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 201 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->scale_container;
#line 201 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->_mode;
#line 201 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, _tmp1_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
#line 202 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = self->priv->entry;
#line 202 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = self->priv->_mode;
#line 202 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, _tmp3_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL);
#line 3901 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda223__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 200 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda223_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3911 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda224_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
#line 204 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (obj != NULL);
#line 204 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (pspec != NULL);
#line 204 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 3925 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda224__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 204 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda224_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
#line 3935 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda225_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 205 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 3943 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                  gpointer self)
{
#line 205 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda225_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 3952 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda226_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 206 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 3960 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                  gpointer self)
{
#line 206 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda226_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 3969 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda227_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 207 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 3977 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda227__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 207 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda227_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 3987 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda228_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 208 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 3995 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda228__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 208 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda228_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 4005 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda229_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 209 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 4013 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda229__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 209 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda229_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 4023 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda230_ (FontManagerGoogleFontsPreviewPane* self)
{
#line 210 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_update_preview (self);
#line 4031 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda230__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 210 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda230_ ((FontManagerGoogleFontsPreviewPane*) self);
#line 4041 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda231_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GtkEntry* entry,
                                                      GtkEntryIconPosition position,
                                                      GdkEvent* event)
{
#line 222 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (entry != NULL);
#line 222 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (event != NULL);
#line 223 "../src/font-manager/web/google/PreviewPane.vala"
	if (position == GTK_ENTRY_ICON_PRIMARY) {
#line 4056 "PreviewPane.c"
		FontManagerGoogleFontsSampleList* _tmp0_;
		FontManagerGoogleFontsSampleList* _tmp1_;
#line 224 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp0_ = self->priv->sample_list;
#line 224 "../src/font-manager/web/google/PreviewPane.vala"
		gtk_popover_popup ((GtkPopover*) _tmp0_);
#line 225 "../src/font-manager/web/google/PreviewPane.vala"
		_tmp1_ = self->priv->sample_list;
#line 225 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_sample_list_unselect_all (_tmp1_);
#line 4067 "PreviewPane.c"
	}
}

static void
__font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press (GtkEntry* _sender,
                                                                            GtkEntryIconPosition icon_pos,
                                                                            GdkEvent* event,
                                                                            gpointer self)
{
#line 222 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda231_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, icon_pos, event);
#line 4079 "PreviewPane.c"
}

static void
_font_manager_google_fonts_preview_pane___lambda232_ (FontManagerGoogleFontsPreviewPane* self,
                                                      const gchar* s)
{
	FontManagerPreviewEntry* _tmp0_;
	FontManagerGoogleFontsSampleList* _tmp1_;
	FontManagerGoogleFontsFont* _tmp2_;
	FontManagerGoogleFontsFont* _tmp3_;
#line 228 "../src/font-manager/web/google/PreviewPane.vala"
	g_return_if_fail (s != NULL);
#line 229 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->entry;
#line 229 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp0_, s);
#line 230 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = self->priv->sample_list;
#line 230 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp1_);
#line 232 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->restore_default_preview = TRUE;
#line 233 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = self->priv->_font;
#line 233 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 233 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->stored_font);
#line 233 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->stored_font = _tmp3_;
#line 4110 "PreviewPane.c"
}

static void
__font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                          const gchar* sample,
                                                                                                          gpointer self)
{
#line 228 "../src/font-manager/web/google/PreviewPane.vala"
	_font_manager_google_fonts_preview_pane___lambda232_ ((FontManagerGoogleFontsPreviewPane*) self, sample);
#line 4120 "PreviewPane.c"
}

static GObject *
font_manager_google_fonts_preview_pane_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerGoogleFontsPreviewPane * self;
	FontManagerPreviewEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkColorButton* _tmp3_;
	GtkColorButton* _tmp4_;
	GtkBox* _tmp5_;
	GtkButton* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkBox* _tmp8_;
	FontManagerGoogleFontsPreviewMode _tmp9_;
	FontManagerPreviewEntry* _tmp10_;
	FontManagerGoogleFontsPreviewMode _tmp11_;
	FontManagerFontScale* _tmp12_;
	FontManagerPreviewEntry* _tmp13_;
	GtkWidget* _tmp14_;
	FontManagerGoogleFontsSampleList* _tmp15_ = NULL;
	FontManagerPreviewEntry* _tmp16_;
	FontManagerPreviewEntry* _tmp17_;
	FontManagerGoogleFontsSampleList* _tmp18_;
#line 168 "../src/font-manager/web/google/PreviewPane.vala"
	parent_class = G_OBJECT_CLASS (font_manager_google_fonts_preview_pane_parent_class);
#line 168 "../src/font-manager/web/google/PreviewPane.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 168 "../src/font-manager/web/google/PreviewPane.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
#line 170 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map, self, 0);
#line 175 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GtkWidget*) self, "unmap", (GCallback) __font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap, self, 0);
#line 183 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = self->priv->entry;
#line 183 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp1_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
#line 183 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp2_ = _tmp1_;
#line 183 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp0_, _tmp2_);
#line 184 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::refresh-required", (GCallback) __font_manager_google_fonts_preview_pane___lambda218__g_object_notify, self, 0);
#line 190 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::family", (GCallback) __font_manager_google_fonts_preview_pane___lambda220__g_object_notify, self, 0);
#line 194 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::font", (GCallback) __font_manager_google_fonts_preview_pane___lambda221__g_object_notify, self, 0);
#line 199 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::preview-text", (GCallback) __font_manager_google_fonts_preview_pane___lambda222__g_object_notify, self, 0);
#line 200 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::mode", (GCallback) __font_manager_google_fonts_preview_pane___lambda223__g_object_notify, self, 0);
#line 204 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::preview-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda224__g_object_notify, self, 0);
#line 205 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp3_ = self->priv->bg_color_button;
#line 205 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (_tmp3_, "color-set", (GCallback) __font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set, self, G_CONNECT_AFTER);
#line 206 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp4_ = self->priv->fg_color_button;
#line 206 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (_tmp4_, "color-set", (GCallback) __font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set, self, G_CONNECT_AFTER);
#line 207 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::min-waterfall-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda227__g_object_notify, self, G_CONNECT_AFTER);
#line 208 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::max-waterfall-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda228__g_object_notify, self, G_CONNECT_AFTER);
#line 209 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::waterfall-size-ratio", (GCallback) __font_manager_google_fonts_preview_pane___lambda229__g_object_notify, self, G_CONNECT_AFTER);
#line 210 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GObject*) self, "notify::show-line-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda230__g_object_notify, self, G_CONNECT_AFTER);
#line 211 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp5_ = self->priv->controls;
#line 211 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_set_button_relief_style ((GtkContainer*) _tmp5_, GTK_RELIEF_NONE);
#line 212 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp6_ = self->priv->download_button;
#line 212 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_button_set_relief (_tmp6_, GTK_RELIEF_NORMAL);
#line 213 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp7_ = self->priv->menu_button;
#line 213 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_button_set_relief ((GtkButton*) _tmp7_, GTK_RELIEF_NORMAL);
#line 214 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp8_ = self->priv->scale_container;
#line 214 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp9_ = self->priv->_mode;
#line 214 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, _tmp9_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
#line 215 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp10_ = self->priv->entry;
#line 215 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp11_ = self->priv->_mode;
#line 215 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, _tmp11_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL);
#line 216 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp12_ = self->priv->fontscale;
#line 216 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_bind_property_with_closures ((GObject*) self, "preview-size", (GObject*) _tmp12_, "value", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp13_ = self->priv->entry;
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp14_ = _g_object_ref0 ((GtkWidget*) _tmp13_);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp15_ = font_manager_google_fonts_sample_list_new ();
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_popover_set_relative_to ((GtkPopover*) _tmp15_, _tmp14_);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (_tmp14_);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_popover_set_position ((GtkPopover*) _tmp15_, GTK_POS_BOTTOM);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_ref_sink (_tmp15_);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->sample_list);
#line 217 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->sample_list = _tmp15_;
#line 221 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp16_ = self->priv->entry;
#line 221 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_entry_set_icon_from_icon_name ((GtkEntry*) _tmp16_, GTK_ENTRY_ICON_PRIMARY, "preferences-desktop-locale-symbolic");
#line 222 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp17_ = self->priv->entry;
#line 222 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object ((GtkEntry*) _tmp17_, "icon-press", (GCallback) __font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press, self, 0);
#line 228 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp18_ = self->priv->sample_list;
#line 228 "../src/font-manager/web/google/PreviewPane.vala"
	g_signal_connect_object (_tmp18_, "row-selected", (GCallback) __font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected, self, 0);
#line 168 "../src/font-manager/web/google/PreviewPane.vala"
	return obj;
#line 4256 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_class_init (FontManagerGoogleFontsPreviewPaneClass * klass,
                                                   gpointer klass_data)
{
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	font_manager_google_fonts_preview_pane_parent_class = g_type_class_peek_parent (klass);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsPreviewPane_private_offset);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_preview_pane_get_property;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_preview_pane_set_property;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_google_fonts_preview_pane_constructor;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_preview_pane_finalize;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY] = g_param_spec_object ("family", "family", "family", FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY] = g_param_spec_object ("font", "font", "font", FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY] = g_param_spec_boolean ("refresh-required", "refresh-required", "refresh-required", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY] = g_param_spec_boolean ("show-line-size", "show-line-size", "show-line-size", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY] = g_param_spec_double ("preview-size", "preview-size", "preview-size", -G_MAXDOUBLE, G_MAXDOUBLE, 16.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("min-waterfall-size", "min-waterfall-size", "min-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MIN_FONT_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("max-waterfall-size", "max-waterfall-size", "max-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MAX_FONT_SIZE * 2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY] = g_param_spec_double ("waterfall-size-ratio", "waterfall-size-ratio", "waterfall-size-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY] = g_param_spec_object ("preview", "preview", "preview", webkit_web_view_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_MODE, FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY] = g_param_spec_string ("preview-text", "preview-text", "preview-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/FontManager/web/google/ui/google-fonts-preview-pane.ui");
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, controls));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scale_container", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, scale_container));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "download_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, download_button));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_box", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, preview_box));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bg_color_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, bg_color_button));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fg_color_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, fg_color_button));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, menu_button));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, entry));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fontscale", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, fontscale));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "lorem_ipsum", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, lorem_ipsum));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_mode_toggled", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_download_button_clicked", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_changed", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed));
#line 4325 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_instance_init (FontManagerGoogleFontsPreviewPane * self,
                                                      gpointer klass)
{
	gchar* _tmp0_;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv = font_manager_google_fonts_preview_pane_get_instance_private (self);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_family = NULL;
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_font = NULL;
#line 84 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_refresh_required = FALSE;
#line 85 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_show_line_size = TRUE;
#line 86 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_preview_size = 16.0;
#line 87 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_min_waterfall_size = FONT_MANAGER_MIN_FONT_SIZE;
#line 88 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_max_waterfall_size = FONT_MANAGER_MAX_FONT_SIZE * 2;
#line 89 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_waterfall_size_ratio = 1.1;
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_preview = NULL;
#line 91 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_mode = FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL;
#line 113 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->_preview_text = NULL;
#line 114 "../src/font-manager/web/google/PreviewPane.vala"
	_tmp0_ = g_strdup ("The quick brown fox jumps over the lazy dog.");
#line 114 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->default_preview_text = _tmp0_;
#line 115 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->restore_default_preview = FALSE;
#line 116 "../src/font-manager/web/google/PreviewPane.vala"
	self->priv->stored_font = NULL;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	g_type_ensure (FONT_MANAGER_TYPE_PREVIEW_ENTRY);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 4369 "PreviewPane.c"
}

static void
font_manager_google_fonts_preview_pane_finalize (GObject * obj)
{
	FontManagerGoogleFontsPreviewPane * self;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
#line 82 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->_family);
#line 83 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->_font);
#line 90 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->_preview);
#line 113 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (self->priv->_preview_text);
#line 114 "../src/font-manager/web/google/PreviewPane.vala"
	_g_free0 (self->priv->default_preview_text);
#line 116 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->stored_font);
#line 118 "../src/font-manager/web/google/PreviewPane.vala"
	_g_object_unref0 (self->priv->sample_list);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	G_OBJECT_CLASS (font_manager_google_fonts_preview_pane_parent_class)->finalize (obj);
#line 4394 "PreviewPane.c"
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsPreviewPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_preview_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsPreviewPane), 0, (GInstanceInitFunc) font_manager_google_fonts_preview_pane_instance_init, NULL };
	GType font_manager_google_fonts_preview_pane_type_id;
	font_manager_google_fonts_preview_pane_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerGoogleFontsPreviewPane", &g_define_type_info, 0);
	FontManagerGoogleFontsPreviewPane_private_offset = g_type_add_instance_private (font_manager_google_fonts_preview_pane_type_id, sizeof (FontManagerGoogleFontsPreviewPanePrivate));
	return font_manager_google_fonts_preview_pane_type_id;
}

GType
font_manager_google_fonts_preview_pane_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_pane_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_pane_type_id__once)) {
		GType font_manager_google_fonts_preview_pane_type_id;
		font_manager_google_fonts_preview_pane_type_id = font_manager_google_fonts_preview_pane_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_pane_type_id__once, font_manager_google_fonts_preview_pane_type_id);
	}
	return font_manager_google_fonts_preview_pane_type_id__once;
}

static void
_vala_font_manager_google_fonts_preview_pane_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	switch (property_id) {
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_family (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_font (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_boolean (value, font_manager_google_fonts_preview_pane_get_refresh_required (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_boolean (value, font_manager_google_fonts_preview_pane_get_show_line_size (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_preview_size (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_min_waterfall_size (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_max_waterfall_size (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_preview (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_enum (value, font_manager_google_fonts_preview_pane_get_mode (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		g_value_set_string (value, font_manager_google_fonts_preview_pane_get_preview_text (self));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 4495 "PreviewPane.c"
		default:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 4501 "PreviewPane.c"
	}
}

static void
_vala_font_manager_google_fonts_preview_pane_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
	switch (property_id) {
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_family (self, g_value_get_object (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_font (self, g_value_get_object (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_refresh_required (self, g_value_get_boolean (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_show_line_size (self, g_value_get_boolean (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_preview_size (self, g_value_get_double (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_min_waterfall_size (self, g_value_get_double (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_max_waterfall_size (self, g_value_get_double (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (self, g_value_get_double (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_preview (self, g_value_get_object (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_mode (self, g_value_get_enum (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		font_manager_google_fonts_preview_pane_set_preview_text (self, g_value_get_string (value));
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 4581 "PreviewPane.c"
		default:
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 80 "../src/font-manager/web/google/PreviewPane.vala"
		break;
#line 4587 "PreviewPane.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

